'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  cursor:pointer;\n  width:100%;\n  position:relative;\n  min-height:180px;\n  display: flex;\n  align-items: left;\n  justify-content: center;\n  border-top-width: 0;\n  border-left-width: 0;\n  border-right-width: 0;\n  border-bottom-width: 5px;\n  border-style: solid;\n  border-color: ', ';\n  padding:24px;\n  flex-direction:column;\n  box-sizing:border-box;\n  &:hover svg {\n    fill: ', ' !important;\n  }\n  &:hover {\n    background: #f2f2f2;\n    border-color: ', ';\n  }\n  opacity: ', ';\n  pointer-events: ', ';\n'], ['\n  cursor:pointer;\n  width:100%;\n  position:relative;\n  min-height:180px;\n  display: flex;\n  align-items: left;\n  justify-content: center;\n  border-top-width: 0;\n  border-left-width: 0;\n  border-right-width: 0;\n  border-bottom-width: 5px;\n  border-style: solid;\n  border-color: ', ';\n  padding:24px;\n  flex-direction:column;\n  box-sizing:border-box;\n  &:hover svg {\n    fill: ', ' !important;\n  }\n  &:hover {\n    background: #f2f2f2;\n    border-color: ', ';\n  }\n  opacity: ', ';\n  pointer-events: ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  svg {\n    width: 60px !important;\n    height:60px !important;\n    fill: ', ' !important;\n  }\n'], ['\n  svg {\n    width: 60px !important;\n    height:60px !important;\n    fill: ', ' !important;\n  }\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  color: #2F2F32;\n  font-weight: 600;\n  font-size: 16px;\n  font-family: \'Open sans\', sans-serif;\n  margin-top:20px;\n  flex-grow: 99;\n  display: flex;\n  align-items: center;\n'], ['\n  color: #2F2F32;\n  font-weight: 600;\n  font-size: 16px;\n  font-family: \'Open sans\', sans-serif;\n  margin-top:20px;\n  flex-grow: 99;\n  display: flex;\n  align-items: center;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var getTypeColor = function getTypeColor(_ref, type) {
  var palette = _ref.palette;

  if (palette.semantic[type]) {
    return palette.semantic[type];
  }
  if (type === 'primary') {
    return palette.accent.main;
  }
  if (type === 'secondary') {
    return palette.primary.main;
  }
  return '#fff';
};

var getLightTypeColor = function getLightTypeColor(_ref2, type) {
  var palette = _ref2.palette;

  if (palette.semantic[type]) {
    return palette.semantic[type];
  }
  if (type === 'primary') {
    return palette.accent.light;
  }
  if (type === 'secondary') {
    return palette.primary.light;
  }
  return '#fff';
};

var ActionWrapper = _styledComponents2.default.div(_templateObject, function (_ref3) {
  var theme = _ref3.theme,
      type = _ref3.type;
  return type ? getTypeColor(theme, type) : theme.palette.lightGrey;
}, function (_ref4) {
  var theme = _ref4.theme,
      type = _ref4.type;
  return type ? getLightTypeColor(theme, type) : theme.palette.lightGrey;
}, function (_ref5) {
  var theme = _ref5.theme,
      type = _ref5.type;
  return type ? getLightTypeColor(theme, type) : theme.palette.lightGrey;
}, function (_ref6) {
  var disabled = _ref6.disabled;
  return disabled ? '0.4' : '1';
}, function (_ref7) {
  var disabled = _ref7.disabled;
  return disabled ? 'none' : 'auto';
});

var ActionIconWrapper = _styledComponents2.default.div(_templateObject2, function (_ref8) {
  var theme = _ref8.theme,
      type = _ref8.type;
  return type ? getTypeColor(theme, type) : theme.palette.lightGrey;
});

var ActionDisplayNameWrapper = _styledComponents2.default.div(_templateObject3);

var Action = function Action(_ref9) {
  var menuDescriptor = _ref9.menuDescriptor,
      disabled = _ref9.disabled,
      _ref9$type = _ref9.type,
      type = _ref9$type === undefined ? 'primary' : _ref9$type;
  return _react2.default.createElement(
    ActionWrapper,
    { onClick: menuDescriptor.onClick, disabled: disabled, type: type },
    _react2.default.createElement(
      ActionIconWrapper,
      { type: type },
      menuDescriptor.icon
    ),
    _react2.default.createElement(
      ActionDisplayNameWrapper,
      null,
      menuDescriptor.displayName
    )
  );
};

exports.default = Action;