'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  flex-flow: row;\n  height:100%;\n  flex-direction:column;\n'], ['\n  display: flex;\n  flex-flow: row;\n  height:100%;\n  flex-direction:column;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  position:absolute;\n  right: 8px;\n  top: 13px;\n  fill: #ccc;\n  svg {\n    fill: ', ';\n  }\n  &:hover svg {\n    fill: ', ';\n  }\n'], ['\n  position:absolute;\n  right: 8px;\n  top: 13px;\n  fill: #ccc;\n  svg {\n    fill: ', ';\n  }\n  &:hover svg {\n    fill: ', ';\n  }\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  padding:10px;\n  display: flex;\n  align-items: center;\n  box-sizing: border-box;\n  cursor: pointer;\n  color:#212121;\n  &:hover {\n    background: #f6f6f6;\n  }\n'], ['\n  padding:10px;\n  display: flex;\n  align-items: center;\n  box-sizing: border-box;\n  cursor: pointer;\n  color:#212121;\n  &:hover {\n    background: #f6f6f6;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Icons = require('../Icons');

var _Menu = require('../Menu');

var _MenuItem = require('../Menu/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _AvatarWithName = require('../Img/AvatarWithName');

var _AvatarWithName2 = _interopRequireDefault(_AvatarWithName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var MainMenuWrapper = _styledComponents2.default.div(_templateObject);

var DecoratedIcon = _styledComponents2.default.div(_templateObject2, function (_ref) {
  var isPromoted = _ref.isPromoted;
  return isPromoted ? 'rgb(0, 150, 136)' : '#ccc';
}, function (_ref2) {
  var isPromoted = _ref2.isPromoted;
  return !isPromoted ? 'rgb(0, 150, 136)' : '#d13f48';
});

var MenuButtonItemWithStyle = _styledComponents2.default.div(_templateObject3);

// eslint-disable-next-line react/prefer-stateless-function

var MenuButtonItem = function (_Component) {
  _inherits(MenuButtonItem, _Component);

  function MenuButtonItem() {
    _classCallCheck(this, MenuButtonItem);

    return _possibleConstructorReturn(this, (MenuButtonItem.__proto__ || Object.getPrototypeOf(MenuButtonItem)).apply(this, arguments));
  }

  _createClass(MenuButtonItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          onClick = _props.onClick,
          style = _props.style;


      return _react2.default.createElement(
        MenuButtonItemWithStyle,
        { onClick: onClick, style: style },
        children
      );
    }
  }]);

  return MenuButtonItem;
}(_react.Component);

var PromotedPersonalizedMenuItem = function PromotedPersonalizedMenuItem(_ref3) {
  var icon = _ref3.icon,
      displayName = _ref3.displayName,
      _onClick = _ref3.onClick,
      value = _ref3.value;

  var content = icon || displayName;

  return _react2.default.createElement(
    MenuButtonItem,
    { onClick: function onClick(e) {
        _onClick(e, value);
      } },
    content
  );
};

var PersonalizedMenuItem = function PersonalizedMenuItem(_ref4) {
  var icon = _ref4.icon,
      displayName = _ref4.displayName,
      _onClick2 = _ref4.onClick,
      isPromoted = _ref4.isPromoted,
      onFavoriteClick = _ref4.onFavoriteClick,
      withPeronalization = _ref4.withPeronalization,
      value = _ref4.value;

  var content = icon ? _react2.default.createElement(_AvatarWithName2.default, { icon: icon, name: displayName }) : _react2.default.createElement(
    'div',
    { style: { lineHeight: '26px' } },
    displayName
  );

  var menuPadding = withPeronalization ? '8px 30px 8px 18px' : '8px 18px';

  return _react2.default.createElement(
    _MenuItem2.default,
    { onClick: function onClick(e) {
        _onClick2(e, value);
      }, style: { padding: menuPadding, cursor: 'pointer', position: 'relative' } },
    content,
    withPeronalization && _react2.default.createElement(
      DecoratedIcon,
      {
        isPromoted: isPromoted,
        onClick: onFavoriteClick
      },
      _react2.default.createElement(_Icons.Followentities, { size: 16 })
    )
  );
};

var ActionMenu = function ActionMenu(props) {
  var _props$menuDescriptor = props.menuDescriptors,
      menuDescriptors = _props$menuDescriptor === undefined ? [] : _props$menuDescriptor,
      _onFavoriteClick = props.onFavoriteClick,
      withPeronalization = props.withPeronalization,
      value = props.value,
      _props$mainMenuButton = props.mainMenuButtonItemStyle,
      mainMenuButtonItemStyle = _props$mainMenuButton === undefined ? {} : _props$mainMenuButton;


  var promotedMenuDescriptorsWithIcon = menuDescriptors.filter(function (menuDescriptor) {
    return menuDescriptor.isPromoted && menuDescriptor.icon;
  });
  var promotedMenuDescriptorsNoIcon = menuDescriptors.filter(function (menuDescriptor) {
    return menuDescriptor.isPromoted && !menuDescriptor.icon;
  });

  var allMenu = withPeronalization ? menuDescriptors : menuDescriptors.filter(function (menuDescriptor) {
    return !menuDescriptor.isPromoted;
  });

  return _react2.default.createElement(
    MainMenuWrapper,
    null,
    _react2.default.createElement(
      'div',
      { style: { display: 'flex', flex: 1 } },
      promotedMenuDescriptorsNoIcon.map(function (promitedMenuDescriptor) {
        return _react2.default.createElement(PromotedPersonalizedMenuItem, _extends({}, promitedMenuDescriptor, { value: value }));
      }),
      promotedMenuDescriptorsWithIcon.map(function (promitedMenuDescriptor) {
        return _react2.default.createElement(PromotedPersonalizedMenuItem, _extends({}, promitedMenuDescriptor, { value: value }));
      }),
      allMenu && allMenu.length > 0 && _react2.default.createElement(
        _Menu.DropDownMenu,
        {
          button: _react2.default.createElement(
            MenuButtonItem,
            { style: mainMenuButtonItemStyle },
            _react2.default.createElement(_Icons.Options, null)
          ),
          anchor: 'right'
        },
        allMenu.map(function (menuDescriptor, i) {
          return _react2.default.createElement(PersonalizedMenuItem, _extends({
            key: i,
            withPeronalization: withPeronalization,
            onFavoriteClick: function onFavoriteClick(e) {
              e.stopPropagation();_onFavoriteClick(menuDescriptor.key);
            }
          }, menuDescriptor, {
            value: value
          }));
        })
      )
    )
  );
};

exports.default = ActionMenu;