'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ActionMenu = require('./ActionMenu');

var _ActionMenu2 = _interopRequireDefault(_ActionMenu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PeronalizationMenu = function (_Component) {
  _inherits(PeronalizationMenu, _Component);

  function PeronalizationMenu(props) {
    _classCallCheck(this, PeronalizationMenu);

    var _this = _possibleConstructorReturn(this, (PeronalizationMenu.__proto__ || Object.getPrototypeOf(PeronalizationMenu)).call(this, props));

    _this.state = {
      favorites: (props.menuDescriptors || []).filter(function (m) {
        return m.isPromoted;
      }).map(function (m) {
        return m.key;
      })
    };
    return _this;
  }

  _createClass(PeronalizationMenu, [{
    key: 'onFavoriteClick',
    value: function onFavoriteClick(key) {
      var hasKey = this.state.favorites.find(function (k) {
        return k === key;
      });
      var newFavorites = [];

      if (hasKey) {
        newFavorites = this.state.favorites.filter(function (k) {
          return k !== key;
        });
      } else {
        newFavorites = [key].concat(_toConsumableArray(this.state.favorites));
      }

      this.setState({
        favorites: newFavorites
      });
    }
  }, {
    key: 'getFavorites',
    value: function getFavorites(menuDescriptors) {
      var favorites = this.state.favorites;


      return menuDescriptors.map(function (m) {
        var hasFound = favorites.find(function (f) {
          return f === m.key;
        });
        return _extends({}, m, {
          isPromoted: hasFound
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var menuDescriptors = this.props.menuDescriptors;

      var menuDescriptorsWithFavorites = this.getFavorites(menuDescriptors);

      return _react2.default.createElement(_ActionMenu2.default, _extends({}, this.props, {
        menuDescriptors: menuDescriptorsWithFavorites,
        withPeronalization: true,
        onFavoriteClick: this.onFavoriteClick.bind(this)
      }));
    }
  }]);

  return PeronalizationMenu;
}(_react.Component);

exports.default = PeronalizationMenu;