'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  border-radius: ', ';\n  overflow: hidden;\n  ', ';\n  cursor: normal;\n  div {\n    a, a:hover {\n      color: white;\n      text-decoration: underline;\n    }\n  }\n'], ['\n  border-radius: ', ';\n  overflow: hidden;\n  ', ';\n  cursor: normal;\n  div {\n    a, a:hover {\n      color: white;\n      text-decoration: underline;\n    }\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Icons = require('../Icons');

var _Alert = require('./Alert.style');

var _Alert2 = _interopRequireDefault(_Alert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var AlertUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var rounded = _ref.rounded,
      radius = _ref.theme.radius;
  return rounded ? radius : 0;
}, function (_ref2) {
  var isFullWidth = _ref2.isFullWidth;
  return isFullWidth ? 'width: 100%;' : '';
});

var Alert = function (_Component) {
  _inherits(Alert, _Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, (Alert.__proto__ || Object.getPrototypeOf(Alert)).call(this, props));

    _this.state = {
      isOpen: true
    };
    _this.close = _this.close.bind(_this);
    _this.isControlled = !!_this.props.onClose;
    return _this;
  }

  /**
   * Close the Alert message when the property showClose is set to 'true'
   */


  _createClass(Alert, [{
    key: 'close',
    value: function close(event) {
      var onClose = this.props.onClose;

      if (onClose) {
        onClose(event, this.state.isOpen);
      }
      if (!this.isControlled) {
        this.setState({ isOpen: false });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          type = _props.type,
          showClose = _props.showClose,
          hideClose = _props.hideClose,
          noIcon = _props.noIcon,
          className = _props.className,
          isBanner = _props.isBanner,
          iconSize = _props.iconSize,
          onClose = _props.onClose,
          style = _props.style,
          rounded = _props.rounded,
          isFullWidth = _props.isFullWidth;
      var isOpen = this.state.isOpen;


      var wrapperStyles = _extends({}, _Alert2.default.alert);

      if (isBanner) {
        wrapperStyles = _extends({}, wrapperStyles, _Alert2.default.bannerAlert);
      }

      var closeContent = void 0;
      var iconContent = void 0;
      var IconComp = void 0;
      var mainAlertStyle = _extends({}, _Alert2.default.alertContent);
      if ((showClose || onClose || isBanner) && !hideClose) {
        closeContent = _react2.default.createElement(
          'button',
          { key: 'closeIcon', onClick: this.close, style: _Alert2.default.closeWrapper },
          _react2.default.createElement(_Icons.Close, { color: 'white' })
        );
        mainAlertStyle = _extends({}, mainAlertStyle, {
          marginRight: '50px'
        });
      }

      if (type === 'danger' || type === 'error') {
        wrapperStyles = _extends({}, wrapperStyles, _Alert2.default.danger);
        IconComp = _Icons.Issue;
      } else if (type === 'warning') {
        wrapperStyles = _extends({}, wrapperStyles, _Alert2.default.warning);
        IconComp = _Icons.Alert;
      } else if (type === 'success') {
        wrapperStyles = _extends({}, wrapperStyles, _Alert2.default.success);
        IconComp = _Icons.Done;
      } else {
        wrapperStyles = _extends({}, wrapperStyles, _Alert2.default.info);
        IconComp = _Icons.Alert;
      }

      if (!noIcon) {
        iconContent = _react2.default.createElement(IconComp, { color: 'white', style: _Alert2.default.icon, size: iconSize });
      }

      if (!isOpen) {
        wrapperStyles = _extends({}, wrapperStyles, { display: 'none' });
      }

      wrapperStyles = _extends({}, wrapperStyles, style);

      return _react2.default.createElement(
        AlertUI,
        { isFullWidth: isFullWidth, rounded: rounded || undefined },
        _react2.default.createElement(
          'div',
          { style: wrapperStyles, className: className },
          closeContent,
          iconContent,
          _react2.default.createElement(
            'div',
            { style: mainAlertStyle },
            this.props.children
          )
        )
      );
    }
  }]);

  return Alert;
}(_react.Component);

Alert.propTypes = {
  children: _propTypes2.default.node,
  showClose: _propTypes2.default.bool, // weird ?
  hideClose: _propTypes2.default.bool, // weird ?
  onClose: _propTypes2.default.func, // eslint-disable-line
  type: _propTypes2.default.oneOf(['danger', 'error', 'success', 'warning', 'information']),
  noIcon: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  isBanner: _propTypes2.default.bool,
  iconSize: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  rounded: _propTypes2.default.bool,
  isFullWidth: _propTypes2.default.bool
};
Alert.defaultProps = {
  type: 'information',
  showClose: undefined,
  // onClose: undefined,
  hideClose: undefined,
  className: '',
  noIcon: false,
  isBanner: false,
  iconSize: 24, // uxi default, src of thruth => SvgIcon
  // onClose: undefined,
  // in case some text is not evaluated, the comp might appear like it has no children (text node)
  children: null, // we don't require children, alert always has at least 50px of height
  style: {},
  rounded: false,
  isFullWidth: false
};


Alert.defaultProps = {};

exports.default = Alert;