'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  font-weight: 600;\n  background: #fff9d6;\n'], ['\n  font-weight: 600;\n  background: #fff9d6;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  white-space: nowrap;\n'], ['\n  white-space: nowrap;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Input = require('../Input');

var _Menu = require('../Menu');

var _Layout = require('../Layout');

var _ThemeComponent2 = require('../Base/ThemeComponent');

var _ThemeComponent3 = _interopRequireDefault(_ThemeComponent2);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Highlighted = _styledComponents2.default.span(_templateObject);

var AutoCompleteStyle = {
  boxShadow: 'rgba(0, 0, 0, 0.16) 0px 2px 5px 0px, rgba(0, 0, 0, 0.12) 0px 2px 10px 0px',
  popover: {
    position: 'absolute',
    top: '30px',
    maxHeight: '60vh',
    overflowY: 'scroll',
    border: '1px solid #ccc',
    left: 0,
    right: 0,
    margin: 0,
    padding: 0,
    zIndex: 2,
    background: 'white'
  }
};

var MatchesPart = _styledComponents2.default.span(_templateObject2);

var getHighlightedNameComplex = function getHighlightedNameComplex(item, valueForInputParam, postFix /* , filterOn */) {
  // const nameToRenderParam = item[filterOn];
  var matchesNode = (item.matchesResults || []).map(function (_ref) {
    var matches = _ref.matches,
        string = _ref.string;
    return matches ? _react2.default.createElement(
      MatchesPart,
      { 'data-matches': true },
      _react2.default.createElement(Highlighted, { dangerouslySetInnerHTML: { __html: '' + string.replace(/\s/, '&nbsp;') } })
    ) : _react2.default.createElement(MatchesPart, {
      'data-not-matches': true,
      dangerouslySetInnerHTML: { __html: '' + string.replace(/\s/, '&nbsp;') }
    });
  });

  return _react2.default.createElement(
    _Layout.Flex,
    { style: { justifyContent: 'flex-start', width: '100%' } },
    _react2.default.createElement(
      'div',
      { style: { overflow: 'hidden', textOverflow: 'ellipsis' } },
      matchesNode
    ),
    _react2.default.createElement(
      'span',
      { 'data-postFix': true, style: { margin: '0 6px', marginLeft: 'auto' } },
      postFix
    )
  );
};

// const recomposeStringValueReducer = (accu = '', { string }) => {
//   if (!accu || typeof accu !== 'string') { accu = string; }
//   return (accu += string);
// };

/* eslint-disable react/jsx-no-bind */
/** @deprecated  */

var AutoComplete = function (_ThemeComponent) {
  _inherits(AutoComplete, _ThemeComponent);

  function AutoComplete(props) {
    _classCallCheck(this, AutoComplete);

    var _this = _possibleConstructorReturn(this, (AutoComplete.__proto__ || Object.getPrototypeOf(AutoComplete)).call(this, props));

    _this.state = {
      index: -1,
      value: props.defaultValue,
      originalItems: _this.props.items.map(function (x, i) {
        return _extends({}, x, {
          originalIndex: i
        });
      }) || [],
      filteredSet: []
    };

    _this.onQuerychangeDebounced = (0, _debounce2.default)(_this.onQuerychange, 100);
    _this.onChangeWrap = _this.onChangeWrap.bind(_this);
    return _this;
  }

  _createClass(AutoComplete, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('click', this.clickHandlerForDom.bind(this), true);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.items.length !== nextProps.items.length) {
        this.setState({
          originalItems: this.props.items.map(function (x, i) {
            return _extends({}, x, {
              originalIndex: i
            });
          }) || []
        });
      }

      if (this.props.defaultValue !== nextProps.defaultValue) {
        this.setState({
          valueForInput: nextProps.defaultValue
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.clickHandlerForDom);
    }
  }, {
    key: 'onItemClick',
    value: function onItemClick(index) {
      var filteredSet = this.state.filteredSet;


      var originalValue = filteredSet[index];

      this.onEnter(originalValue.matchesResults
      // eslint-disable-next-line no-return-assign
      .reduce(function () {
        var accu = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
        var _ref2 = arguments[1];
        var string = _ref2.string;
        return accu += string;
      }, ''), // eslint-disable-line no-param-reassign
      originalValue);
      this.setState({ index: -1, escape: true });
    }
  }, {
    key: 'clickHandlerForDom',
    value: function clickHandlerForDom(e) {
      var domNode = this.node;
      if (!domNode || !domNode.contains(e.target)) {
        this.setState({ index: -1, escape: true });
      }
    }
  }, {
    key: 'onQuerychange',
    value: function onQuerychange(value) {
      var onchange = this.props.onchange;


      this.setState({
        valueForInput: value
      });

      var consumerNotifierCallback = function consumerNotifierCallback() {
        return onchange && onchange(value);
      };

      this.asyncUpdateFilteredSet(consumerNotifierCallback);
    }
  }, {
    key: 'onChangeWrap',
    value: function onChangeWrap(e) {
      var value = e.target.value;
      this.setState({ valueForInput: value });

      this.onQuerychangeDebounced(value);
    }
  }, {
    key: 'handleMouseEnterList',
    value: function handleMouseEnterList() {
      this.setState({ index: -1 });
    }
  }, {
    key: 'handleMouseLeaveList',
    value: function handleMouseLeaveList() {
      this.setState({ index: -1 });
    }
  }, {
    key: 'handleMouseEnterListItem',
    value: function handleMouseEnterListItem() {
      this.setState({ index: -1 });
    }
  }, {
    key: 'handleMouseLeaveListItem',
    value: function handleMouseLeaveListItem() {
      this.setState({ index: -1 });
    }
  }, {
    key: 'onEnter',
    value: function onEnter(value, originalValue) {
      // const { filteredSet, index } = this.state;
      var onChange = this.props.onChange;

      // const originalValue = filteredSet[index];

      this.setState({
        valueForInput: value
      });

      if (onChange) {
        onChange({
          value: value,
          originalValue: originalValue
        });
      }
    }
  }, {
    key: 'updateSearchValue',
    value: function updateSearchValue(e) {
      // const { items } = this.props;
      var _state = this.state,
          index = _state.index,
          valueForInput = _state.valueForInput,
          filteredSet = _state.filteredSet;


      if (e.key === 'Enter') {
        if (index < 0) {
          this.onEnter(valueForInput || '', true);
        } else {
          this.onEnter(filteredSet[index].matchesResults
          // eslint-disable-next-line no-return-assign
          .reduce(function () {
            var accu = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
            var _ref3 = arguments[1];
            var string = _ref3.string;
            return accu += string;
          }, ''), // eslint-disable-line no-param-reassign
          filteredSet[index]);
        }
        this.setState({ index: -1, escape: true });
      } else if (e.key === 'Escape') {
        this.setState({ index: -1, escape: true });
      } else if (e.key === 'ArrowDown') {
        if (this.state.index === filteredSet.length) {
          this.setState({ index: 0, escape: false });
        } else {
          this.setState({ index: this.state.index + 1, escape: false });
        }
      } else if (e.key === 'ArrowUp') {
        if (this.state.index >= 0) {
          this.setState({ index: this.state.index - 1, escape: false });
        }
      } else {
        this.setState({ index: -1, escape: false });
      }
    }
  }, {
    key: 'asyncUpdateFilteredSet',
    value: function asyncUpdateFilteredSet(consumerNotifierCallback) {
      var _this2 = this;

      // eslint-disable-line class-methods-use-this
      var _props = this.props,
          items = _props.items,
          defaultValue = _props.defaultValue,
          filterOn = _props.filterOn,
          strict = _props.strict;
      var valueForInput = this.state.valueForInput;


      if (valueForInput && valueForInput.length >= 2) {
        new Promise(function (resolve /* , reject */) {
          var filterFnStrict = function filterFnStrict(item) {
            return item[filterOn].toLowerCase().replace(/\s/g, '').indexOf((valueForInput || defaultValue || '').toLowerCase().replace(/\s/g, '')) > -1;
          };

          var matchMapper = function matchMapper(item) {
            return _extends({}, item, {
              matchesResults: (0, _utils.getMatchesResult)(item[filterOn], valueForInput || defaultValue || '')
            });
          };

          var filterFnPermissive = function filterFnPermissive(mappedMatch) {
            var isMatch = mappedMatch.matchesResults.some(function (x) {
              return x.matches;
            });
            return isMatch;
          };

          var mappedUNfilteredSet = items && items.map(matchMapper) || [];

          var filteredSet = mappedUNfilteredSet.filter(strict ? filterFnStrict : filterFnPermissive);

          var filteredSetWithScore = (0, _utils.getFilteredSetWithScore)(filteredSet);

          var finalSortedResult = filteredSetWithScore.sort(function (a, b) {
            if (a.scrore > b.scrore) {
              return -1;
            }
            if (a.scrore < b.scrore) {
              return 1;
            }
            return 0;
          });
          resolve(finalSortedResult);
        }).then(function (filteredSet) {
          return _this2.setState({
            filteredSet: filteredSet
          }, consumerNotifierCallback);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          placeholder = _props2.placeholder,
          filterOn = _props2.filterOn,
          resultLimit = _props2.resultLimit;
      var _state2 = this.state,
          index = _state2.index,
          escape = _state2.escape,
          valueForInput = _state2.valueForInput,
          filteredSet = _state2.filteredSet;


      var shadowStyle = _extends({}, filteredSet.length && filteredSet.length > 0 ? { boxShadow: AutoCompleteStyle.boxShadow } : {}, filteredSet.length && filteredSet.length > 0 ? { boxShadow: AutoCompleteStyle.boxShadow } : {});

      var autoComplete = !escape && valueForInput && filteredSet.length ? _react2.default.createElement(
        _Menu.VerticalMenu,
        {
          style: _extends({}, AutoCompleteStyle.popover, shadowStyle),
          ref: function ref(_ref4) {
            _this3.autoComplete = _ref4;
          },
          onMouseOver: this.handleMouseEnterList.bind(this),
          onMouseOut: this.handleMouseLeaveList.bind(this)
        },
        filteredSet
        // more than a hundreds search results is not
        // actually helpfull anyway, neither is it reasonnable to ask that to the dom
        // let's cut it at 10
        .slice(0, resultLimit).map(function (item, currentIndex) {
          var postFix = item.postFix;

          // const nameToRender = item[filterOn] || item.name;

          var nameToRenderWithHightlight = getHighlightedNameComplex(item, valueForInput, postFix, filterOn);

          // const selectedClass = '';
          var liStyle = {};
          if (index === currentIndex) {
            liStyle = Object.assign({}, {
              color: _this3.context.uxiTheme.palette.accent.main,
              background: 'rgb(233,245,244)'
            });
          } else {
            liStyle = {};
          }

          return _react2.default.createElement(
            _Menu.MenuItem,
            {
              key: currentIndex,
              onClick: _this3.onItemClick.bind(_this3, currentIndex),
              style: liStyle,
              onMouseOver: _this3.handleMouseEnterListItem.bind(_this3),
              onMouseOut: _this3.handleMouseLeaveListItem.bind(_this3)
            },
            nameToRenderWithHightlight
          );
        }),
        filteredSet.length > 20 ? _react2.default.createElement(
          _Menu.MenuItem,
          {
            key: 'not-currentIndex',
            onClick: function onClick() {}
            // onMouseOver={this.handleMouseEnterListItem.bind(this)}
            // onMouseOut={this.handleMouseLeaveListItem.bind(this)}
            , style: {
              textAlign: 'center', opacity: 0.8
            }
          },
          'Some results were omitted, try a more specific query'
        ) : null,
        valueForInput && filteredSet.length === 0 ? _react2.default.createElement(
          _Menu.MenuItem,
          {
            key: 'not-currentIndex-no-results',
            onClick: function onClick() {},
            style: {
              textAlign: 'center', opacity: 0.8
            }
          },
          'no match found'
        ) : null
      ) : null;

      return _react2.default.createElement(
        'div',
        {
          style: { position: 'relative' },
          ref: function ref(node) {
            _this3.node = node;
          },
          onKeyUp: this.updateSearchValue.bind(this)
        },
        _react2.default.createElement(_Input.TextField, {
          style: { zIndex: 3 },
          placeholder: placeholder,
          ref: function ref(_ref5) {
            _this3.currentInput = _ref5;
          },
          onChange: this.onChangeWrap,
          value: this.state.valueForInput || '',
          type: 'text'
        }),
        autoComplete
      );
    }
  }]);

  return AutoComplete;
}(_ThemeComponent3.default);

AutoComplete.defaultProps = {
  items: [],
  placeholder: 'Type to search...',
  strict: false,
  resultLimit: 20
};

exports.default = AutoComplete;