"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.getFilteredSetWithScore = getFilteredSetWithScore;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/*
Q: fernd
A:
[
  { matches: true, string: 'Fern' }, // !! watch out for the caps
  { matches: false, string: '&nbsp' },
  { matches: true, string: 'D' }, // !! watch out for the caps
  { matches: false, string: 'awson' },
]
*/

var getMatchesResult = exports.getMatchesResult = function getMatchesResult(source, target) {
  // shorcut in case of perfect match
  if (source.toLowerCase().indexOf(target.toLowerCase()) === 0) {
    // ! perfect match, from the start worth a 100
    return [{ matches: true, string: source.slice(0, target.length) }, { matches: false, string: source.slice(target.length) }];
  }

  // shorcut in case of perfect match
  if (source.toLowerCase().indexOf(target.toLowerCase()) > -1) {
    // ! perfect match, from the middle worth a plenty
    var idx = source.toLowerCase().indexOf(target.toLowerCase());

    return [{ matches: false, string: source.slice(0, idx) }, { matches: true, string: source.slice(idx, idx + target.length) }, { matches: false, string: source.slice(idx + target.length) }];
  }

  var result = [];

  // this can probalby be refactored into a nice looking map + reducer:
  var i = 0;
  var j = 0;
  while (i < source.length) {
    var sourceChar = source[i];
    var targetChar = target[j];

    var currentRunMatchObj = {
      matches: false,
      string: sourceChar
    };

    if (sourceChar.toLowerCase() === (targetChar && targetChar.toLowerCase())) {
      currentRunMatchObj.matches = true;
      result.push(currentRunMatchObj);
      j++; // eslint-disable-line no-plusplus
    } else {
      result.push(currentRunMatchObj);
      currentRunMatchObj = {
        matches: false,
        string: sourceChar
      };
    }
    i++; // eslint-disable-line no-plusplus
  }

  var initialAccu = {
    isCurrentlyMatching: result[0].matches,
    result: [{
      matches: result[0].matches,
      string: result[0].string
    }]
  };

  var finalResult = result.reduce(function (accu, x, i) {
    // eslint-disable-line no-shadow
    if (i === 0) {
      return accu;
    }

    // const currentItem = accu.result[accu.result.length - 1];

    if (x.matches === accu.isCurrentlyMatching) {
      if (i === 0) {
        accu.result[0] = x.string; // eslint-disable-line no-param-reassign
      } else {
        // eslint-disable-next-line no-param-reassign
        accu.result[accu.result.length - 1].string += x.string;
      }
      return accu;
    }
    return {
      isCurrentlyMatching: x.matches,
      result: [].concat(_toConsumableArray(accu.result), [_extends({}, x)])
    };
  }, initialAccu);

  return finalResult.result;
};

var addScore = function addScore(accu, _ref) {
  var string = _ref.string,
      matches = _ref.matches;

  if (matches) {
    return string.length > accu ? string.length : accu;
  }
  return accu;
};

function getFilteredSetWithScore(filteredSet) {
  var filteredSetWithScore = filteredSet.map(function (x) {
    return _extends({}, x, {
      scrore: x.matchesResults.reduce(addScore, 0)
    });
  });

  return filteredSetWithScore;
}