'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  svg * {\n    ', ';\n  }\n'], ['\n  svg * {\n    ', ';\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var BadgeStyle = {
  badge: {
    margin: 0,
    boxSizing: 'border-box',
    position: 'relative',
    padding: '0.4em 0.3em',
    fontSize: '12px',
    lineHeight: '1',
    color: '#fff',
    textAlign: 'center',
    whiteSpace: 'nowrap',
    verticalAlign: 'baseline',
    borderRadius: '0.25em',
    display: 'inline-block'
  },
  info: {
    color: '#fff',
    backgroundColor: 'rgb(49, 112, 143)',
    borderColor: 'rgb(49, 112, 143)'
  },
  error: {
    backgroundColor: '#F44336',
    color: '#fff'
  },
  warning: {
    backgroundColor: '#FF9800',
    color: '#fff'
  },
  success: {
    backgroundColor: '#009688',
    color: '#fff'
  },
  default: {
    backgroundColor: '#cecece',
    color: '#3a3a3a'
  }
};
/* eslint-disable indent */
var BadgeUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var type = _ref.type;
  return BadgeStyle[type] && BadgeStyle[type].color && 'fill: ' + BadgeStyle[type].color;
});
/* eslint-enbale indent */

/* eslint-disable react/prefer-stateless-function */

var Badge = function (_Component) {
  _inherits(Badge, _Component);

  function Badge() {
    _classCallCheck(this, Badge);

    return _possibleConstructorReturn(this, (Badge.__proto__ || Object.getPrototypeOf(Badge)).apply(this, arguments));
  }

  _createClass(Badge, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          type = _props.type,
          style = _props.style;

      var mergedStyle = Object.assign({}, BadgeStyle.badge, style);
      // const classNames = [mergedStyle];

      if (type === 'error') {
        mergedStyle = _extends({}, mergedStyle, BadgeStyle.error);
      } else if (type === 'warning') {
        mergedStyle = _extends({}, mergedStyle, BadgeStyle.warning);
      } else if (type === 'success') {
        mergedStyle = _extends({}, mergedStyle, BadgeStyle.success);
      } else if (type === 'info') {
        mergedStyle = _extends({}, mergedStyle, BadgeStyle.info);
      } else {
        mergedStyle = _extends({}, mergedStyle, BadgeStyle.default);
      }

      return _react2.default.createElement(
        BadgeUI,
        { style: mergedStyle, type: type },
        this.props.children
      );
    }
  }]);

  return Badge;
}(_react.Component);

Badge.propTypes = {
  /**
   * The Alert will be added relativelty to this node.
   */
  children: _propTypes2.default.node,
  style: _propTypes2.default.object,
  type: _propTypes2.default.oneOf(['error', 'success', 'warning', 'info', 'default'])
  // rounded: PropTypes.bool,
};
Badge.defaultProps = {
  type: 'default',
  children: null,
  style: {}
  // rounded: false,
};
exports.default = Badge;