'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// call context uxiTheme
// check theme component to see it uses the good one this.context.uxiTheme

/**
 * TODO: Some of thos compos still use context or import the theme directly, fix it
 */
var ThemeComponent = function (_Component) {
  _inherits(ThemeComponent, _Component);

  function ThemeComponent() {
    _classCallCheck(this, ThemeComponent);

    return _possibleConstructorReturn(this, (ThemeComponent.__proto__ || Object.getPrototypeOf(ThemeComponent)).apply(this, arguments));
  }

  _createClass(ThemeComponent, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isDarkThemeFromTheme: this.isDarkThemeFromTheme.bind(this)
      };
    }
  }, {
    key: 'getSubStylePseudoElement',
    value: function getSubStylePseudoElement(name, subStyleName, pseudoElementName) {
      var theme = this.context.uxiTheme;
      var result = {};

      result[':' + pseudoElementName] = theme[name + ':' + subStyleName + ':' + pseudoElementName] || {};

      return result;
    }
  }, {
    key: 'getPseudoElement',
    value: function getPseudoElement(name, pseudoElement) {
      var theme = this.context.uxiTheme;
      var result = {};
      var pseudoElementStyle = theme[name + ':' + pseudoElement] || {};

      result[':' + pseudoElement] = pseudoElementStyle;

      return result;
    }
  }, {
    key: 'getSubStyle',
    value: function getSubStyle(name, subStyleName) {
      var stylesFromComponent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      var theme = this.context.uxiTheme;
      var themeForComponent = theme[name + ':' + subStyleName] || {};

      return Object.assign({}, themeForComponent, stylesFromComponent);
    }
  }, {
    key: 'getStyle',
    value: function getStyle(name) {
      var stylesFromComponent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _props = this.props,
          style = _props.style,
          fromParentStyle = _props.fromParentStyle;

      var theme = this.context.uxiTheme;
      var themeForComponent = theme[name] || {};

      return Object.assign({}, themeForComponent, stylesFromComponent, fromParentStyle || {}, style || {});
    }
  }, {
    key: 'isDarkThemeFromTheme',
    value: function isDarkThemeFromTheme() {
      var isDark = this.props.isDark;

      var isDarkFromRoot = this.context.isDarkTheme();
      var isDarkFromTheme = this.context.isDarkThemeFromTheme ? this.context.isDarkThemeFromTheme() : false;

      return isDark || isDarkFromRoot || isDarkFromTheme;
    }
  }]);

  return ThemeComponent;
}(_react.Component);

ThemeComponent.contextTypes = {
  uxiTheme: _propTypes2.default.object.isRequired,
  isFixedWidth: _propTypes2.default.func,
  isDarkTheme: _propTypes2.default.func.isRequired,
  isDarkThemeFromTheme: _propTypes2.default.func
};
ThemeComponent.childContextTypes = {
  isDarkThemeFromTheme: _propTypes2.default.func
};
exports.default = ThemeComponent;