'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Theme = require('../Theme');

var _IsDarkComponent2 = require('../Base/IsDarkComponent');

var _IsDarkComponent3 = _interopRequireDefault(_IsDarkComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Box = function (_IsDarkComponent) {
  _inherits(Box, _IsDarkComponent);

  function Box() {
    _classCallCheck(this, Box);

    return _possibleConstructorReturn(this, (Box.__proto__ || Object.getPrototypeOf(Box)).apply(this, arguments));
  }

  _createClass(Box, [{
    key: 'getMargin',
    value: function getMargin() {
      var margin = this.props.margin;


      if (!margin) {
        return {};
      }

      if (margin.toLowerCase() === 'xs') {
        return {
          margin: '5px'
        };
      }

      if (margin.toLowerCase() === 's') {
        return {
          margin: '15px'
        };
      }

      if (margin.toLowerCase() === 'm') {
        return {
          margin: '30px'
        };
      }

      if (margin.toLowerCase() === 'l') {
        return {
          margin: '60px'
        };
      }

      return {};
    }
  }, {
    key: 'getPadding',
    value: function getPadding() {
      var padding = this.props.padding;


      if (!padding) {
        return {};
      }

      if (padding.toLowerCase() === 'xs') {
        return {
          padding: '5px'
        };
      }

      if (padding.toLowerCase() === 's') {
        return {
          padding: '15px'
        };
      }

      if (padding.toLowerCase() === 'm') {
        return {
          padding: '30px'
        };
      }

      if (padding.toLowerCase() === 'l') {
        return {
          padding: '60px'
        };
      }

      return {};
    }
  }, {
    key: 'getStyle',
    value: function getStyle() {
      var stylesFromComponent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var style = this.props.style;


      return Object.assign({}, style || {}, this.getPadding(), this.getMargin(), stylesFromComponent);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          hasBorder = _props.hasBorder,
          children = _props.children,
          isDark = _props.isDark,
          style = _props.style;

      var borderStyle = hasBorder ? {
        border: _Theme.theme.border.default,
        borderRadius: '2px',
        background: isDark ? _Theme.theme.background.dark : _Theme.theme.background.light
      } : {};

      return _react2.default.createElement(
        'div',
        { style: _extends({}, this.getStyle(borderStyle), style) },
        children
      );
    }
  }]);

  return Box;
}(_IsDarkComponent3.default);

Box.propTypes = {
  margin: _propTypes2.default.oneOf(['xs', 's', 'm', 'l', 'XS', 'S', 'M', 'L']),
  padding: _propTypes2.default.oneOf(['xs', 's', 'm', 'l', 'XS', 'S', 'M', 'L']),
  style: _propTypes2.default.object
};

exports.default = Box;