'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CollapsibleBox = require('./CollapsibleBox.style');

var _CollapsibleBox2 = _interopRequireDefault(_CollapsibleBox);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

var _Text = require('../Text');

var _Text2 = _interopRequireDefault(_Text);

var _IconButton = require('../Button/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _ThemeComponent2 = require('../Base/ThemeComponent');

var _ThemeComponent3 = _interopRequireDefault(_ThemeComponent2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CollapsibleBox = function (_ThemeComponent) {
  _inherits(CollapsibleBox, _ThemeComponent);

  function CollapsibleBox(props) {
    _classCallCheck(this, CollapsibleBox);

    var _this = _possibleConstructorReturn(this, (CollapsibleBox.__proto__ || Object.getPrototypeOf(CollapsibleBox)).call(this, props));

    _this.state = {
      isOpen: props.isOpen
    };
    return _this;
  }

  _createClass(CollapsibleBox, [{
    key: 'toggle',
    value: function toggle() {
      this.setState({
        isOpen: !this.state.isOpen
      });
    }
  }, {
    key: 'getMargin',
    value: function getMargin() {
      var margin = this.props.margin;


      if (!margin) {
        return {};
      }

      if (margin.toLowerCase() === 'xs') {
        return {
          margin: '5px'
        };
      }

      if (margin.toLowerCase() === 's') {
        return {
          margin: '15px'
        };
      }

      if (margin.toLowerCase() === 'm') {
        return {
          margin: '30px'
        };
      }

      if (margin.toLowerCase() === 'l') {
        return {
          margin: '60px'
        };
      }

      return {};
    }
  }, {
    key: 'getPadding',
    value: function getPadding() {
      var padding = this.props.padding;


      if (!padding) {
        return {};
      }

      if (padding.toLowerCase() === 'xs') {
        return {
          padding: '5px'
        };
      }

      if (padding.toLowerCase() === 's') {
        return {
          padding: '15px'
        };
      }

      if (padding.toLowerCase() === 'm') {
        return {
          padding: '30px'
        };
      }

      if (padding.toLowerCase() === 'l') {
        return {
          padding: '60px'
        };
      }

      return {};
    }
  }, {
    key: 'getStyle',
    value: function getStyle() {
      var stylesFromComponent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var style = this.props.style;


      return Object.assign({}, style || {}, _CollapsibleBox2.default.wrapper, this.getPadding(), this.getMargin(), stylesFromComponent);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          title = _props.title;


      var expandIcon = this.state.isOpen ? _react2.default.createElement(_IconButton2.default, { style: { width: '14px' }, color: this.context.uxiTheme.palette.accent.main, size: 'S', icon: 'Arrowdown' }) : _react2.default.createElement(_IconButton2.default, { style: { width: '14px' }, color: this.context.uxiTheme.palette.accent.main, size: 'S', icon: 'Arrowup' });

      var header = _react2.default.createElement(
        'ul',
        { role: 'menu', style: _CollapsibleBox2.default.header, onClick: function onClick() {
            _this2.toggle();
          } },
        _react2.default.createElement(
          'div',
          { style: { flex: 1 } },
          _react2.default.createElement(
            _Text2.default,
            { type: 'heading' },
            title
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { textAlign: 'right' } },
          expandIcon
        )
      );

      var containerStyle = _CollapsibleBox2.default.container;

      if (!this.state.isOpen) {
        containerStyle = _extends({}, containerStyle, { maxHeight: 0 });
      }

      return (
        // <div style={CollapsibleBoxStyle.wrapper}>
        _react2.default.createElement(
          'div',
          { style: this.getStyle() },
          header,
          _react2.default.createElement(
            'div',
            { style: containerStyle },
            children
          )
        )
      );
    }
  }]);

  return CollapsibleBox;
}(_ThemeComponent3.default);

exports.default = CollapsibleBox;