'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ThemeComponent2 = require('../Base/ThemeComponent');

var _ThemeComponent3 = _interopRequireDefault(_ThemeComponent2);

var _ThemedBox = require('./ThemedBox.style');

var _ThemedBox2 = _interopRequireDefault(_ThemedBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ThemeBox = function (_ThemeComponent) {
  _inherits(ThemeBox, _ThemeComponent);

  function ThemeBox() {
    _classCallCheck(this, ThemeBox);

    return _possibleConstructorReturn(this, (ThemeBox.__proto__ || Object.getPrototypeOf(ThemeBox)).apply(this, arguments));
  }

  _createClass(ThemeBox, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;

      var isDark = this.isDarkThemeFromTheme();

      var globalHeaderMergedStyle = this.getStyle('GlobalHeader', {});

      var mergedStyle = Object.assign({}, globalHeaderMergedStyle, _extends({
        paddingLeft: this.context.uxiTheme.padding.breathPadding,
        paddingRight: this.context.uxiTheme.padding.breathPadding,
        height: this.context.uxiTheme.dimensions.mainHeaderHeight
      }, this.context.uxiTheme.fontsAndColor.fontsAndColor), isDark ? _ThemedBox2.default.dark : _ThemedBox2.default.light);

      return _react2.default.createElement(
        'div',
        { style: mergedStyle },
        children
      );
    }
  }]);

  return ThemeBox;
}(_ThemeComponent3.default);

exports.default = ThemeBox;