'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ButtonComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Indicator = require('../Indicator');

var _Ripples = require('../Motion/Ripples');

var _Ripples2 = _interopRequireDefault(_Ripples);

var _ButtonIconWrapper = require('./ButtonIconWrapper');

var _ButtonContentWrapper = require('./ButtonContentWrapper');

var _Buttons = require('./Buttons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// eslint-disable-next-line
var ButtonComponent = exports.ButtonComponent = function (_Component) {
  _inherits(ButtonComponent, _Component);

  function ButtonComponent(props) {
    _classCallCheck(this, ButtonComponent);

    var _this = _possibleConstructorReturn(this, (ButtonComponent.__proto__ || Object.getPrototypeOf(ButtonComponent)).call(this, props));

    _this.ButtonCommonMixin = '';
    _this.ButtonBaseMixin = '';
    _this.buttonType = ''; // oneOf 'Button', 'FlatButton', 'OutlineButton', 'UnstyledButton'
    return _this;
  }

  _createClass(ButtonComponent, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          message = _props.message,
          text = _props.text,
          originalType = _props.type,
          children = _props.children,
          inert = _props.inert,
          link = _props.link,
          readyLink = _props.readyLink,
          isFullWidth = _props.isFullWidth,
          click = _props.click,
          onClick = _props.onClick,
          disabled = _props.disabled,
          iconProp = _props.icon,
          iconPosition = _props.iconPosition,
          style = _props.style,
          className = _props.className,
          target = _props.target,
          loading = _props.loading,
          _props$tabIndex = _props.tabIndex,
          tabIndex = _props$tabIndex === undefined ? 0 : _props$tabIndex,
          onMouseOut = _props.onMouseOut,
          title = _props.title;


      var textOrMessage = message || text || children;

      var wasASubmitInitially = originalType === 'submit';

      var type = wasASubmitInitially ? 'primary' : originalType;

      var icon = void 0;
      var iconSize = 16;
      if (_react2.default.isValidElement(iconProp)) {
        var iconSizeFromConsumer = iconProp.props ? iconProp.props.size : null;
        if (iconSizeFromConsumer !== undefined) {
          iconSize = iconSizeFromConsumer;
        }
        icon = _react2.default.cloneElement(iconProp, {
          size: iconSize
        });
      }

      var buttonAttr = _extends({
        onClick: !loading && (click || onClick || null),
        title: title,
        className: className,
        style: _extends({}, style, {
          margin: 0,
          marginTop: 0,
          marginRight: 0,
          marginBottom: 0,
          marginLeft: 0
        })
      }, tabIndex !== undefined && !disabled && !inert ? { tabIndex: tabIndex } : {});

      var marginStyles = _extends({
        display: isFullWidth ? 'block' : 'inline-block'
      }, 'margin' in style ? { margin: style.margin } : {}, 'marginTop' in style ? { marginTop: style.marginTop } : {}, 'marginRight' in style ? { marginRight: style.marginRight } : {}, 'marginBottom' in style ? { marginBottom: style.marginBottom } : {}, 'marginLeft' in style ? { marginLeft: style.marginLeft } : {});

      var styleProps = {
        isFullWidth: isFullWidth,
        disabled: disabled,
        type: type,
        iconPosition: iconPosition,
        icon: icon,
        textOrMessage: textOrMessage
      };

      // which element to render div|a|button
      var TheButtonComponent = null;
      if (inert) {
        TheButtonComponent = (0, _Buttons.getButtonDivUI)(this.buttonType);
      } else if (readyLink) {
        var DivButtonComponent = (0, _Buttons.getButtonDivUI)(this.buttonType);
        TheButtonComponent = function TheButtonComponent(props) {
          return _react2.default.createElement(
            DivButtonComponent,
            props,
            readyLink
          );
        };
      } else if (link) {
        TheButtonComponent = (0, _Buttons.getButtonLinkUI)(this.buttonType);
      } else {
        TheButtonComponent = (0, _Buttons.getButtonUI)(this.buttonType);
      }

      var theButton = _react2.default.createElement(
        TheButtonComponent,
        _extends({}, link && !disabled ? { href: link } : {}, link && !disabled && target ? { target: target } : {}, styleProps, buttonAttr, {
          onMouseOut: onMouseOut
        }),
        icon && (loading ? _react2.default.createElement(
          _ButtonIconWrapper.ButtonIconWrapper,
          styleProps,
          ' ',
          _react2.default.createElement(_Indicator.Loader, { size: '16' }),
          ' '
        ) : _react2.default.createElement(
          _ButtonIconWrapper.ButtonIconWrapper,
          styleProps,
          ' ',
          icon,
          ' '
        )),
        !icon && loading && _react2.default.createElement(
          _ButtonIconWrapper.ButtonIconWrapper,
          styleProps,
          ' ',
          _react2.default.createElement(_Indicator.Loader, { size: '16' }),
          ' '
        ),
        textOrMessage && _react2.default.createElement(
          _ButtonContentWrapper.ButtonContentWrapper,
          styleProps,
          ' ',
          textOrMessage,
          ' '
        )
      );

      var border = style.border,
          borderBottom = style.borderBottom,
          borderTop = style.borderTop,
          borderLeft = style.borderLeft,
          borderRight = style.borderRight,
          restForRippleStyles = _objectWithoutProperties(style, ['border', 'borderBottom', 'borderTop', 'borderLeft', 'borderRight']);

      var rippleStyles = _extends({}, isFullWidth ? { width: '100%' } : {}, restForRippleStyles, {
        margin: 0,
        marginTop: 0,
        marginRight: 0,
        marginBottom: 0,
        marginLeft: 0
      });

      return _react2.default.createElement(
        'div',
        {
          style: _extends({}, marginStyles, {
            lineHeight: 0
          }, style.width ? { width: style.width } : {}, style.minWidth ? { minWidth: style.minWidth } : {}, style.maxWidth ? { maxWidth: style.maxWidth } : {}, style.height ? { height: style.width } : {}, style.minHeight ? { minHeight: style.minHeight } : {}, style.maxHeight ? { maxHeight: style.maxHeight } : {})
        },
        _react2.default.createElement(
          _Ripples2.default,
          { disabled: disabled, style: rippleStyles },
          theButton
        )
      );
    }
  }]);

  return ButtonComponent;
}(_react.Component);

ButtonComponent.propTypes = {
  style: _propTypes2.default.object,
  type: _propTypes2.default.oneOf([// eslint-disable-line
  'primary', 'secondary', 'danger', 'error', 'warning', 'success', 'info', 'default'])
};

ButtonComponent.defaultProps = {
  style: {},
  onMouseOut: undefined
  // type: 'default',
};

exports.default = ButtonComponent;