'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  cursor: pointer;\n  color: ', ';\n  display: inline-block;\n  ', ';\n  &:hover {\n    text-decoration: underline;\n  }\n  svg {\n    color: ', ';\n    fill: ', ';\n  }\n  opacity: ', ';\n'], ['\n  cursor: pointer;\n  color: ', ';\n  display: inline-block;\n  ', ';\n  &:hover {\n    text-decoration: underline;\n  }\n  svg {\n    color: ', ';\n    fill: ', ';\n  }\n  opacity: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _AvatarWithName = require('../Img/AvatarWithName');

var _AvatarWithName2 = _interopRequireDefault(_AvatarWithName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var getTypeColor = function getTypeColor(_ref, type) {
  var palette = _ref.palette;

  if (!type) {
    return palette.accent.main;
  }
  if (palette.semantic[type]) {
    return palette.semantic[type];
  }
  return '#fff';
};

var ButtonLinkWrapper = _styledComponents2.default.a(_templateObject, function (_ref2) {
  var theme = _ref2.theme,
      type = _ref2.type;
  return getTypeColor(theme, type);
}, function (_ref3) {
  var isFullWidth = _ref3.isFullWidth;
  return isFullWidth ? 'width: 100%' : '';
}, function (_ref4) {
  var theme = _ref4.theme,
      type = _ref4.type;
  return getTypeColor(theme, type);
}, function (_ref5) {
  var theme = _ref5.theme,
      type = _ref5.type;
  return getTypeColor(theme, type);
}, function (_ref6) {
  var disabled = _ref6.disabled;
  return disabled ? '0.4' : '1';
});

var ButtonLink = function ButtonLink(_ref7) {
  var _onClick = _ref7.onClick,
      icon = _ref7.icon,
      text = _ref7.text,
      message = _ref7.message,
      children = _ref7.children,
      style = _ref7.style,
      isFullWidth = _ref7.isFullWidth,
      iconAfter = _ref7.iconAfter,
      disabled = _ref7.disabled,
      title = _ref7.title;

  var content = icon ? _react2.default.createElement(_AvatarWithName2.default, {
    inverse: iconAfter,
    imgSize: 16,
    icon: icon,
    name: text || message || children,
    style: _extends({}, isFullWidth ? { justifyContent: 'center' } : {})
  }) : _react2.default.createElement(
    'div',
    { style: { textAlign: isFullWidth ? 'center' : 'left' } },
    text || message || children
  );

  return _react2.default.createElement(
    ButtonLinkWrapper,
    {
      style: style,
      onClick: function onClick(e) {
        e.preventDefault();if (!disabled) {
          _onClick(e);
        }
      },
      isFullWidth: isFullWidth,
      disabled: disabled,
      title: title
    },
    content
  );
};

ButtonLink.displayName = 'ButtonLink';

ButtonLink.defaultProps = {
  onClick: function onClick() {},
  icon: null,
  text: '',
  message: '',
  children: null,
  style: {},
  isFullWidth: false,
  iconAfter: undefined,
  disabled: false,
  title: undefined
};

ButtonLink.propTypes = {
  onClick: _propTypes2.default.func,
  icon: _propTypes2.default.node,
  text: _propTypes2.default.any,
  message: _propTypes2.default.any,
  children: _propTypes2.default.any,
  style: _propTypes2.default.object,
  isFullWidth: _propTypes2.default.bool,
  iconAfter: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  title: _propTypes2.default.string
};

exports.default = ButtonLink;