'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  /* STATIC BASE STYLES: */\n  ', ';\n\n  /* ICON POSITION: */\n  flex-direction: ', ';\n\n  /* FULL WIDTH STYLES: */\n  ', ';\n\n  /* TYPE STYLES: */\n  background-color: ', ';\n  border-color: ', ';\n  color: ', ';\n  svg { fill: ', ';}\n  &:hover {\n    border-color: ', ';\n    color: ', ';\n    background-color: ', ';\n    svg { fill: ', ';}\n  }\n\n  /* DISABLED STYLES: (overrides types styles)*/\n  cursor: ', ';\n  ', '\n  ', ';\n  &:hover {\n    ', ';\n    ', ';\n    svg {\n      ', ';\n    }\n  }\n  svg {\n    ', ';\n  }\n\n}\n'], ['\n  /* STATIC BASE STYLES: */\n  ', ';\n\n  /* ICON POSITION: */\n  flex-direction: ', ';\n\n  /* FULL WIDTH STYLES: */\n  ', ';\n\n  /* TYPE STYLES: */\n  background-color: ', ';\n  border-color: ', ';\n  color: ', ';\n  svg { fill: ', ';}\n  &:hover {\n    border-color: ', ';\n    color: ', ';\n    background-color: ', ';\n    svg { fill: ', ';}\n  }\n\n  /* DISABLED STYLES: (overrides types styles)*/\n  cursor: ', ';\n  ', '\n  ', ';\n  &:hover {\n    ', ';\n    ', ';\n    svg {\n      ', ';\n    }\n  }\n  svg {\n    ', ';\n  }\n\n}\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  margin: ', ';\n'], ['\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  margin: ', ';\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  margin: 0 4px;\n'], ['\n  margin: 0 4px;\n']),
    _templateObject4 = _taggedTemplateLiteral(['', ';'], ['', ';']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _ButtonBaseStyles = require('./ButtonBaseStyles');

var _ButtonBaseStyles2 = _interopRequireDefault(_ButtonBaseStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
/* eslint-disable brace-style */


var getTypeColor = function getTypeColor(_ref, type) {
  var palette = _ref.palette;

  if (palette.semantic[type]) {
    return palette.semantic[type];
  }
  if (type === 'primary') {
    return palette.accent.main;
  }
  if (type === 'secondary') {
    return palette.primary.main;
  }
  return '#fff';
};

/* eslint-disable indent */
var ButtonBaseMixin = (0, _styledComponents.css)(_templateObject, _ButtonBaseStyles2.default, function (_ref2) {
  var iconPosition = _ref2.iconPosition;

  if (iconPosition && iconPosition === 'after') {
    return 'row-reverse';
  }
  return 'row';
}, function (_ref3) {
  var isFullWidth = _ref3.isFullWidth;
  return isFullWidth ? 'width: 100%' : '';
}, function (_ref4) {
  var theme = _ref4.theme,
      type = _ref4.type;
  return getTypeColor(theme, type);
}, function (_ref5) {
  var theme = _ref5.theme,
      type = _ref5.type;
  return type ? getTypeColor(theme, type) : 'inherit';
}, function (_ref6) {
  var type = _ref6.type;
  return type ? '#fff' : 'inherit';
}, function (_ref7) {
  var type = _ref7.type;
  return type ? '#fff' : 'inherit';
}, function (_ref8) {
  var theme = _ref8.theme,
      type = _ref8.type;
  return type ? getTypeColor(theme, type) : 'inherit';
}, function (_ref9) {
  var theme = _ref9.theme,
      type = _ref9.type;
  return type ? getTypeColor(theme, type) : 'inherit';
}, function (_ref10) {
  var type = _ref10.type,
      theme = _ref10.theme;
  return type ? '#fff' : theme.palette.lightGrey;
}, function (_ref11) {
  var theme = _ref11.theme,
      type = _ref11.type;
  return type ? getTypeColor(theme, type) : 'inherit';
}, function (_ref12) {
  var disabled = _ref12.disabled;
  return disabled ? 'normal' : 'pointer';
}, function (_ref13) {
  var disabled = _ref13.disabled,
      palette = _ref13.theme.palette;
  return disabled ? 'background-color: ' + palette.lightGrey + '; color: ' + palette.grey + ';' : '';
}, function (_ref14) {
  var disabled = _ref14.disabled;
  return disabled ? 'border-color: transparent;' : '';
}, function (_ref15) {
  var disabled = _ref15.disabled,
      palette = _ref15.theme.palette;
  return disabled ? 'background-color: ' + palette.lightGrey + '; color: ' + palette.grey : '';
}, function (_ref16) {
  var disabled = _ref16.disabled;
  return disabled ? 'border-color: transparent;' : '';
}, function (_ref17) {
  var disabled = _ref17.disabled,
      palette = _ref17.theme.palette;
  return disabled ? 'fill: ' + palette.grey : '';
}, function (_ref18) {
  var disabled = _ref18.disabled,
      palette = _ref18.theme.palette;
  return disabled ? 'fill: ' + palette.grey : '';
});

var ButtonIconWrapper = _styledComponents2.default.div(_templateObject2, function (_ref19) {
  var icon = _ref19.icon;
  return icon ? '0 4px' : '0';
});

var ButtonContentWrapper = _styledComponents2.default.div(_templateObject3);

/* eslint-enable indent */
var ButtonUI = _styledComponents2.default.button(_templateObject4, ButtonBaseMixin);
var ButtonLinkUI = _styledComponents2.default.a(_templateObject4, ButtonBaseMixin);
var ButtonDivUI = _styledComponents2.default.div(_templateObject4, ButtonBaseMixin);

// eslint-disable-next-line react/prefer-stateless-function

var Button = function (_Component) {
  _inherits(Button, _Component);

  function Button() {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          message = _props.message,
          text = _props.text,
          originalType = _props.type,
          children = _props.children,
          inert = _props.inert,
          link = _props.link,
          isFullWidth = _props.isFullWidth,
          onClick = _props.onClick,
          disabled = _props.disabled,
          iconProp = _props.icon,
          iconPosition = _props.iconPosition,
          style = _props.style;


      var textOrMessage = message || text || children;

      var wasASubmitInitially = originalType === 'submit';

      var type = wasASubmitInitially ? 'primary' : originalType;

      var icon = void 0;
      if (_react2.default.isValidElement(iconProp)) {
        icon = _react2.default.cloneElement(iconProp, { size: '16' });
      }

      var buttonProps = {
        onClick: onClick
      };

      var styleProps = {
        isFullWidth: isFullWidth,
        disabled: disabled,
        type: type,
        iconPosition: iconPosition,
        icon: icon
      };

      // which element to render div|a|button
      var TheButtonComponent = null;
      if (inert) {
        TheButtonComponent = ButtonDivUI;
      } else if (link) {
        TheButtonComponent = ButtonLinkUI;
      } else {
        TheButtonComponent = ButtonUI;
      }

      var theButton = _react2.default.createElement(
        TheButtonComponent,
        _extends({}, styleProps, buttonProps, { isFullWidth: isFullWidth, style: style }),
        icon && _react2.default.createElement(
          ButtonIconWrapper,
          styleProps,
          ' ',
          icon,
          ' '
        ),
        textOrMessage && _react2.default.createElement(
          ButtonContentWrapper,
          styleProps,
          ' ',
          textOrMessage,
          ' '
        )
      );

      // const rippleStyles = isFullWidth ? { width: '100%' } : {};

      return theButton;
    }
  }]);

  return Button;
}(_react.Component);

exports.default = Button;