'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getAppropriateIcon = require('../Icons/getAppropriateIcon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/prefer-stateless-function */
var IconButton = function (_Component) {
  _inherits(IconButton, _Component);

  function IconButton() {
    _classCallCheck(this, IconButton);

    return _possibleConstructorReturn(this, (IconButton.__proto__ || Object.getPrototypeOf(IconButton)).apply(this, arguments));
  }

  _createClass(IconButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          onClick = _props.onClick,
          link = _props.link,
          icon = _props.icon,
          children = _props.children,
          style = _props.style,
          rel = _props.rel,
          target = _props.target,
          href = _props.href;

      // white list link prop (attributes):

      var linkPropsAttr = {
        rel: rel,
        target: target,
        href: href
      };

      var finalIcon = void 0;

      if (typeof icon === 'string') {
        var Icon = (0, _getAppropriateIcon.getAppropriateIcon)(icon);
        finalIcon = _react2.default.createElement(Icon, this.props);
      } else if (_react2.default.isValidElement(icon)) {
        finalIcon = icon;
      } else {
        var _Icon = icon;
        finalIcon = _react2.default.createElement(_Icon, this.props);
      }

      if (link || href) {
        return _react2.default.createElement(
          'a',
          _extends({ href: link, style: style }, linkPropsAttr),
          finalIcon
        );
      }

      var finalStyles = _extends({
        border: 0,
        padding: 0,
        verticalAlign: 'middle',
        cursor: 'pointer',
        background: 'transparent'
      }, style);

      return _react2.default.createElement(
        'button',
        { style: finalStyles, onClick: onClick },
        finalIcon,
        children
      );
    }
  }]);

  return IconButton;
}(_react.Component);

IconButton.defaultProps = {
  rel: null,
  target: null,
  href: null
};

exports.default = IconButton;