'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  cursor: pointer;\n  border: none;\n  background: transparent;\n  border-radius: 0;\n  display: none;\n  outline: none;\n  &:first-of-type {\n    margin-right: 16px;\n    &:hover { transform-origin: right center }\n  }\n  &:nth-of-type(2) {\n    margin-left: 16px;\n    &:hover { transform-origin: left center }\n  }\n  @media (min-width: 1024px) {\n    display: inherit;\n  }\n  &:hover {\n    transform: scale(1.1);\n    transition: ', '\n  }\n'], ['\n  cursor: pointer;\n  border: none;\n  background: transparent;\n  border-radius: 0;\n  display: none;\n  outline: none;\n  &:first-of-type {\n    margin-right: 16px;\n    &:hover { transform-origin: right center }\n  }\n  &:nth-of-type(2) {\n    margin-left: 16px;\n    &:hover { transform-origin: left center }\n  }\n  @media (min-width: 1024px) {\n    display: inherit;\n  }\n  &:hover {\n    transform: scale(1.1);\n    transition: ', '\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  margin: 32px auto;\n  @media (min-width: 1024px) {\n    margin: 48px auto;\n    flex-direction: row;\n    align-items: stretch;\n  }\n}'], ['\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  margin: 32px auto;\n  @media (min-width: 1024px) {\n    margin: 48px auto;\n    flex-direction: row;\n    align-items: stretch;\n  }\n}']),
    _templateObject3 = _taggedTemplateLiteral(['\n  z-index: 1;\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  @media (min-width: 1024px) {\n    flex-flow: row nowrap;\n    /* max-width: (3 * 280 + (6 * 8)) ;*/\n    max-width: 888px;\n    overflow: hidden;\n    justify-content: start;\n  }\n'], ['\n  z-index: 1;\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  @media (min-width: 1024px) {\n    flex-flow: row nowrap;\n    /* max-width: (3 * 280 + (6 * 8)) ;*/\n    max-width: 888px;\n    overflow: hidden;\n    justify-content: start;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Icons = require('../Icons');

var _CarrouselItem = require('./CarrouselItem');

var _CarrouselItem2 = _interopRequireDefault(_CarrouselItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var NavigationUI = _styledComponents2.default.button(_templateObject, function (_ref) {
  var transition = _ref.theme.transition;
  return transition.defaultAll;
});

var OutterWrapperUI = _styledComponents2.default.div(_templateObject2);

var WrapperUI = _styledComponents2.default.div(_templateObject3);

var Carrousel = function (_Component) {
  _inherits(Carrousel, _Component);

  function Carrousel(props) {
    _classCallCheck(this, Carrousel);

    var _this = _possibleConstructorReturn(this, (Carrousel.__proto__ || Object.getPrototypeOf(Carrousel)).call(this, props));

    _this.handleNext = _this.handleNext.bind(_this);
    _this.handlePrevious = _this.handlePrevious.bind(_this);
    _this.canScrollLeft = false;
    _this.canScrollRight = false;

    _this.state = {
      scrollableTowardsNext: false,
      scrollableTowardsPrevious: false
    };
    return _this;
  }

  _createClass(Carrousel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateScrollableState();
    }
  }, {
    key: 'updateScrollableState',
    value: function updateScrollableState() {
      if (this.ref) {
        var _ref2 = this.ref,
            children = _ref2.children,
            scrollLeft = _ref2.scrollLeft;

        var refRect = this.ref.getBoundingClientRect();

        if (children) {
          var totalInnerWidth = [].concat(_toConsumableArray(children)).reduce(function (accu, x) {
            var width = x.getBoundingClientRect().width;
            return accu + width;
          }, 0);

          this.setState({
            scrollableTowardsNext: totalInnerWidth - scrollLeft - refRect.width > 0,
            scrollableTowardsPrevious: scrollLeft > 0
          });
        }
      }
    }
  }, {
    key: 'handleNext',
    value: function handleNext() {
      if (this.ref) {
        var width = this.ref.getBoundingClientRect().width;
        this.ref.scrollLeft = this.ref.scrollLeft + width;
      }
      this.updateScrollableState();
    }
  }, {
    key: 'handlePrevious',
    value: function handlePrevious() {
      if (this.ref) {
        var width = this.ref.getBoundingClientRect().width;
        this.ref.scrollLeft = this.ref.scrollLeft - width;
      }
      this.updateScrollableState();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var children = this.props.children;
      var _state = this.state,
          scrollableTowardsNext = _state.scrollableTowardsNext,
          scrollableTowardsPrevious = _state.scrollableTowardsPrevious;

      var color = '#26a29a';

      var shouldDisplayNavArrows = scrollableTowardsNext > 0 || scrollableTowardsPrevious > 0;

      var prev = shouldDisplayNavArrows && _react2.default.createElement(
        NavigationUI,
        { onClick: this.handlePrevious },
        _react2.default.createElement(_Icons.Arrowleft, { color: scrollableTowardsPrevious ? color : undefined, size: 32 })
      );

      var next = shouldDisplayNavArrows && _react2.default.createElement(
        NavigationUI,
        { onClick: this.handleNext },
        _react2.default.createElement(_Icons.Arrowright, { color: scrollableTowardsNext ? color : undefined, size: 32 })
      );

      return _react2.default.createElement(
        OutterWrapperUI,
        null,
        prev,
        _react2.default.createElement(
          WrapperUI,
          { innerRef: function innerRef(node) {
              _this2.ref = node;
            } },
          _react2.default.Children.map(children, function (child) {
            if (child.type === 'CarrouselItem') {
              return _react2.default.cloneElement(child);
            }
            return _react2.default.createElement(
              _CarrouselItem2.default,
              null,
              ' ',
              _react2.default.cloneElement(child),
              ' '
            );
          })
        ),
        next
      );
    }
  }]);

  return Carrousel;
}(_react.Component);

Carrousel.defaultProps = {
  items: []
};

exports.default = Carrousel;