'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: grid;\n  grid-template-columns: repeat(8, minmax(120px, 1fr));\n  grid-auto-rows: 180px;\n  grid-gap:24px;\n  @media (max-width: 960px) {\n    grid-template-columns: repeat(2, 1fr);\n  }\n'], ['\n  display: grid;\n  grid-template-columns: repeat(8, minmax(120px, 1fr));\n  grid-auto-rows: 180px;\n  grid-gap:24px;\n  @media (max-width: 960px) {\n    grid-template-columns: repeat(2, 1fr);\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/*
  Credit for inspiration: https://medium.com/@andybarefoot/a-masonry-style-layout-using-css-grid-8c663d355ebb
*/

var DashboardWrapperDiv = _styledComponents2.default.div(_templateObject);

var DashboardWrapper = function (_Component) {
  _inherits(DashboardWrapper, _Component);

  function DashboardWrapper() {
    _classCallCheck(this, DashboardWrapper);

    return _possibleConstructorReturn(this, (DashboardWrapper.__proto__ || Object.getPrototypeOf(DashboardWrapper)).apply(this, arguments));
  }

  _createClass(DashboardWrapper, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // this.resizeAllGridItems();
      window.addEventListener('resize', this.resizeAllGridItems);
    }
  }, {
    key: 'resizeAllGridItems',
    value: function resizeAllGridItems() {
      var _this2 = this;

      var allItems = document.getElementsByClassName('item');
      [].concat(_toConsumableArray(allItems)).forEach(function (x) {
        _this2.resizeGridItem(x);
      });
    }
  }, {
    key: 'resizeGridItem',
    value: function resizeGridItem(item) {
      var grid = _reactDom2.default.findDOMNode(this.grid); // eslint-disable-line react/no-find-dom-node
      var rowHeight = parseInt(window.getComputedStyle(grid).getPropertyValue('grid-auto-rows'), 10);
      var rowGap = parseInt(window.getComputedStyle(grid).getPropertyValue('grid-row-gap'), 10);
      var rowSpan = Math.ceil((item.querySelector('.content').getBoundingClientRect().height + rowGap) / (rowHeight + rowGap));
      item.style.gridRowEnd = 'span ' + rowSpan; // eslint-disable-line no-param-reassign
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var children = this.props.children;

      return _react2.default.createElement(
        DashboardWrapperDiv,
        { ref: function ref(grid) {
            _this3.grid = grid;
          } },
        children
      );
    }
  }]);

  return DashboardWrapper;
}(_react.Component);

exports.default = DashboardWrapper;