'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _Table = require('../Table');

var _viewModel = require('./grid/viewModel');

var _factory = require('./grid/factory');

var _Button = require('../Button');

var _List = require('../List');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 *
 * Data grid is much more complex than a Table.
 * The Data Grid is a really complex component which
 * plays with the idea of showing a List of Entities
 * The Data Grid is complex and should not be missMatched with the Table
 * The Table is used for simpler usecases whereas the
 * Data Grid is more close to an XLS like component.
 * Under the hood, the Data Grid is using the Table.
 *
 * Data GRID can be extends - as we work by Entity,
 * we can create custom cell or column defition to show extra content.
 * Data GRID APIS:
 *
 * data <= the data
 * actions = [], a list of actions with an Icon, a name,
 * a promoted (boolean to mention must be visible) and an action
 * batchActions = [], a list of actions with an Icon, a name and an action,
 * sortingKyes=[], a list of Keys that needs to be sorted
 * selectable
 * activable
 * multiSelectable
 * noDataText,
 * fixedHeight => setup the correct overflow
 * tileConfig: {
 * }
 * detailViewConfig: {
 * }
 * iconViewConfig: {
 *
 * },
 * tableConfig: {
 *   fixedHeader,
 *   columnConfig: {
 *   },
 *   resizable,
 *   extraColumnConfig: {
 *     candidate: [],
 *     extraColumns: [
 *       colimnConfig,
 *     ]
 *   }
 * }
 */

/**
  *    var gridOptions = {
        columnDefs: columnDefs,
        rowSelection: 'multiple',
        enableColResize: true,
        enableSorting: true,
        enableFilter: true,
        enableRangeSelection: true,
        suppressRowClickSelection: true,
        animateRows: true,
        onModelUpdated: modelUpdated,
        debug: true
    };
  */

var DataGrid = function (_Component) {
  _inherits(DataGrid, _Component);

  function DataGrid(props) {
    _classCallCheck(this, DataGrid);

    var _this = _possibleConstructorReturn(this, (DataGrid.__proto__ || Object.getPrototypeOf(DataGrid)).call(this, props));

    _this.state = {
      selectedEntities: [],
      allChecked: false
    };

    _this.isSelectionControlled = props.selectedEntities !== undefined;
    return _this;
  }

  _createClass(DataGrid, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var _state = this.state,
          selectedEntities = _state.selectedEntities,
          allChecked = _state.allChecked;
      var _props = this.props,
          data = _props.data,
          properties = _props.properties,
          selectable = _props.selectable,
          selectedEntitiesProp = _props.selectedEntities;


      if (!(0, _isEqual2.default)(nextProps.selectedEntities, selectedEntitiesProp)) {
        return true;
      } else if (nextState.selectedEntities.length !== selectedEntities.length) {
        return true;
      } else if (nextProps.selectable !== selectable) {
        return true;
      } else if (nextState.allChecked !== allChecked) {
        return true;
      } else if (nextProps.data.length !== data.length) {
        return true;
      } else if (!(0, _isEqual2.default)(nextProps.properties, properties)) {
        return true;
      } else if (!(0, _isEqual2.default)(nextProps.data, data)) {
        return true;
      }
      return false;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (!(0, _isEqual2.default)(this.state.selectedEntities, this.props.selectedEntities)) {
        if (this.isSelectionControlled) {
          this.setState({
            selectedEntities: this.props.selectedEntities
          });
        }
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(e, indexes, values) {
      var onChange = this.props.onChange;

      if (this.isSelectionControlled) {
        // noop
        // actully, let's cheat
        this.setState({
          selectedEntities: values
        });
      } else {
        this.setState({
          selectedEntities: values
        });
      }

      if (onChange) {
        onChange(e, indexes, values);
      }
    }
  }, {
    key: 'clearSelectedEntities',
    value: function clearSelectedEntities() {
      this.setState({
        selectedEntities: []
      });

      if (this.tableRef) {
        // if not new table
        this.tableRef.clearSelection();
      }
    }
  }, {
    key: 'checkAll',
    value: function checkAll() {
      this.setState({
        allChecked: !this.state.allChecked
      });
    }
  }, {
    key: 'createBatchActions',
    value: function createBatchActions(actions) {
      var _this2 = this;

      var _state2 = this.state,
          selectedEntities = _state2.selectedEntities,
          hideBatchActionContent = _state2.hideBatchActionContent;


      if (hideBatchActionContent) {
        return null;
      }

      if (selectedEntities.length === 0) {
        return _react2.default.createElement('div', null);
      }

      var listStyle = {
        zIndex: 1,
        position: 'absolute',
        top: 0,
        left: 0,
        right: 0,
        marginLeft: '56px',
        lineHeight: '48px',
        height: '48px',
        display: 'flex',
        justifyContent: 'stretch',
        borderBottom: '1px solid rgb(224,224,224)',
        background: 'white'
      };

      return _react2.default.createElement(
        _List.List,
        { style: listStyle },
        _react2.default.createElement(
          'span',
          { key: 'selected' },
          selectedEntities.length,
          ' selected'
        ),
        actions.map(function (action, i) {
          return _react2.default.createElement(_Button.ButtonLink, {
            key: action.label || i,
            text: action.label,
            icon: action.icon,
            onClick: function onClick(e) {
              action.onClick(e, selectedEntities, _this2.clearSelectedEntities);
              if (action.clearSelection) {
                _this2.clearSelectedEntities();
              }
            }
          });
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          data = _props2.data,
          propertyKey = _props2.propertyKey,
          properties = _props2.properties,
          selectable = _props2.selectable,
          fixedHeight = _props2.fixedHeight,
          multiSelectable = _props2.multiSelectable,
          batchActions = _props2.batchActions,
          actions = _props2.actions,
          stickyHeader = _props2.stickyHeader,
          hideBatchActionContent = _props2.hideBatchActionContent,
          selectedProp = _props2.selected,
          selectedEntitiesProp = _props2.selectedEntities,
          resizable = _props2.resizable;

      // let's keep hacking around GFD

      var selected = selectedProp;
      if (selectedEntitiesProp && selected === undefined) {
        selected = data.reduce(function (acc, _ref, i) {
          var entityId = _ref.entityId;
          return selectedEntitiesProp.indexOf(entityId) > -1 ? [].concat(_toConsumableArray(acc), [i]) : acc;
        }, []);
      }

      var getTypeDefinition = this.context.getTypeDefinition;

      var headers = (0, _viewModel.toHeaderDefinition)(data, properties);
      var viewModel = (0, _viewModel.toViewModel)(data, properties, propertyKey, getTypeDefinition);
      var _state3 = this.state,
          selectedEntitiesState = _state3.selectedEntities,
          allChecked = _state3.allChecked;


      var selectedEntities = this.isSelectionControlled ? selectedEntitiesProp : selectedEntitiesState;

      var hideHeader = false;

      if (hideBatchActionContent !== true && batchActions && batchActions.length > 0 && selectedEntities && selectedEntities.length > 0) {
        hideHeader = true;
      }

      var header = (0, _factory.createDataGridHeader)(headers, fixedHeight, hideHeader, stickyHeader);
      var body = (0, _factory.createDataGridBody)(viewModel, false, actions);
      var batchActionsContent = this.createBatchActions(batchActions || []);

      var content = _react2.default.createElement(
        'div',
        { style: { position: 'relative' } },
        batchActionsContent,
        _react2.default.createElement(
          _Table.Table,
          {
            resizable: resizable,
            ref: function ref(tableRef) {
              _this3.tableRef = tableRef;
            },
            onChange: this.onChange.bind(this),
            multiSelectable: multiSelectable // WTFF!!
            , selectable: selectable // WTFF!!
            , selected: selected,
            selectedEntities: selectedEntities
          },
          header,
          body
        )
      );

      if (!fixedHeight) {
        return content;
      }

      var headerWithCheckbox = (0, _factory.createDataGridHeader)(headers, fixedHeight, hideHeader, stickyHeader, multiSelectable, function () {
        _this3.checkAll();
      }, allChecked);

      return _react2.default.createElement(
        'div',
        { style: { position: 'relative' } },
        batchActionsContent,
        _react2.default.createElement(
          _Table.Table,
          { resizable: resizable },
          headerWithCheckbox
        ),
        _react2.default.createElement(
          'div',
          { style: { height: fixedHeight + 'px', overflowY: 'scroll' } },
          _react2.default.createElement(
            _Table.Table
            // resizable={resizable}
            ,
            { ref: function ref(tableRef) {
                _this3.tableRef = tableRef;
              },
              allRowsSelected: allChecked,
              onChange: this.onChange.bind(this),
              selectable: selectable,
              multiSelectable: multiSelectable,
              selected: selected,
              selectedEntities: selectedEntities
            },
            body
          )
        )
      );
    }
  }]);

  return DataGrid;
}(_react.Component);

DataGrid.componentName = 'DataGrid';
DataGrid.contextTypes = {
  getTypeDefinition: _propTypes2.default.func
};
DataGrid.propTypes = {
  data: _propTypes2.default.array
};
DataGrid.defaultProps = {
  data: []
};
exports.default = DataGrid;