'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withSelection = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getValuesAndRows = function getValuesAndRows(props) {
  var children = props.children;


  var availableIndexes = [];
  var availableRowsValues = [];

  _react2.default.Children.forEach(children, function (child) {
    if (!_react2.default.isValidElement(child)) {
      return;
    }

    var componentName = child.type.componentName;


    if (componentName === 'TableBody') {
      // TODO: Add Scenario for TableView, TileView,....
      _react2.default.Children.forEach(child.props.children, function (row, idx) {
        if (row) {
          // By default we take the 'value' props from the Children Component to use as the value.
          var _row$props = row.props,
              value = _row$props.value,
              locked = _row$props.locked;

          if (locked !== true) {
            availableRowsValues.push(value);
            availableIndexes.push(idx);
          }
        }
      });
    }
  });

  return {
    availableIndexes: availableIndexes,
    availableRowsValues: availableRowsValues
  };
};

var withSelection = exports.withSelection = function withSelection(Comp) {
  return function (_Component) {
    _inherits(WithSelection, _Component);

    function WithSelection(props) {
      _classCallCheck(this, WithSelection);

      var _this = _possibleConstructorReturn(this, (WithSelection.__proto__ || Object.getPrototypeOf(WithSelection)).call(this, props));

      _this.onRowSelection = function (rowIndex) {
        var _this$props = _this.props,
            onChange = _this$props.onChange,
            multiSelectable = _this$props.multiSelectable,
            selectable = _this$props.selectable,
            selected = _this$props.selected;
        var _this$state = _this.state,
            availableIndexes = _this$state.availableIndexes,
            availableRowsValues = _this$state.availableRowsValues,
            selectedRowsState = _this$state.selectedRows;


        var selectedRows = _this.isSelectionControlled ? selected : selectedRowsState;

        var mitigatedSelectedRows = [].concat(_toConsumableArray(selectedRows || []));

        // If the rowIndex is the special case 'check all', we select all availableRows (not locked).
        if (rowIndex === 'all') {
          mitigatedSelectedRows = [].concat(_toConsumableArray(_this.state.availableIndexes || []));
        } else if (rowIndex === 'none') {
          // If the rowIndex is the special case 'none', unselect all rows.
          mitigatedSelectedRows = [];
        } else {
          if (mitigatedSelectedRows.length === 0) {
            // eslint-disable-line no-lonely-if
            mitigatedSelectedRows.push(rowIndex);
          } else if (mitigatedSelectedRows.length > 0) {
            // If it is a multi-select, we allow muliple values
            if (multiSelectable) {
              var idx = mitigatedSelectedRows.indexOf(rowIndex);

              if (idx > -1) {
                mitigatedSelectedRows.splice(idx, 1);
              } else {
                mitigatedSelectedRows.splice(idx, 0, rowIndex);
              }
            } else if (selectable && !multiSelectable) {
              // If no multi-select, we toggle if already present.
              var _idx = mitigatedSelectedRows.indexOf(rowIndex);
              if (_idx > -1) {
                // single select, is already in, remove it
                mitigatedSelectedRows = [];
              } else {
                // add
                mitigatedSelectedRows = [rowIndex];
              }
            }
          }
        }
        // make values, yeah this idirty
        var selectedRowsValues = _this.getValueForRows(mitigatedSelectedRows);

        // if (!this.isSelectionControlled) {
        _this.setState({ selectedRows: mitigatedSelectedRows, selectedRowsValues: selectedRowsValues });
        // }

        if (onChange) {
          onChange(event, mitigatedSelectedRows, selectedRowsValues, availableIndexes, availableRowsValues);
        }
      };

      _this.onSelectAll = function () {
        if (_this.onRowSelection) {
          if (_this.state.availableIndexes.length === _this.state.selectedRows.length) {
            _this.onRowSelection('none');
          } else {
            _this.onRowSelection('all');
          }
        }
      };

      _this.onActivateRow = _this.onActivateRow.bind(_this);
      _this.onRowSelection = _this.onRowSelection.bind(_this);

      _this.isSelectionControlled = props.selected !== undefined || props.selected !== undefined;

      _this.state = {
        allRowsSelected: props.allRowsSelected,
        selectedRows: _this.isSelectionControlled ? props.selected : [],
        selectedRowsValues: props.initialSelected || [],
        availableIndexes: [], // internal
        availableRowsValues: [], // internal
        activeRow: null
      };
      _this.currentRowID = 0;
      return _this;
    }

    _createClass(WithSelection, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var initialState = getValuesAndRows(this.props);
        var selectedRowsValues = this.state.selectedRowsValues;

        var selectedRows = [];
        initialState.availableRowsValues.forEach(function (v, index) {
          var isSelected = selectedRowsValues.find(function (selectedValue) {
            return v === selectedValue;
          });
          if (isSelected) {
            selectedRows.push(index);
          }
        });

        this.setState(Object.assign({}, initialState, {
          selectedRows: selectedRows
        }));
      }

      /*
      componentDidUpdate(prevProps, prevState) {
        if (this.isSelectionControlled) {
          if (
            // via indexes
            (
              (prevProps.selectedIndexes || []).length !== (this.props.selectedIndexes || []).length
              || (!isEqual(prevProps.selectedIndexes, this.props.selectedIndexes))
            )
            // or via entityId (assumed to be from entity[propertyKey]) ?
            || (
              (prevProps.selectedEntities || []).length !== (this.props.selectedEntities || []).length
              || (!isEqual(prevProps.selectedEntities, this.props.selectedEntities))
            )
          ) {
            this.setState({
              selectedRowsValues: this.props.selectedEntities,
              selectedRows: this.props.selectedIndexes,
            });
          }
        }
      }
      */

    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        // eslint-disable-line consistent-return
        var _state = this.state,
            availableRowsValues = _state.availableRowsValues,
            selectedRowsValues = _state.selectedRowsValues,
            availableIndexes = _state.availableIndexes,
            allRowsSelected = _state.allRowsSelected;

        var newValues = getValuesAndRows(nextProps);
        var newSelectedIndex = [];
        var newSelectedValues = [];

        if (this.isSelectionControlled) {
          if (
          // via indexes
          (nextProps.selectedIndexes || []).length !== (this.props.selectedIndexes || []).length || !(0, _isEqual2.default)(nextProps.selectedIndexes, this.props.selectedIndexes) ||
          // or via entityId (assumed to be from entity[propertyKey]) ?
          (nextProps.selectedEntities || []).length !== (this.props.selectedEntities || []).length || !(0, _isEqual2.default)(nextProps.selectedEntities, this.props.selectedEntities)) {
            return this.setState({
              selectedRowsValues: nextProps.selectedEntities,
              selectedRows: nextProps.selectedIndexes
            });
          }
        }

        if (availableRowsValues.length !== newValues.availableRowsValues.length) {
          newValues.availableRowsValues.forEach(function (newValue, index) {
            var isPresent = selectedRowsValues.find(function (oldValue) {
              return oldValue === newValue;
            });
            if (isPresent) {
              newSelectedIndex.push(index);
              newSelectedValues.push(newValue);
            }
          });

          // we need to update the Index if there are deletion or addition
          // to do that, we assign a uniqueID list which
          // can indicate weather the row was existing or now

          // selectedRows <=== should be updated with new INDEX
          // selectedRowsVAlues should not change

          this.setState(Object.assign({}, newValues, { selectedRows: newSelectedIndex, selectedRowsValues: newSelectedValues }));
        }

        if (allRowsSelected !== nextProps.allRowsSelected) {
          if (nextProps.allRowsSelected) {
            this.setState(Object.assign({}, this.state, {
              allRowsSelected: true,
              selectedRows: availableIndexes,
              selectedRowsValues: availableRowsValues
            }));

            if (nextProps.onChange) {
              nextProps.onChange(null, availableIndexes, availableRowsValues, availableIndexes, availableRowsValues);
            }
          } else {
            this.setState(Object.assign({}, this.state, { allRowsSelected: false, selectedRows: [], selectedRowsValues: [] }));

            if (nextProps.onChange) {
              nextProps.onChange(null, [], [], availableIndexes, availableRowsValues);
            }
          }
        }
      }

      /**
       *
       * @param {*} event The synthetic event triggred by React
       * @param {*} rowIndex The index of the row that triggered the Active
       */

    }, {
      key: 'onActivateRow',
      value: function onActivateRow(event, rowIndex) {
        var activeRow = this.state.activeRow;

        if (rowIndex === activeRow) {
          this.setState({ activeRow: null });
        } else {
          this.setState({ activeRow: rowIndex });
        }
      }

      /**
       * @param {*} rowIndex The index of the row
       */

    }, {
      key: 'getValueForRows',
      value: function getValueForRows() {
        var rows = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        var _state2 = this.state,
            availableIndexes = _state2.availableIndexes,
            availableRowsValues = _state2.availableRowsValues;

        return rows.map(function (row) {
          var indexInValues = availableIndexes.indexOf(row);
          return availableRowsValues[indexInValues];
        });
      }
    }, {
      key: 'clearSelection',
      value: function clearSelection() {
        this.onRowSelection('none');
      }
    }, {
      key: 'isRowSelected',
      value: function isRowSelected(rowIndex, rowPropertyKey) {
        if (this.isSelectionControlled) {
          if (rowPropertyKey) {
            if (this.props.selectedEntities.indexOf(rowPropertyKey) > -1) {
              return true;
            }
            return false;
          } else if (rowIndex !== undefined) {
            // TODO implement this case
          }
        } else {
          if (this.state.selectedRows.indexOf(rowIndex) > -1) {
            return true;
          }
          return false;
        }
        return false;
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var allRowsSelected = this.state.availableIndexes.length === (this.state.selectedRows || []).length;

        return _react2.default.createElement(Comp, _extends({}, this.props, {
          allRowsSelected: allRowsSelected,
          isRowSelected: function isRowSelected(rowIndex, rowPropertyKey) {
            return _this2.isRowSelected(rowIndex, rowPropertyKey);
          },
          onSelectAll: function onSelectAll() {
            _this2.onSelectAll();
          },
          onRowSelection: this.onRowSelection,
          onActivateRow: this.onActivateRow,
          activeRow: this.state.activeRow
        }));
      }
    }]);

    return WithSelection;
  }(_react.Component);
};

exports.default = {
  withSelection: withSelection
};