'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SORTS = exports.minCellWidth = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); // eslint-disable-line import/no-named-as-default


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _Checkboxoutline = require('../Icons/Checkboxoutline');

var _Checkboxoutline2 = _interopRequireDefault(_Checkboxoutline);

var _UnstyledButton = require('../Button/UnstyledButton1');

var _Flex = require('../Layout/Flex');

var _Checkbox = require('../Input/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _CellWithPopOver = require('./CellWithPopOver');

var _CellWithPopOver2 = _interopRequireDefault(_CellWithPopOver);

var _TdInnerWrapper = require('./TdInnerWrapper');

var _TdInnerWrapper2 = _interopRequireDefault(_TdInnerWrapper);

var _TextEllipsis = require('../Text/TextEllipsis');

var _TextEllipsis2 = _interopRequireDefault(_TextEllipsis);

var _Table = require('./Table');

var _Table2 = _interopRequireDefault(_Table);

var _Th = require('./Th');

var _Th2 = _interopRequireDefault(_Th);

var _Tr = require('./Tr');

var _Tr2 = _interopRequireDefault(_Tr);

var _Td = require('./Td');

var _Td2 = _interopRequireDefault(_Td);

var _DataGridSmartOverflowXWrapper = require('./DataGridSmartOverflowXWrapper');

var _DataGridSmartOverflowXWrapper2 = _interopRequireDefault(_DataGridSmartOverflowXWrapper);

var _ThInnerWrapper = require('./ThInnerWrapper');

var _ThInnerWrapper2 = _interopRequireDefault(_ThInnerWrapper);

var _reducer = require('./reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var minCellWidth = exports.minCellWidth = 64;
var cellHeight = 48;

var isString = function isString(value) {
  return typeof value === 'string';
};

var runWarnings = function runWarnings(props) {
  if (props.selected === undefined && props.selectable && props.data[0][props.propertyKey] === undefined) {
    var msg = ['Missing `propertyKey`.', 'If you entities do not have `id` DataGrid needs you to specify propertyKey props', 'in order for the uncontrolled selection to work'].join('');
    console.warn(msg);
    throw new Error(msg);
  }
};

var SORTS = exports.SORTS = {
  ASC: 'ASC',
  DESC: 'DESC'
};
var toggleSORTS = function toggleSORTS(sort) {
  return SORTS[sort] === SORTS.ASC ? SORTS.DESC : SORTS.ASC;
};

var DataGrid = function DataGrid(props) {
  var propertyKey = props.propertyKey,
      data = props.data,
      _props$model = props.model,
      model = _props$model === undefined ? Object.keys(data[0] || {}).map(function (k) {
    return { property: k, displayName: k, show: true };
  }) : _props$model,
      selectable = props.selectable,
      multiSelectable = props.multiSelectable,
      onSelectionChange = props.onSelectionChange,
      onSelectAllChange = props.onSelectAllChange,
      onInvertSelection = props.onInvertSelection,
      selectedProp = props.selected,
      defaultSelected = props.defaultSelected,
      sortable = props.sortable,
      sortDirectionsProp = props.sortDirections,
      defaultSortDirections = props.defaultSortDirections,
      onSortChange = props.onSortChange,
      resizable = props.resizable,
      useSmartOverflowXProp = props.useSmartOverflowX,
      borderCollapse = props.borderCollapse,
      ThInnerWrapper = props.ThInnerWrapper,
      _props$reorderable = props.reorderable,
      reorderable = _props$reorderable === undefined ? true : _props$reorderable,
      tableHeaderOverlayRender = props.tableHeaderOverlayRender,
      baseCellWidthProp = props.baseCellWidth,
      _props$allowInlinePro = props.allowInlinePropertySelection,
      allowInlinePropertySelection = _props$allowInlinePro === undefined ? true : _props$allowInlinePro,
      uniqueSelectionProperty = props.uniqueSelectionProperty,
      restrictionValue = props.restrictionValue;


  var useSmartOverflowX = resizable ? true : useSmartOverflowXProp;

  // eslint-disable-next-line no-nested-ternary
  var baseCellWidth = baseCellWidthProp !== undefined ? baseCellWidthProp : useSmartOverflowX && resizable /*  && display === 'block' */ ? 240 : undefined;

  var _useReducer = (0, _react.useReducer)(_reducer2.default, _extends({}, _reducer.initialState, {
    columns: model,
    baseCellWidth: baseCellWidth
  }, defaultSelected ? { selected: defaultSelected } : {})),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      _useReducer2$ = _useReducer2[0],
      cRectHeight = _useReducer2$.cRectHeight,
      columnsState = _useReducer2$.columns,
      isResizing = _useReducer2$.isResizing,
      pageX = _useReducer2$.pageX,
      isResizingProp = _useReducer2$.isResizingProp,
      isResizingNextProp = _useReducer2$.isResizingNextProp,
      currColWidth = _useReducer2$.currColWidth,
      nextColWidth = _useReducer2$.nextColWidth,
      hasBeenResizedOnce = _useReducer2$.hasBeenResizedOnce,
      isReordering = _useReducer2$.isReordering,
      display = _useReducer2$.display,
      extraColWidth = _useReducer2$.extraColWidth,
      selected = _useReducer2$.selected,
      dispatch = _useReducer2[1];
  // const [selected, setSelected] = useState(defaultSelected || []);


  var columns = allowInlinePropertySelection ? columnsState : model.map(function (x) {
    return _extends({}, x, {
      show: true,
      width: (columnsState.find(function (y) {
        return y.property === x.property;
      }) || {}).width || 240
    });
  });

  if (extraColWidth) {
    columns = [].concat(_toConsumableArray(columns), [{
      property: 'toString', // cheat
      displayName: _react2.default.createElement(
        _TextEllipsis2.default,
        { style: { userSelect: 'none', textOverflow: 'clip' } },
        '\xA0\xA0\xA0 \xA0\xA0\xA0 \xA0\xA0\xA0 \xA0\xA0\xA0'
      ),
      width: extraColWidth
    }]);
  }

  var setSelected = function setSelected(newSelected) {
    return dispatch((0, _actions.setSelected)(newSelected));
  };

  var setExtraColumnWidth = function setExtraColumnWidth(width) {
    return dispatch((0, _actions.setExtraColumnWidth)(width));
  };

  var setDisplay = function setDisplay(property) {
    return dispatch((0, _actions.setDisplay)(property));
  };

  var setColumns = function setColumns(property) {
    return dispatch((0, _actions.setColumns)(property));
  };
  var storeContentRectHeight = function storeContentRectHeight(property) {
    return dispatch((0, _actions.storeContentRectHeight)(property));
  };

  var showColumn = function showColumn(property) {
    return dispatch((0, _actions.showColumn)(property));
  };
  var hideColumn = function hideColumn(property) {
    return dispatch((0, _actions.hideColumn)(property));
  };

  var setIsReordering = function setIsReordering(payload) {
    return dispatch((0, _actions.setIsReordering)(payload));
  };
  var setColumOrder = function setColumOrder(payload) {
    return dispatch((0, _actions.setColumOrder)(payload));
  };
  var setIsResizing = function setIsResizing(payload) {
    return dispatch((0, _actions.setIsResizing)(payload));
  };

  var setColumnWidth = function setColumnWidth(_ref) {
    var property = _ref.property,
        width = _ref.width;
    return dispatch((0, _actions.setColumnWidth)({ property: property, width: width }));
  };

  var setCurrColumnWidth = function setCurrColumnWidth(width) {
    return dispatch((0, _actions.setCurrColumnWidth)(width));
  };
  var setNextColumnWidth = function setNextColumnWidth(width) {
    return dispatch((0, _actions.setNextColumnWidth)(width));
  };

  var allowInlinePropertySelectionMonitor = model.map(function (_ref2) {
    var property = _ref2.property;
    return property;
  }).join('');
  (0, _react.useEffect)(function () {
    if (!allowInlinePropertySelection) {
      setColumns(model.map(function (x) {
        return _extends({}, x, {
          show: true,
          width: (columnsState.find(function (y) {
            return y.property === x.property;
          }) || {}).width || 240
        });
      }));
      return function () {};
    }
    return function () {};
  }, [allowInlinePropertySelectionMonitor]);

  (0, _react.useEffect)(function () {
    setColumns(model.map(function (x) {
      return _extends({}, x, {
        show: true,
        width: (columnsState.find(function (y) {
          return y.property === x.property;
        }) || {}).width || 240
      });
    }));
  }, [model]);

  runWarnings(props);

  var hasCustomHeader = tableHeaderOverlayRender !== undefined;

  var onOnDocumentMouseUp = function onOnDocumentMouseUp() /* e */{
    setIsResizing({
      isResizing: false,
      pageX: undefined,
      currColWidth: undefined,
      nextColWidth: undefined,
      property: undefined
    });
    document.removeEventListener('mouseup', onOnDocumentMouseUp);
    document.body.style.cursor = 'inherit';
  };

  var onResizeStart = function onResizeStart(e, property) {
    // eslint-disable-next-line no-shadow
    var currCol = e.target.parentElement;
    // eslint-disable-next-line no-shadow

    var _currCol$getBoundingC = currCol.getBoundingClientRect(),
        currColWidth = _currCol$getBoundingC.width;

    var nextCol = currCol.nextElementSibling;
    // eslint-disable-next-line no-shadow

    var _ref3 = nextCol ? nextCol.getBoundingClientRect() : {},
        nextColWidth = _ref3.width;

    var payload = {
      isResizing: true,
      property: property,
      pageX: e.pageX,
      currColWidth: currColWidth,
      nextColWidth: nextCol ? nextColWidth : undefined
    };

    setIsResizing(payload);

    document.addEventListener('mouseup', onOnDocumentMouseUp);

    document.body.style.cursor = 'col-resize';
  };

  var onOnDocumentMouseMoveHandler = function onOnDocumentMouseMoveHandler(e) {
    if (isResizing) {
      var diffX = e.pageX - pageX;
      if (display === 'table' && isResizingNextProp) {
        var v = nextColWidth - diffX;
        setNextColumnWidth(v < minCellWidth ? minCellWidth : v);
      }
      var newVal = currColWidth + diffX;
      setCurrColumnWidth(newVal < minCellWidth ? minCellWidth : newVal);
    }
  };

  (0, _react.useEffect)(function () {
    if (isResizing) {
      var debounceListener = (0, _debounce2.default)(onOnDocumentMouseMoveHandler, 16, { maxWait: 16, leading: true, trailing: true });

      document.addEventListener('mousemove', debounceListener);

      return function () {
        debounceListener.flush();
        document.removeEventListener('mousemove', debounceListener);
      };
    }
    return function () {};
  }, [isResizing]);

  (0, _react.useEffect)(function () {
    if (isResizing) {
      var listener = function listener(event) {
        onOnDocumentMouseUp(event);
      };

      document.addEventListener('mouseup', listener);

      return function () {
        document.removeEventListener('mouseup', listener);
      };
    }
    return function () {};
  }, [isResizing, onOnDocumentMouseUp]);

  var onDragTableHeaderStart = function onDragTableHeaderStart(index /* , ref */) {
    setIsReordering(index);
  };

  var onDropTableHeader = function onDropTableHeader() {
    setIsReordering(null);
  };

  /* Sort */
  var isSortControlled = selectedProp !== undefined;

  var _useState = (0, _react.useState)(defaultSortDirections
  // || (sortable ? columnsOrder.map(({ property }) => ({ property })) : [])
  || (sortable ? model.map(function (_ref4) {
    var property = _ref4.property;
    return { property: property };
  }) : [])),
      _useState2 = _slicedToArray(_useState, 2),
      sortDirections = _useState2[0],
      setSortDirections = _useState2[1];

  var actualSortDirections = isSortControlled ? sortDirectionsProp : sortDirections;
  var handleSortChange = function handleSortChange(property, sortDirection) {
    var newSortDirections = actualSortDirections.map(function (sortModel) {
      return _extends({}, sortModel, sortModel.property === property ? { sortDirection: sortDirection } : {});
    });
    if (!isSortControlled) {
      setSortDirections(newSortDirections);
    }
    onSortChange(property, sortDirection, newSortDirections);
  };

  /* selection */
  var isSelectionControlled = selectedProp !== undefined;
  // const [selected, setSelected] = useState(defaultSelected || []);
  var actualSelected = isSelectionControlled ? selectedProp : selected;
  var onToggleSelectAll = function onToggleSelectAll(checked) {
    var newSelected = checked ? data.map(function (_, i) {
      return i;
    }) : [];
    if (!isSelectionControlled) {
      setSelected(newSelected);
    }
    onSelectAllChange(checked);
  };
  var onInvertSelectionHandler = function onInvertSelectionHandler() {
    var newSelected = data.filter(function (x) {
      return !actualSelected.includes(x[propertyKey]);
    }).map(function (x) {
      return x[propertyKey];
    });

    if (!isSelectionControlled) {
      setSelected(newSelected);
    }
    // onSelectAllChange(checked);
    onInvertSelection(newSelected);
  };
  var onToggle = function onToggle(checked, entityPropertyKeyValue) {
    var newSelected = checked ? [].concat(_toConsumableArray(actualSelected), [entityPropertyKeyValue]) : actualSelected.filter(function (x) {
      return x !== entityPropertyKeyValue;
    });

    if (!isSelectionControlled) {
      setSelected(newSelected);
    }

    onSelectionChange(checked, entityPropertyKeyValue, newSelected);
  };

  return _react2.default.createElement(
    _DataGridSmartOverflowXWrapper2.default,
    {
      selectable: selectable,
      extraColWidth: extraColWidth,
      setExtraColumnWidth: setExtraColumnWidth,
      hasBeenResizedOnce: hasBeenResizedOnce,
      isResizing: isResizing,
      useSmartOverflowX: useSmartOverflowX,
      setDisplay: setDisplay,
      display: display,
      columns: columns,
      columnsSizes: columns.map(function (_ref5) {
        var width = _ref5.width;
        return width;
      }),
      storeContentRectHeight: storeContentRectHeight,
      cRectHeight: cRectHeight
    },
    _react2.default.createElement(
      _Table2.default,
      {
        borderCollapse: borderCollapse,
        isResizing: isResizing,
        isReordering: isReordering
      },
      _react2.default.createElement(
        'thead',
        hasCustomHeader ? { position: 'relative' } : {},
        _react2.default.createElement(
          _Tr2.default,
          null,
          multiSelectable || selectable ? _react2.default.createElement(
            _Th2.default,
            {
              isCheckboxCell: true,
              selected: actualSelected,
              key: 'select-checkbox-cell',
              ThInnerWrapper: function ThInnerWrapper(_ref6) {
                var children = _ref6.children;
                return _react2.default.createElement(
                  _Flex.Flex,
                  null,
                  children
                );
              },
              resizable: false,
              reorderable: false,
              style: { width: cellHeight, maxWidth: cellHeight }
            },
            _react2.default.createElement(
              _Flex.Flex,
              { style: { width: '100%', height: '100%' } },

              /* eslint-disable no-nested-ternary */
              multiSelectable ? actualSelected.length === data.length ? _react2.default.createElement(_Checkbox2.default, {
                id: 'DataGridMultiSelectCheckBox',
                name: 'DataGridMultiSelectCheckBox',
                onChange: function onChange(evt, checked) {
                  return onToggleSelectAll(checked);
                },
                checked: true
              }) : actualSelected.length === 0 ? _react2.default.createElement(_Checkbox2.default, {
                id: 'DataGridMultiSelectCheckBox',
                name: 'DataGridMultiSelectCheckBox',
                onChange: function onChange(evt, checked) {
                  return onToggleSelectAll(checked);
                },
                checked: false
              }) : _react2.default.createElement(
                _UnstyledButton.UnstyledButton,
                { onClick: function onClick() {
                    onInvertSelectionHandler();
                  } },
                _react2.default.createElement(
                  _Flex.Flex,
                  { style: { width: '100%', height: '100%', position: 'relative' } },
                  _react2.default.createElement(_Checkboxoutline2.default, null),
                  _react2.default.createElement(
                    _Flex.Flex,
                    { style: { fontSize: '32px', position: 'absolute', top: '-2.5px', left: 0, width: '100%', height: '100%' } },
                    '-'
                  )
                )
              ) : null
              /* eslint-enable no-nested-ternary */

            )
          ) : null,

          // (columnsOrder).map((m, i, { length }) => {
          columns.filter(function (c) {
            return !c.hide;
          }).map(function (m, i, _ref7) {
            var length = _ref7.length;

            var resizeProps = resizable /* && (i < (length - 1)) */
            ? {
              onResizeStart: onResizeStart,
              onResizeStop: function onResizeStop() {
                return (/* e */onOnDocumentMouseUp()
                );
              },
              resizable: true,
              columnWidth: m.width
            } : {
              columnWidth: m.width
            };

            var sortModel = (actualSortDirections || []).find(function (_ref8) {
              var property = _ref8.property;
              return property === m.property;
            });

            var sortProps = sortable && sortModel ? {
              onSortChange: function onSortChange() {
                return handleSortChange(m.property, toggleSORTS((sortModel || {}).sortDirection));
              },
              sortable: true,
              sortDirection: (sortModel || {}).sortDirection
            } : {};

            var reorderingProps = {
              reorderable: reorderable,
              setColumOrder: setColumOrder,
              isReordering: isReordering,
              onDragTableHeaderStart: onDragTableHeaderStart,
              onDropTableHeader: onDropTableHeader
            };

            var thTitle = isString(m.displayName) ? m.displayName : m.property;

            return _react2.default.createElement(
              _Th2.default,
              _extends({
                cRectHeight: cRectHeight,
                allowInlinePropertySelection: allowInlinePropertySelection,
                display: display,
                property: m.property,
                setInitialSize: function setInitialSize(width) {
                  if (resizable) {
                    var res = width < baseCellWidth ? baseCellWidth : width;
                    setColumnWidth({ property: m.property, width: res });
                  }
                },
                model: columns,
                showColumn: showColumn,
                hideColumn: hideColumn,
                data: data,
                isResizing: isResizing,
                isBeingResized: !!(m.property === isResizingProp),
                isBeingResizedBySibling: !!(m.property === isResizingNextProp),
                isReordering: isReordering,
                menuDescriptor: m.menuDescriptor,
                menu: m.menu,
                index: i,
                key: i,
                isLast: i === length - 1
              }, resizeProps, sortProps, reorderingProps, {
                ThInnerWrapper: ThInnerWrapper,
                dragId: m.property
              }),
              m.property === 'toString' ? m.displayName : _react2.default.createElement(
                _TextEllipsis2.default,
                { title: thTitle },
                m.displayName
              )
            );
          })
        ),
        hasCustomHeader ? tableHeaderOverlayRender({
          data: data,
          model: model,
          selected: actualSelected,
          sortDirections: actualSortDirections
        }) : null
      ),
      _react2.default.createElement(
        'tbody',
        null,
        data.map(function (entity, i) {
          var isSelected = actualSelected.indexOf(entity[propertyKey]) > -1;
          var propertyKeyIndex = entity && entity[propertyKey] ? entity[propertyKey] : i;

          var disabled = false;

          if (uniqueSelectionProperty && restrictionValue) {
            var valueForRestrictionProperty = (entity || {})[uniqueSelectionProperty];
            disabled = (multiSelectable || selectable) && valueForRestrictionProperty !== restrictionValue;
          }

          return _react2.default.createElement(
            _Tr2.default,
            {
              key: propertyKeyIndex,
              selected: isSelected
            },
            multiSelectable || selectable ? _react2.default.createElement(
              _Td2.default,
              {
                key: 'checkbox-select-cell' + (isSelected ? '-selected' : ''),
                selected: actualSelected
              },
              _react2.default.createElement(
                _TdInnerWrapper2.default,
                { style: { justifyContent: 'center', padding: '0 8px' } },
                _react2.default.createElement(_Checkbox2.default, {
                  id: i,
                  name: i,
                  disabled: disabled,
                  onChange: function onChange(evt, checked) {
                    return onToggle(checked, entity[propertyKey]);
                  },
                  checked: isSelected
                })
              )
            ) : null,
            columns.filter(function (c) {
              return !c.hide;
            }).map(function () {
              var m = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
              var idx = arguments[1];
              var filteredColumns = arguments[2];

              var sizeProps = hasBeenResizedOnce && resizable && m.width !== undefined && columns.filter(function (c) {
                return !c.hide;
              }).length > 1 ? {
                style: {
                  width: m.width,
                  minWidth: m.width,
                  maxWidth: m.width
                }
              } : {};

              var mComp = m.Component ? _react2.default.createElement(m.Component, entity) : null;

              var cellContent = _react2.default.createElement(
                _TdInnerWrapper2.default,
                sizeProps,
                _react2.default.createElement(
                  'span',
                  {
                    style: {
                      maxWidth: 'calc(100% - 8px)',
                      width: '100%',
                      minWidth: '1px',
                      boxSizing: 'border-box'
                    }
                  },
                  _react2.default.createElement(
                    _Flex.Flex,
                    {
                      style: {
                        justifyContent: 'flex-start',
                        flexFlow: 'row nowrap',
                        maxWidth: '100%',
                        boxSizing: 'border-box'
                      }
                    },
                    m.Component !== undefined ? mComp : _react2.default.createElement(
                      _Flex.Flex,
                      { style: { minWidth: '1px', flexGrow: 1, flexShrink: 999, justifyContent: 'flex-start' } },
                      _react2.default.createElement(
                        _TextEllipsis2.default,
                        { title: entity[m.property] },
                        entity[m.property]
                      )
                    )
                  )
                )
              );

              var cellDetail = m.CellDetail !== undefined ? _react2.default.createElement(m.CellDetail, entity) : null;

              var finalCellContent = cellDetail && !isResizing ? _react2.default.createElement(_CellWithPopOver2.default, { cellContent: cellContent, cellDetail: cellDetail }) : cellContent;

              return _react2.default.createElement(
                _Td2.default,
                {
                  allowInlinePropertySelection: allowInlinePropertySelection,
                  key: idx,
                  columns: columns,
                  mComp: mComp,
                  Component: m.Component,
                  columnSize: m.width,
                  columnOrder: filteredColumns[idx],
                  filteredColumns: filteredColumns,
                  isResizing: isResizing,
                  isBeingResized: !!(m.property === isResizingProp),
                  isBeingResizedBySibling: !!(m.property === isResizingNextProp)
                },
                finalCellContent
              );
            })
          );
        })
      )
    )
  );
};

/* eslint-disable no-unused-vars */
DataGrid.defaultProps = {
  propertyKey: 'id',

  model: undefined,
  data: [],

  selectable: false,
  selected: undefined,
  defaultSelected: undefined,
  onSelectionChange: function onSelectionChange(checked, entityId, selected) {},
  onSelectAllChange: function onSelectAllChange(selectAllChecked) {},

  reorderable: false,
  sortable: false,
  sortDirections: undefined,
  defaultSortDirections: undefined,
  // eslint-disable-next-line max-len
  onSortChange: function onSortChange(property, sortDirection, newSortDirections) {},

  resizable: false,
  borderCollapse: 'collapse',
  defaultColumnsSizes: undefined,
  useSmartOverflowX: false,

  ThInnerWrapper: _ThInnerWrapper2.default
};
/* eslint-enable no-unused-vars */

DataGrid.displayName = 'DataGridv2';

exports.default = DataGrid;