'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  &, & * {\n    box-sizing: border-box !important;\n  }\n  display: flex;\n  table {\n    display: ', ';\n    width: 100%;\n  }\n'], ['\n  &, & * {\n    box-sizing: border-box !important;\n  }\n  display: flex;\n  table {\n    display: ', ';\n    width: 100%;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _useResizeObserver = require('../hooks/useResizeObserver');

var _useResizeObserver2 = _interopRequireDefault(_useResizeObserver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// const scrollBarOffset = 20;
var selectableCellWidth = 50;

var DataGridSmartOverflowXWrapperUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var display = _ref.display;
  return display;
});

var DataGridSmartOverflowXWrapper = function DataGridSmartOverflowXWrapper(props) {
  var storeContentRectHeight = props.storeContentRectHeight,
      setExtraColumnWidth = props.setExtraColumnWidth,
      extraColWidth = props.extraColWidth,
      cRectHeight = props.cRectHeight,
      columnsSizes = props.columnsSizes,
      useSmartOverflowX = props.useSmartOverflowX,
      children = props.children,
      setDisplay = props.setDisplay,
      display = props.display,
      hasBeenResizedOnce = props.hasBeenResizedOnce,
      columns = props.columns,
      selectable = props.selectable;


  var ref = (0, _react.useRef)();

  (0, _useResizeObserver2.default)([ref, columnsSizes], function (contentRect) {
    // if (isResizing) { return; }
    // if (isReordering) { return; }

    var table = ref && ref.current ? ref.current.querySelector('table') : {};
    table.setAttribute('style', 'display: table; width: auto;');

    var _ref2 = table.getBoundingClientRect ? table.getBoundingClientRect() : { width: 0 },
        tableWidth = _ref2.width;

    // do not create a bad cyclic deps
    // check that we doo not take the extraol into accounot to calc
    // the diff for table/block selection
    // columns
    // const last = columns[columns.length - 1]


    var height = contentRect.height,
        containerWidth = contentRect.width;


    var mainDiff = containerWidth - tableWidth;
    var displayVal = mainDiff >= 0 ? 'table' : 'block';
    table.setAttribute('style', '');

    // const lastTh = table.querySelector('th:last-of-type');
    var widthsSum = columns.filter(function (x) {
      return !x.hide && x.property !== 'toString';
    }).reduce(function (a, _ref3) {
      var width = _ref3.width;
      return a + width;
    }, 0);
    if (selectable) {
      widthsSum += selectableCellWidth;
      // const extraColTh = (ref && ref.current) ? ref.current.querySelector('th:last') : {};
    }
    var actualExtraCollWidth = tableWidth - widthsSum;
    //   ? lastTh.getBoundingClientRect()
    //   : { width: 0 };

    if (actualExtraCollWidth) {
      tableWidth -= actualExtraCollWidth;
      // const extraColTh = (ref && ref.current) ? ref.current.querySelector('th:last') : {};
    }

    if (useSmartOverflowX) {
      if (hasBeenResizedOnce) {
        var d = containerWidth - tableWidth;
        // const offset = columns
        //  .filter(x => !x.hide).length - 1; // numbers of fences, not pickets;
        var offset = 4;
        var diff = d - offset > 0 ? d - offset : null; // like in the reducer
        if (extraColWidth !== diff) {
          // if (diff > 0 && extraColWidth > 0 && extraColWidth !== diff) {
          setExtraColumnWidth(diff);
          // }
          // setDisplay('block');
        }

        if (display !== 'block') {
          setDisplay('block');
        }
        return;
      }

      if (display !== displayVal) {
        setDisplay(displayVal);
      }
      var heightChanged = cRectHeight !== height;

      if (heightChanged) {
        storeContentRectHeight(
        // Substract scroll bar width, if needed, to remove a useless spacing
        // that would create a useless scrolling context
        // this only serves as a way to get a nice drag ghost,
        // a couple missing PX are not a big issue,
        // where a couple too much create the aforementioned issue
        // displayVal === 'block'
        //   // ? height - 17 // largest registered scrollbarWidth (https://bit.ly/2UBdiFz)
        //   ? height - scrollBarOffset // Lett's justt make sure we're good here
        //   : height
        height);
      }
    }
  });

  return _react2.default.createElement(
    DataGridSmartOverflowXWrapperUI,
    { ref: ref, display: display },
    children
  );
};

exports.default = DataGridSmartOverflowXWrapper;