'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  flex-flow: row nowrap;\n  align-items: stretch;\n  white-space: nowrap;\n  padding: 0 0 0 16px;\n  width: 100%;\n  width: auto;\n  box-sizing : border-box;\n  ', ';\n  ', ';\n  height: 100%;\n  /* width: calc(100% - 8px); */\n  ', ';\n'], ['\n  display: flex;\n  flex-flow: row nowrap;\n  align-items: stretch;\n  white-space: nowrap;\n  padding: 0 0 0 16px;\n  width: 100%;\n  width: auto;\n  box-sizing : border-box;\n  ', ';\n  ', ';\n  height: 100%;\n  /* width: calc(100% - 8px); */\n  ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['padding-right: 8px;'], ['padding-right: 8px;']),
    _templateObject3 = _taggedTemplateLiteral(['cursor: ew-resize;'], ['cursor: ew-resize;']),
    _templateObject4 = _taggedTemplateLiteral(['width: calc(100% - 8px);'], ['width: calc(100% - 8px);']),
    _templateObject5 = _taggedTemplateLiteral(['width: calc(100%); max-width: calc(100%); padding: 0;'], ['width: calc(100%); max-width: calc(100%); padding: 0;']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _reactDnd = require('react-dnd');

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ThInnerWrapperUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var resizable = _ref.resizable;
  return resizable ? (0, _styledComponents.css)(_templateObject2) : '';
}, function (_ref2) {
  var reorderable = _ref2.reorderable,
      canDrag = _ref2.canDrag;
  return reorderable && canDrag ? (0, _styledComponents.css)(_templateObject3) : '';
}, function (_ref3) {
  var dragId = _ref3.dragId;
  return dragId !== 'toString' ? (0, _styledComponents.css)(_templateObject4) : (0, _styledComponents.css)(_templateObject5);
});

var ThInnerWrapper = function ThInnerWrapper(props) {
  var isResizing = props.isResizing,
      onDragTableHeaderStart = props.onDragTableHeaderStart,
      onDropTableHeader = props.onDropTableHeader,
      setColumOrder = props.setColumOrder,
      index = props.index,
      dragId = props.dragId,
      reorderable = props.reorderable,
      canDrag = props.canDrag;


  var ref = (0, _react.useRef)(null);

  var _useDrop = (0, _reactDnd.useDrop)({
    accept: 'my-foobar-type',
    hover: (0, _debounce2.default)(function (item, monitor) {
      if (!ref.current || isResizing) {
        return;
      }

      var dragIndex = item.index;
      var itemDragId = item.dragId;
      var hoverIndex = index;
      var itemHoverId = dragId;

      if (itemDragId === itemHoverId) {
        return;
      }

      var _ref$current$getBound = ref.current.getBoundingClientRect(),
          left = _ref$current$getBound.left,
          width = _ref$current$getBound.width;

      var hoverMiddleX = width / 2;

      var _ref4 = monitor.getClientOffset() || {},
          _ref4$x = _ref4.x,
          x = _ref4$x === undefined ? 0 : _ref4$x;

      var isDragingRight = dragIndex < hoverIndex;

      var hoverClientX = x - left;

      if (isDragingRight && hoverClientX > hoverMiddleX || hoverClientX < hoverMiddleX) {
        setColumOrder([itemDragId, itemHoverId]);
        // Note: we're mutating the monitor item here!
        // Generally it's better to avoid mutations,
        // but it's good here for the sake of performance
        // to avoid expensive index searches.
        // eslint-disable-next-line no-param-reassign
        item.index = hoverIndex;
      }
    }, 16, { maxWait: 32, leading: true, trailing: true })
  }),
      _useDrop2 = _slicedToArray(_useDrop, 2),
      drop = _useDrop2[1];

  var _useDrag = (0, _reactDnd.useDrag)({
    item: {
      type: 'my-foobar-type',
      dragId: dragId,
      index: index,
      options: {
        canDrag: canDrag
      }
    },
    // eslint-disable-next-line consistent-return
    begin: function begin() /* monitor */{
      if (!ref.current || isResizing || !canDrag) {
        // return drop(ref);
        return;
      }
      onDragTableHeaderStart(index, ref);
    },
    end: function end() /* monitor */{
      onDropTableHeader();
    }
  }),
      _useDrag2 = _slicedToArray(_useDrag, 2),
      drag = _useDrag2[1];

  // disable DnD when we resize, and to be sure call drop


  (0, _react.useEffect)(function () {
    if (isResizing) {
      drop(ref);
      return function () {
        if (reorderable) {
          drag(drop(ref));
        }
      };
    }
    if (reorderable) {
      drag(drop(ref));
    }
    return function () {
      drop(ref);
    };
  }, [isResizing]);

  return _react2.default.createElement(ThInnerWrapperUI, _extends({}, props, {
    ref: isResizing || !canDrag ? null : ref
  }));
};

ThInnerWrapper.displayName = 'ThInnerWrapper';

exports.default = ThInnerWrapper;