'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Dialog = require('./Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _DivPadding = require('../Base/DivPadding');

var _DivPadding2 = _interopRequireDefault(_DivPadding);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line  import/no-named-as-default

var ConfirmDialog = function ConfirmDialog(_ref) {
  var show = _ref.show,
      onConfirm = _ref.onConfirm,
      onCancel = _ref.onCancel,
      _ref$text = _ref.text,
      text = _ref$text === undefined ? 'Are you sure ?' : _ref$text,
      _ref$confirmLabel = _ref.confirmLabel,
      confirmLabel = _ref$confirmLabel === undefined ? 'Confirm' : _ref$confirmLabel,
      _ref$cancelLabel = _ref.cancelLabel,
      cancelLabel = _ref$cancelLabel === undefined ? 'Cancel' : _ref$cancelLabel;
  return _react2.default.createElement(
    _Dialog2.default,
    { show: show, modal: true, style: { maxWidth: '400px' } },
    _react2.default.createElement(
      _DivPadding2.default,
      { padding: 'M', style: { textAlign: 'center' } },
      _react2.default.createElement(
        'div',
        null,
        text
      ),
      _react2.default.createElement(
        'div',
        { style: { marginTop: '30px' } },
        _react2.default.createElement(
          _Button2.default,
          { style: { marginRight: '5px' }, onClick: onConfirm, type: 'primary' },
          confirmLabel
        ),
        _react2.default.createElement(
          _Button2.default,
          { style: { marginLeft: '5px' }, onClick: onCancel },
          cancelLabel
        )
      )
    )
  );
};

exports.default = ConfirmDialog;