'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  z-index: 999;\n  position: fixed;\n  top: 10vh;\n  width: calc(100% - 20vw);\n  max-width: 700px;\n  max-height: 80vh;\n  margin: 0 auto;\n  bottom: auto;\n  left: 10vw;\n  right: 10vw;\n  backface-visibility: hidden;\n  background: #fff;\n  border-radius: ', ';\n\n  /* overflow: hidden; */\n  box-shadow:\n    rgba(0, 0, 0, 0.5) 0px 1px 6px,\n    rgba(0, 0, 0, 0.2) 0px 4px 16px;\n  box-shadow:\n    rgba(0, 0, 0, 0.3) 0px 2px 21px 1px,\n    rgba(0,0,0,0.2) 0px 1px 22px 4px;\n\n  ', '\n  ', '\n'], ['\n  z-index: 999;\n  position: fixed;\n  top: 10vh;\n  width: calc(100% - 20vw);\n  max-width: 700px;\n  max-height: 80vh;\n  margin: 0 auto;\n  bottom: auto;\n  left: 10vw;\n  right: 10vw;\n  backface-visibility: hidden;\n  background: #fff;\n  border-radius: ', ';\n\n  /* overflow: hidden; */\n  box-shadow:\n    rgba(0, 0, 0, 0.5) 0px 1px 6px,\n    rgba(0, 0, 0, 0.2) 0px 4px 16px;\n  box-shadow:\n    rgba(0, 0, 0, 0.3) 0px 2px 21px 1px,\n    rgba(0,0,0,0.2) 0px 1px 22px 4px;\n\n  ', '\n  ', '\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Modal = require('../internal/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _defaults = require('../Panel/defaults');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var DialogUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var radius = _ref.theme.radius;
  return radius;
}, function (_ref2) {
  var isFullWidth = _ref2.isFullWidth;
  return isFullWidth && '\n    max-width: 80vw;\n  ';
}, function (_ref3) {
  var isFullScreen = _ref3.isFullScreen;
  return isFullScreen && '\n    max-width: 92vw;\n    width: calc(100% - 8vw);\n    max-height: 92vh;\n    height: 100%;\n    left: 4vw;\n    right: 4vw;\n    top: 4vh;\n  ';
});

/**
 *
 * If we have a PanelContent in the Dialog, apply dialog style to penl content:
 * maxHeight: 'calc(80vh - calc( 2 * 50px ))'
 * This assume panelHeader and PanelFooter are present
 */
var Dialog = function Dialog(_ref4) {
  var show = _ref4.show,
      modal = _ref4.modal,
      onClose = _ref4.onClose,
      children = _ref4.children,
      style = _ref4.style,
      isFullWidth = _ref4.isFullWidth,
      isFullScreen = _ref4.isFullScreen;

  var extendedChildren = _react2.default.Children.map(children, function (c, index) {
    var childExtendedChildren = _react2.default.Children.map(c.props.children, function (childChildren) {
      if (childChildren && childChildren.type && childChildren.type.displayName === 'PanelContent') {
        var baseHeight = '80vh';
        if (isFullScreen) {
          baseHeight = '92vh';
        }

        return _react2.default.cloneElement(childChildren, _extends({}, childChildren.props || {}, {
          style: _extends({
            maxHeight: 'calc(' + baseHeight + ' - (' + _defaults.headerHeight + ' + ' + _defaults.footerHeight + '))' }, childChildren.props.style)
        }));
      }
      return childChildren;
    });

    return _react2.default.cloneElement(c, _extends({
      key: 'dialogContent-' + index,
      onClose: onClose,
      style: _extends({}, c && c.props && c.props.style ? c.props.style : {})
    }, c.props || {}, c.type.displayName === 'Panel' ? { rounded: true } : {}, {
      children: childExtendedChildren
    }));
  });

  return _react2.default.createElement(
    _Modal2.default,
    {
      show: show,
      onClose: modal ? null : onClose
    },
    _react2.default.createElement(
      DialogUI,
      { style: style, isFullScreen: isFullScreen, isFullWidth: isFullWidth },
      extendedChildren
    )
  );
};

Dialog.displayName = 'Dialog';

Dialog.defaultProps = {
  isFullScreen: false,
  isFullWidth: false
};

exports.default = Dialog;