'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ThemeComponent2 = require('../Base/ThemeComponent');

var _ThemeComponent3 = _interopRequireDefault(_ThemeComponent2);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// eslint-disable-line import/no-named-as-default

var DialogFooterStyle = {
  root: {
    padding: '10px 15px',
    borderTop: '1px solid rgb(204, 204, 204)',
    background: '#cccccc1f',
    borderBottomLeftRadius: '2px',
    borderBottompRightRadius: '2px',
    display: 'flex'
  },
  actions: {
    flex: 1,
    textAlign: 'right'
  },
  cancel: {
    paddingLeft: '10px',
    textAlign: 'right'
  }
};

var DialogFooter = function (_ThemeComponent) {
  _inherits(DialogFooter, _ThemeComponent);

  function DialogFooter() {
    _classCallCheck(this, DialogFooter);

    return _possibleConstructorReturn(this, (DialogFooter.__proto__ || Object.getPrototypeOf(DialogFooter)).apply(this, arguments));
  }

  _createClass(DialogFooter, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          hasCancel = _props.hasCancel,
          cancelLabel = _props.cancelLabel,
          onClose = _props.onClose;

      var mainMergedStyle = this.getStyle('DialogHeader', DialogFooterStyle.root);
      return _react2.default.createElement(
        'div',
        { style: mainMergedStyle },
        _react2.default.createElement(
          'div',
          { style: DialogFooterStyle.actions },
          children
        ),
        hasCancel && _react2.default.createElement(
          'div',
          { style: DialogFooterStyle.cancel },
          _react2.default.createElement(
            _Button2.default,
            { onClick: onClose },
            cancelLabel || 'Cancel'
          )
        )
      );
    }
  }]);

  return DialogFooter;
}(_ThemeComponent3.default);

DialogFooter.defaultProps = {
  hasCancel: true
};

exports.default = DialogFooter;