'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ConfirmDialog = require('./ConfirmDialog');

var _ConfirmDialog2 = _interopRequireDefault(_ConfirmDialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WithConfirmDialogHOC = function WithConfirmDialogHOC(Comp) {
  var WithConfirmDialog = function (_Component) {
    _inherits(WithConfirmDialog, _Component);

    function WithConfirmDialog(props) {
      _classCallCheck(this, WithConfirmDialog);

      var _this = _possibleConstructorReturn(this, (WithConfirmDialog.__proto__ || Object.getPrototypeOf(WithConfirmDialog)).call(this, props));

      _this.state = { showDialog: false };

      _this.handleConfirm = _this.handleConfirm.bind(_this);
      _this.handleCancel = _this.handleCancel.bind(_this);
      return _this;
    }

    _createClass(WithConfirmDialog, [{
      key: 'handleConfirm',
      value: function handleConfirm() {
        var onClick = this.props.onClick;

        this.setState({ showDialog: false });
        if (onClick) {
          onClick();
        }
      }
    }, {
      key: 'handleCancel',
      value: function handleCancel() {
        var onCancel = this.props.onCancel;

        this.setState({ showDialog: false });
        if (onCancel) {
          onCancel();
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props,
            confirmText = _props.confirmText,
            confirmLabel = _props.confirmLabel,
            cancelLabel = _props.cancelLabel;
        var showDialog = this.state.showDialog;


        return [_react2.default.createElement(Comp, _extends({}, this.props, {
          onClick: function onClick() {
            _this2.setState({ showDialog: true });
          },
          key: 'Component'
        })), _react2.default.createElement(_ConfirmDialog2.default, {
          key: 'confirm-dialog',
          show: showDialog,
          onConfirm: this.handleConfirm,
          onCancel: this.handleCancel,
          text: confirmText,
          confirmLabel: confirmLabel,
          cancelLabel: cancelLabel
        })];
      }
    }]);

    return WithConfirmDialog;
  }(_react.Component);

  return WithConfirmDialog;
};

exports.default = WithConfirmDialogHOC;