'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  pointer-events: all;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  min-width: 280px;\n  width: 500px;\n  max-width: 100vw;\n  background: #fff;\n\n  box-shadow: box-shadow: 0px 3px 10px rgba(0, 0, 0, 0) , 0px 3px 10px rgba(0, 0, 0, 0);\n\n\n  ', ';\n  /* height | width */\n  ', ';\n\n  /* top&bottom | right&left */\n  ', ';\n  &>*:last-child { ', ' }\n'], ['\n  pointer-events: all;\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  min-width: 280px;\n  width: 500px;\n  max-width: 100vw;\n  background: #fff;\n\n  box-shadow: box-shadow: 0px 3px 10px rgba(0, 0, 0, 0) , 0px 3px 10px rgba(0, 0, 0, 0);\n\n\n  ', ';\n  /* height | width */\n  ', ';\n\n  /* top&bottom | right&left */\n  ', ';\n  &>*:last-child { ', ' }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Modal = require('../internal/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _Slide = require('../internal/Slide');

var _Slide2 = _interopRequireDefault(_Slide);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // @inheritedComponent Modal

function getSlideDirection(anchor) {
  if (anchor === 'left') {
    return 'right';
  } else if (anchor === 'right') {
    return 'left';
  } else if (anchor === 'top') {
    return 'bottom';
  }
  return 'top';
}

var slidesHorizontaly = function slidesHorizontaly(direction) {
  return direction === 'right' || direction === 'left';
};

var DrawerUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var isIn = _ref.inAttr,
      inline = _ref.inline;
  return isIn // eslint-disable-line no-nested-ternary
  ? inline ? 'none' : 'box-shadow: 0px 3px 10px rgba(0, 0, 0, 0.16) , 0px 3px 10px rgba(0, 0, 0, 0.23)' : '';
}, function (_ref2) {
  var dir = _ref2.dir;
  return slidesHorizontaly(dir) ? 'height: 100%' : 'width: 100%';
}, function (_ref3) {
  var dir = _ref3.dir;
  return slidesHorizontaly(dir) ? 'top: 0; bottom: 0' : 'left: 0; right: 0';
}, function (_ref4) {
  var dir = _ref4.dir,
      children = _ref4.children;
  return _react2.default.Children.count(children) >= 3 && slidesHorizontaly(dir) ? 'margin-top: auto' : '';
});

var Drawer = function (_React$Component) {
  _inherits(Drawer, _React$Component);

  function Drawer(props) {
    _classCallCheck(this, Drawer);

    var _this = _possibleConstructorReturn(this, (Drawer.__proto__ || Object.getPrototypeOf(Drawer)).call(this, props));

    _this.state = {
      // Let's assume that the Drawer will always be rendered on user space.
      // We use that state is order to skip the appear transition during the
      // initial mount of the component.
      firstMount: true
    };

    _this.handleEsc = _this.handleEsc.bind(_this);
    _this.storeRef = _this.storeRef.bind(_this);
    return _this;
  }

  _createClass(Drawer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          open = _props.open,
          isOpen = _props.isOpen;

      if (open || isOpen) {
        // this.attachKeyboardEventHandler();
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps() {
      this.setState({
        firstMount: false
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _props2 = this.props,
          isOpen = _props2.isOpen,
          open = _props2.open;


      if (prevProps.open !== open || prevProps.isOpen !== isOpen) {
        if (open || isOpen) {
          // this.attachKeyboardEventHandler();
          this.focusFirstFocusableIfAny();
        } else if (!open && !isOpen) {
          // this.detachKeyboardEventHandler();
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // this.detachKeyboardEventHandler();
    }
  }, {
    key: 'detachKeyboardEventHandler',
    value: function detachKeyboardEventHandler() {
      if (window) {
        window.removeEventListener('keyup', this.handleEsc);
      }
    }
  }, {
    key: 'attachKeyboardEventHandler',
    value: function attachKeyboardEventHandler() {
      if (window) {
        window.addEventListener('keyup', this.handleEsc);
      }
    }
  }, {
    key: 'handleEsc',
    value: function handleEsc(e) {
      var key = e.key;
      var onClose = this.props.onClose;

      if (onClose && key === 'Escape') {
        onClose();
      }
    }
  }, {
    key: 'focusFirstFocusableIfAny',
    value: function focusFirstFocusableIfAny() {
      if (this.ref) {
        if (this.ref.querySelector) {
          var target = this.ref.querySelector('*[tabIndex]');
          if (target && target.focus) {
            // noop
          } else if (this.ref && this.ref.focus) {
            target = this.ref;
          }

          var r = setTimeout(function () {
            if (target && target.focus) {
              target.focus();
            }
            clearTimeout(r);
          }, 10);
        }
      }
    }
  }, {
    key: 'storeRef',
    value: function storeRef(node) {
      this.ref = node;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          anchor = _props3.anchor,
          children = _props3.children,
          onClose = _props3.onClose,
          open = _props3.open,
          isOpen = _props3.isOpen,
          showOverlay = _props3.showOverlay,
          style = _props3.style,
          modal = _props3.modal,
          offsetTop = _props3.offsetTop,
          offsetBottom = _props3.offsetBottom,
          offsetLeft = _props3.offsetLeft,
          offsetRight = _props3.offsetRight,
          regional = _props3.regional,
          inline = _props3.inline;


      var keyboardKeyDownHandler = open || isOpen ? this.handleEsc : null;

      return _react2.default.createElement(
        'div',
        { ref: this.storeRef, onKeyDown: keyboardKeyDownHandler },
        _react2.default.createElement(
          _Slide2.default,
          {
            regional: regional,
            inline: inline,
            inAttr: open || isOpen,
            direction: getSlideDirection(anchor),
            appear: !this.state.firstMount,
            offsetTop: offsetTop,
            offsetBottom: offsetBottom,
            offsetLeft: offsetLeft,
            offsetRight: offsetRight
          },
          _react2.default.createElement(
            DrawerUI,
            {
              regional: regional,
              inline: inline,
              offsetTop: offsetTop,
              offsetBottom: offsetBottom,
              offsetLeft: offsetLeft,
              offsetRight: offsetRight,
              inAttr: open || isOpen,
              dir: getSlideDirection(anchor),
              style: style
            },
            _react2.default.Children.map(children, function (c, index) {
              return _react2.default.isValidElement(c) && _react2.default.cloneElement(c, _extends({
                key: 'Drawer-' + index,
                onClose: onClose,
                anchor: anchor
              }, c.props || {}));
            })
          )
        ),
        showOverlay ? _react2.default.createElement(_Modal2.default, {
          show: open || isOpen,
          onClose: modal ? null : onClose
        }) : null
      );
    }
  }]);

  return Drawer;
}(_react2.default.Component);

Drawer.propTypes = {
  anchor: _propTypes2.default.oneOf(['left', 'top', 'right', 'bottom']),
  children: _propTypes2.default.node,
  onClose: _propTypes2.default.func,
  /**
   * deprecated (use `isOpen`)
   */
  open: _propTypes2.default.bool,
  /**
   * favor over deprecated `open`
   */
  isOpen: _propTypes2.default.bool,
  showOverlay: _propTypes2.default.bool,
  // transitionDuration: PropTypes.oneOfType([
  //   PropTypes.number,
  //   PropTypes.shape({ enter: PropTypes.number, exit: PropTypes.number }),
  // ]), // not used
  offsetTop: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  offsetBottom: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  offsetRight: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  offsetLeft: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
};

Drawer.defaultProps = {
  anchor: 'right',
  open: false,
  isOpen: false,
  showOverlay: false,
  children: null,
  onClose: function onClose() {},
  // transitionDuration: 0,
  offsetTop: 0,
  offsetBottom: 0,
  offsetRight: 0,
  offsetLeft: 0
};

exports.default = Drawer;