'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _templateObject = _taggedTemplateLiteral([' left: 0; '], [' left: 0; ']),
    _templateObject2 = _taggedTemplateLiteral([' right: 0; '], [' right: 0; ']),
    _templateObject3 = _taggedTemplateLiteral(['\n      transform: translateX(-50%);\n      left: 50%;\n    '], ['\n      transform: translateX(-50%);\n      left: 50%;\n    ']),
    _templateObject4 = _taggedTemplateLiteral(['\n  z-index: 1;\n  width: 100%;\n  ', ';\n  min-width: 180px;\n  position: ', ';\n  top: 100%;\n'], ['\n  z-index: 1;\n  width: 100%;\n  ', ';\n  min-width: 180px;\n  position: ', ';\n  top: 100%;\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  ', ';\n  position: relative;\n  ', ' {\n    ', ';\n  }\n'], ['\n  ', ';\n  position: relative;\n  ', ' {\n    ', ';\n  }\n']),
    _templateObject6 = _taggedTemplateLiteral(['width: 100%; height: 100%;'], ['width: 100%; height: 100%;']),
    _templateObject7 = _taggedTemplateLiteral(['\n      display: ', ';\n      visibility: ', ';\n    '], ['\n      display: ', ';\n      visibility: ', ';\n    ']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _useClickOutside = require('../hooks/useClickOutside');

var _useClickOutside2 = _interopRequireDefault(_useClickOutside);

var _useOnEscKeyDown = require('../hooks/useOnEscKeyDown');

var _useOnEscKeyDown2 = _interopRequireDefault(_useOnEscKeyDown);

var _UnstyledButton = require('../Button/UnstyledButton1');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// import theme from '../../theme';


var getAnchorStyles = function getAnchorStyles(anchor) {
  if (anchor === 'left') {
    return (0, _styledComponents.css)(_templateObject);
  }
  if (anchor === 'right') {
    return (0, _styledComponents.css)(_templateObject2);
  }
  if (anchor === 'center') {
    return (0, _styledComponents.css)(_templateObject3);
  }
  return '';
};

var MenuWrapper = _styledComponents2.default.div(_templateObject4, function (_ref) {
  var anchor = _ref.anchor,
      inline = _ref.inline;
  return inline ? '' : getAnchorStyles(anchor);
}, function (_ref2) {
  var inline = _ref2.inline;
  return inline ? 'relative' : 'absolute';
});
// MenuWrapper.defaultProps = { theme };


var Wrapper = _styledComponents2.default.div(_templateObject5, function (_ref3) {
  var isFullWidth = _ref3.isFullWidth;
  return isFullWidth ? (0, _styledComponents.css)(_templateObject6) : '';
}, MenuWrapper, function (_ref4) {
  var isOpen = _ref4.isOpen;
  return (0, _styledComponents.css)(_templateObject7, isOpen ? 'block' : 'none', isOpen ? 'visible' : 'hidden');
});
// Wrapper.defaultProps = { theme };

var DropDown = function DropDown(props) {
  var trigger = props.trigger,
      box = props.box,
      open = props.open,
      defaultOpen = props.defaultOpen,
      onChange = props.onChange,
      anchor = props.anchor,
      inline = props.inline,
      style = props.style,
      menuStyle = props.menuStyle,
      light = props.light,
      isFullWidth = props.isFullWidth;

  var isControlled = open !== undefined;

  var _useState = (0, _react.useState)(defaultOpen),
      _useState2 = _slicedToArray(_useState, 2),
      visibility = _useState2[0],
      setVisibility = _useState2[1];

  var isOpen = isControlled ? open : visibility;

  var ref = (0, _react.useRef)();

  (0, _useClickOutside2.default)(ref, function (e) {
    if (isOpen) {
      if (!isControlled) {
        setVisibility(false);
      }
      onChange(false, e);
    }
  });

  (0, _useOnEscKeyDown2.default)(ref, function (e) {
    if (isOpen) {
      if (!isControlled) {
        setVisibility(false);
      }
      onChange(false, e);
    }
  });

  var onChangeHandler = function onChangeHandler() {
    var newVal = !isOpen;
    if (!isControlled) {
      setVisibility(newVal);
    }
    onChange(newVal);
  };

  return _react2.default.createElement(
    Wrapper,
    { className: 'uxi_DropDownWrapper', style: _extends({}, style), ref: ref, light: light, isFullWidth: isFullWidth, isOpen: isOpen },
    _react2.default.createElement(
      _UnstyledButton.UnstyledButton,
      {
        isFullWidth: isFullWidth,
        style: { height: '100%', width: '100%' },
        onClick: function onClick() {
          if (isControlled) {
            return onChangeHandler(!isOpen);
          }
          return setVisibility(!isOpen);
        }
      },
      trigger
    ),
    _react2.default.createElement(
      MenuWrapper,
      {
        inline: inline,
        menuStyle: menuStyle,
        anchor: anchor
      },
      box
    )
  );
};

DropDown.propTypes = {
  inline: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  menuStyle: _propTypes2.default.object,
  onChange: _propTypes2.default.func,
  open: _propTypes2.default.bool,
  defaultOpen: _propTypes2.default.bool,
  anchor: _propTypes2.default.oneOf(['center', 'left', 'right']),
  trigger: _propTypes2.default.any,
  box: _propTypes2.default.any,
  light: _propTypes2.default.bool
};

/* eslint-disable no-unused-vars */
DropDown.defaultProps = {
  inline: false,
  style: {},
  menuStyle: {},
  onChange: function onChange(isOpen, eventOrUndefined) {},
  open: undefined,
  defaultOpen: undefined,
  anchor: 'center', // one of 'center', 'left', 'right'
  trigger: '•••',
  box: 'Pass some content in the `box` props of DropDown',
  light: false
};

exports.default = DropDown;