'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 * convert a folder of SVGs to a folder of react components with an index
 * /root
 *    - _script.js
 *    - /svgs
 *        - loading.svg
 *        - ... .svg
 *
 * will output .js file in the root folder as well as an index.js
 * /root
 *    - /svgs (untouched)
 *    - _script.js
 *    — index.js
 *    - Loading.js
 *    - ... .js
 *
 * require prettier and eslint globally isntalled
 */
/* eslint-disable */
var fs = require('fs');

var _require = require('child_process'),
    exec = _require.exec;

var makeReducer = function makeReducer(taskRunner) {
  return function (tasksQueue, task) {
    return tasksQueue.then(function (chainResults) {
      return taskRunner(task).then(function (taskResult) {
        return [].concat(_toConsumableArray(chainResults), [taskResult]);
      });
    });
  };
};

var initialValue = Promise.resolve([]);

var mapPromiseSequentially = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(tasks, taskRunner) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log('mapPromiseSequentially', tasks);
            return _context.abrupt('return', tasks.reduce(makeReducer(taskRunner), initialValue));

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function mapPromiseSequentially(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var capitalize = function capitalize(x) {
  return x.charAt(0).toUpperCase() + x.slice(1);
};
var toLowerCase = function toLowerCase(x) {
  return x.toLowerCase();
};
var removeDashIco = function removeDashIco(x) {
  return x.replace('-ico', '');
};
var camelCaser = function camelCaser(match, p1, offset, string) {
  console.log('match', match);
  console.log('p1', p1);
  console.log('offset', offset);
  console.log('string', string);

  return p1.replace('-', '');
  // return capitalize(p1.replace('-', ''));
};
var toCamelCase = function toCamelCase(x) {
  return x.replace(/(-[a-z])/g, camelCaser)
  // .replace(/(-[a-z])/g, camelCaser)
  // .replace(/(-[a-z])/g, camelCaser)
  ;
};
var objToString = Object.prototype.toString;
var isFn = function isFn(x) {
  return objToString.call(x) === '[object Function]';
};
var addLinFeedToOpenningTag = function addLinFeedToOpenningTag(match, p1, offset, string) {
  return '\n ' + p1;
};
var cleanSVGContent = function cleanSVGContent(x) {
  return x.replace(/<defs>.*<\/defs>/g, '').replace(/<title>.*<\/title>/g, '').replace(/(class="cls-1")/g, '').replace(/(class="cls-1")/g, '').replace(/(class="cls-2")/g, '').replace(/(class="cls-2")/g, '')
  // .replace(/(<.*>)/g, '\n$&');
  .replace(/(<[^>]+>)/g, addLinFeedToOpenningTag)
  // .replace(/(viewBox=".*")/, '$& style={styles.svg} width="24px" height="24px"')
  .replace(/(viewBox=".*")/, '$& width="24px" height="24px"').replace(/(<svg)/, '<svg focusable="false" ') // IE 11 is the best
  .replace(/(style=".*")/g, ' ') // IE 11 is the best
  ;
};

var getRatio = function getRatio(string) {
  // this is so unstable
  var matches = string.match(/viewBox="(.*)"/)[1].split(' ').map(function (x) {
    return Number(x);
  }).filter(function (x) {
    return x;
  });

  console.log('||', matches);
  return (matches[1] / matches[0] * 100).toFixed(3);
};

var writeFile = function writeFile(x) {
  console.log('x', x);
  var finalFileName = cleanFileName(x).replace('.svg', '');
  console.log('finalFileName', finalFileName);

  var svgFileContent = fs.readFileSync('./svgs/' + x, 'utf8');

  var cleanedSvgFileContent = cleanSVGContent(svgFileContent);

  if (x.match(/gdpr/i)) {
    console.log('BEfore:');
    console.log(svgFileContent);
    console.log('after:');
    console.log(cleanedSvgFileContent);
  }

  // const ratio = getRatio(cleanedSvgFileContent);

  var content = template.replace('{{svg}}', cleanedSvgFileContent).replace(/{{name}}/g, finalFileName);
  // .replace('{{ratio}}', ratio);


  fs.writeFileSync(finalFileName + '.js', content);
  return finalFileName;
};

var getTestTemplate = function getTestTemplate(fileName) {
  return 'import React from \'react\';\nimport ' + fileName + ' from \'../' + fileName + '\';\n\ndescribe(\'Icon : <' + fileName + ' />\', () => {\n  it(\'match snapshot\', () => {\n    expect(shallow(<' + fileName + ' />)).toMatchSnapshot();\n  });\n});\n\n';
};
var writeFileTest = function writeFileTest(fileName) {
  exec('echo "' + getTestTemplate(fileName) + '" > ./__tests__/' + fileName + '.test.js', function (err, stdout, stderr) {
    if (err) {
      console.log(err);return false;
    }
    console.log('test written for ' + fileName);
  });
  return fileName;
};

var addFileToIndex = function addFileToIndex(x) {
  // const exportString = [
  //   `import ${x}Comp from './${x}';`
  //   `export const ${x} = ${x}Comp;`
  // ].join('\n')

  exec('echo "import ' + x + 'Comp from \'./' + x + '\'; export const ' + x + ' = ' + x + 'Comp; " >> index.js', function (err, stdout, stderr) {
    if (err) {
      console.log(err);return false;
    }
    console.log('good for ' + x);
  });
  return x;
};
/*
  const prettifyString = (x) => prettier.format(x);
*/
var prettifyFile = function prettifyFile(x) {
  return new Promise(function (resolve, reject) {
    exec('npx prettier --single-quote --write ./' + x + '.js ', function (err, stdout, stderr) {
      if (err) {
        console.log(err);reject(err);
      }
      console.log('all good for ' + x + '.js');
      resolve(x);
    });
  });
};

var eslintAutoFix = function eslintAutoFix(x) {
  exec('npx eslint --fix ./' + x + '.js ', function (err, stdout, stderr) {
    if (err) {
      console.log(err);return false;
    }
    console.log('all good for ' + x + '.js');
  });
  return x;
};

var eslintAutoFixPromise = function eslintAutoFixPromise(x) {
  return new Promise(function (resolve, reject) {
    exec('npx eslint --fix ./' + x + '.js ', function (err, stdout, stderr) {
      if (err) {
        console.log(err);return false;
      }
      console.log('all good for ' + x + '.js');
      resolve(x);
    });
  });
};

var onlySVGFiles = function onlySVGFiles(x) {
  return x.match(/.svg$/) !== -1;
};

var addParenthesisBack = function addParenthesisBack(s) {
  // .readdirSync('./', 'utf8')
  // .filter(onlySVGFiles)
  // .map(x => {
  var file = fs.readFileSync(s + '.js', 'utf8');
  var fileContent = file.replace('=>', '=>').replace('</SvgIcon>;', '</SvgIcon>\n);');

  fs.writeFileSync(s + '.js', fileContent, 'utf8');
};

var compose = function compose() {
  var fns = [].concat(Array.prototype.slice.call(arguments));
  fns.filter(function (x) {
    return isFn;
  });

  return function (item) {
    return fns.reduce(function (r, fn) {
      r = fn(r);return r;
    }, item);
  };
};

var cleanFileName = compose(toLowerCase, capitalize, removeDashIco, toCamelCase);
var template = // fs.readFileSync('./_template.js', 'utf8');
'import React from \'react\';\nimport PropTypes from \'prop-types\';\nimport SvgIcon from \'../SvgIcon\';\n/* eslint-disable max-len */\n\nconst {{name}} = (props) => (\n  <SvgIcon {...props} >\n    {{svg}}\n  </SvgIcon>\n);\n\n{{name}}.propTypes = {\n  color: PropTypes.string,\n};\n\n{{name}}.defaultProps = {\n  color: \'currentColor\',\n};\n\nexport default {{name}};';

/**
 * RUN :
 */
// eraseIndex
exec("echo '/* eslint-disable max-len */' > ./index.js", function (err, std, stdout) {
  if (err) {
    console.log(err);return false;
  }
  console.log('index deleted');
});

// exec('echo "import React from \'react\';" > ./index.js', (err, std, stdout) => {
//   if (err) { console.log(err); return false; }
//   console.log('index deleted');
// });


_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
  var originalFiles, gASI;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          console.log('start');
          _context2.next = 3;
          return Promise.all(fs.readdirSync('./svgs').filter(function (filename) {
            return filename.toLowerCase() !== '.ds_store';
          })
          // .filter(x => x.match('options'))
          .map(writeFile).map(writeFileTest)
          // .map(prettifyFile)
          .map(addFileToIndex)
          // .map(prettifyFile)
          );

        case 3:
          originalFiles = _context2.sent;
          _context2.next = 6;
          return mapPromiseSequentially(originalFiles, prettifyFile);

        case 6:
          _context2.next = 8;
          return mapPromiseSequentially(originalFiles, eslintAutoFixPromise);

        case 8:

          console.log('§§ originalFiles', originalFiles);

          exec('npm run lint', function (err, std, stdout) {
            if (err) {
              console.log(err);return false;
            }
            console.log('lint autofix has ran succesfully');
          });

          originalFiles.map(addParenthesisBack).map(function (x) {
            console.log(x);return x;
          });

          // eslint-disable-next-line single-quote
          gASI = 'import * as Icons from \'./index\';\n\nconst capitalize = x => x.charAt(0).toUpperCase() + x.slice(1);\n\nexport const getAppropriateIcon = (identifier) => {\n  const cleanedIdentifer = capitalize(identifier.toLowerCase());\n  return Icons[cleanedIdentifer] ? Icons[cleanedIdentifer] : Icons[\'Circle\'];\n};\n\nexport default getAppropriateIcon;\n';


          exec('echo "' + gASI + '" > ./getAppropriateIcon.js', function (err, std, stdout) {
            if (err) {
              console.log(err);return false;
            }
            console.log('index deleted');
          });

          /*
          export const getAppropriateSvgIcon = (identifier) => {
          const Element = `${identifier}`;
          return <Element />;
          };
           */

          // .map(addParenthesisBack)

        case 13:
        case 'end':
          return _context2.stop();
      }
    }
  }, _callee2, this);
}))();