'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
// eslint-disable-next-line import/no-named-as-default


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getAppropriateIcon = require('../Icons/getAppropriateIcon');

var _getAppropriateIcon2 = _interopRequireDefault(_getAppropriateIcon);

var _Img = require('./Img');

var _Img2 = _interopRequireDefault(_Img);

var _TextEllipsis = require('../Text/TextEllipsis');

var _TextEllipsis2 = _interopRequireDefault(_TextEllipsis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  wrapper: {
    maxWidth: '100%',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'flex-start'
  },
  nameWrapper: {
    marginLeft: '6px',
    overflow: 'hidden'
  }
};

var AvatarWithName = function AvatarWithName(_ref) {
  var src = _ref.src,
      icon = _ref.icon,
      name = _ref.name,
      imgSize = _ref.imgSize,
      isSquare = _ref.isSquare,
      onClick = _ref.onClick,
      contain = _ref.contain,
      style = _ref.style,
      nameStyle = _ref.nameStyle,
      inverse = _ref.inverse;

  // eslint-disable-next-line no-nested-ternary
  var imgContent = src ? _react2.default.createElement(_Img2.default, { contain: contain, async: true, width: imgSize || '26', style: { borderRadius: isSquare ? 0 : '50%' }, src: src }) : icon // eslint-disable-line
  ? _react2.default.isValidElement(icon) ? _react2.default.cloneElement(icon, { size: imgSize || '26px' }) : _react2.default.createElement((0, _getAppropriateIcon2.default)(icon || 'Circle'), { size: imgSize || '26px' }) : _react2.default.createElement((0, _getAppropriateIcon2.default)('Circle'), { size: imgSize || '26px' });

  return _react2.default.createElement(
    'div',
    {
      style: _extends({}, styles.wrapper, inverse ? { flexDirection: 'row-reverse' } : {}, style),
      onClick: onClick || null
    },
    imgContent,
    _react2.default.createElement(
      'div',
      {
        style: _extends({}, styles.nameWrapper, inverse ? { marginLeft: 0, marginRight: '6px' } : {}, nameStyle)
      },
      _react2.default.createElement(
        _TextEllipsis2.default,
        null,
        name
      )
    )
  );
};

AvatarWithName.displayName = 'AvatarWithName';

exports.default = AvatarWithName;