'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getAppropriateIcon = require('../Icons/getAppropriateIcon');

var _getAppropriateIcon2 = _interopRequireDefault(_getAppropriateIcon);

var _Img = require('./Img');

var _Img2 = _interopRequireDefault(_Img);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line import/no-named-as-default
var styles = {
  wrapper: {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'flex-start'
  },
  nameWrapper: {
    marginLeft: '6px'
  }
};

var AvatarWithNameAndExtra = function AvatarWithNameAndExtra(_ref) {
  var src = _ref.src,
      icon = _ref.icon,
      name = _ref.name,
      extra = _ref.extra,
      imgSize = _ref.imgSize,
      isSquare = _ref.isSquare,
      onClick = _ref.onClick;

  // eslint-disable-next-line no-nested-ternary
  var imgContent = src ? _react2.default.createElement(_Img2.default, { async: true, width: imgSize || '26', style: { borderRadius: isSquare ? 0 : '50%' }, src: src }) : icon ? _react2.default.cloneElement(icon, { size: icon.props.size || imgSize || '26px' }) : _react2.default.createElement((0, _getAppropriateIcon2.default)('Circleduser'), { size: imgSize || '26px' });

  return _react2.default.createElement(
    'div',
    { style: styles.wrapper, onClick: onClick || null },
    imgContent,
    _react2.default.createElement(
      'div',
      { style: styles.nameWrapper },
      _react2.default.createElement(
        'div',
        { style: { fontSize: '16px' } },
        name
      ),
      _react2.default.createElement(
        'div',
        { style: { fontSize: '11px' } },
        extra
      )
    )
  );
};

AvatarWithNameAndExtra.displayName = 'AvatarWithNameAndExtra';

exports.default = AvatarWithNameAndExtra;