'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Gallery = require('./Gallery');

var _Gallery2 = _interopRequireDefault(_Gallery);

var _PropsMapperContainerQueries = require('../internal/PropsMapperContainerQueries');

var _PropsMapperContainerQueries2 = _interopRequireDefault(_PropsMapperContainerQueries);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultRules = [{
  minWidth: 0,
  mapper: function mapper() {
    return (/* { imgHeight } */{ imgHeight: 90 }
    );
  }
}, {
  minWidth: 600,
  mapper: function mapper() {
    return (/* { imgHeight } */{ imgHeight: 135 }
    );
  }
}, {
  minWidth: 900,
  mapper: function mapper() {
    return (/* { imgHeight } */{ imgHeight: 160 }
    );
  }
}];
// eslint-disable-next-line import/no-named-as-default


var ResponsiveGallery = function ResponsiveGallery(props) {
  var galleryDescriptor = props.galleryDescriptor,
      rules = props.rules,
      style = props.style;

  return _react2.default.createElement(
    _PropsMapperContainerQueries2.default,
    { imgHeight: 40, rules: rules },
    _react2.default.createElement(_Gallery2.default, { galleryDescriptor: galleryDescriptor, style: style })
  );
};

ResponsiveGallery.displayName = 'ResponsiveGallery';

ResponsiveGallery.defaultProps = {
  rules: defaultRules,
  galleryDescriptor: []
};

exports.default = ResponsiveGallery;