'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  /* ', '; */\n  display: inline-block;\n  ', ';\n  display: flex;\n  align-items: center;\n  flex-direction: ', ';\n  justify-content: ', ';\n'], ['\n  /* ', '; */\n  display: inline-block;\n  ', ';\n  display: flex;\n  align-items: center;\n  flex-direction: ', ';\n  justify-content: ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  position: relative;\n  display: inline-block;\n  width: 100%;\n  height: 4px;\n  max-width: ', ';\n  background: ', ';\n  margin: ', ';\n'], ['\n  position: relative;\n  display: inline-block;\n  width: 100%;\n  height: 4px;\n  max-width: ', ';\n  background: ', ';\n  margin: ', ';\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  display: inline-block;\n    margin: ', ';\n'], ['\n  display: inline-block;\n    margin: ', ';\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  width: ', ';\n  background: ', ';\n  transition: ', ';\n'], ['\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  width: ', ';\n  background: ', ';\n  transition: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// eslint-disable-next-line no-mixed-operators
var lt = function lt(x, a, b, c, d) {
  return (x - a) / (b - c) * (d - c) + c;
};
var addUnitIfNeeded = function addUnitIfNeeded(value) {
  if (!value) {
    return '';
  }

  if (value.match && value.match(/px|pc|%|em|rem/)) {
    return value;
  }

  return value.match + 'px';
};
var ProgressBarWrapperUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var width = _ref.width;
  return width !== undefined ? 'width: ' + width + 'px' : 'auto';
}, function (_ref2) {
  var width = _ref2.width;
  return width && addUnitIfNeeded(width);
}, function (_ref3) {
  var labelPosition = _ref3.labelPosition;

  if (labelPosition === 'left') {
    return 'row-reverse';
  }
  if (labelPosition === 'top') {
    return 'column-reverse';
  }
  if (labelPosition === 'bottom') {
    return 'column';
  }
  return 'inherit';
}, function (_ref4) {
  var labelPosition = _ref4.labelPosition;

  if (labelPosition === 'left') {
    return 'flex-end';
  }
  if (labelPosition === 'top') {
    return 'flex-end';
  }
  if (labelPosition === 'bottom') {
    return 'flex-start';
  }
  return 'flex-start';
});

var ProgressIndicatorWrapperUI = _styledComponents2.default.div(_templateObject2, function (_ref5) {
  var width = _ref5.width;
  return width !== undefined ? '' + addUnitIfNeeded(width) : 'auto';
}, function (_ref6) {
  var theme = _ref6.theme;
  return theme.palette.lightGrey;
}, function (_ref7) {
  var labelPosition = _ref7.labelPosition;

  if (labelPosition === 'left') {
    return '0';
  }
  if (labelPosition === 'top') {
    return '4px 0 0 0';
  }
  if (labelPosition === 'bottom') {
    return 0;
  }
  return '0 6px 0 0';
});

var LabelWrapperUI = _styledComponents2.default.div(_templateObject3, function (_ref8) {
  var labelPosition = _ref8.labelPosition;

  if (labelPosition === 'left') {
    return '0 6px 0 0';
  }
  if (labelPosition === 'top') {
    return 0;
  }
  if (labelPosition === 'bottom') {
    return '4px 0 0 0';
  }
  return '0';
});

var ProgressIndicatorUI = _styledComponents2.default.div(_templateObject4, function (_ref9) {
  var value = _ref9.value;
  return value + '%';
}, function (_ref10) {
  var theme = _ref10.theme;
  return theme.palette.accent.main;
}, function (_ref11) {
  var transition = _ref11.theme.transition;
  return transition.defaultAll;
});

var ProgressBar = function ProgressBar(_ref12) {
  var min = _ref12.min,
      max = _ref12.max,
      value = _ref12.value,
      width = _ref12.width,
      label = _ref12.label,
      labelPosition = _ref12.labelPosition;
  return _react2.default.createElement(
    ProgressBarWrapperUI,
    { labelPosition: labelPosition, width: width },
    _react2.default.createElement(
      ProgressIndicatorWrapperUI,
      { width: width, labelPosition: labelPosition },
      _react2.default.createElement(ProgressIndicatorUI, { value: lt(value, min, max, 0, 100) })
    ),
    _react2.default.createElement(
      LabelWrapperUI,
      { labelPosition: labelPosition },
      label
    )
  );
};
exports.default = ProgressBar;