'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _DropDownWithClickOutside = require('../internal/DropDownWithClickOutside');

var _DropDownWithClickOutside2 = _interopRequireDefault(_DropDownWithClickOutside);

var _SelectInputOptions = require('./Select/SelectInputOptions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
// import BETALookUp from '../internal/BETALookup';

// import ListWithNavigation from './ListWithNavigation';


var InputUI = _styledComponents2.default.input(_templateObject, function (_ref) {
  var isFullWidth = _ref.isFullWidth;
  return isFullWidth ? 'width: 100%;' : '';
});

var KeyNavigationItem = function KeyNavigationItem(_ref2) {
  var _onClick = _ref2.onClick,
      selected = _ref2.selected,
      value = _ref2.value,
      index = _ref2.index,
      children = _ref2.children,
      style = _ref2.style;
  return _react2.default.createElement(
    _SelectInputOptions.OptionsUI,
    {
      tabIndex: 0,
      onClick: function onClick(e) {
        _onClick(e, index, value, true);
      },
      onKeyPress: function onKeyPress(e) {
        if (e.keyCode === 13 || e.key === 'Enter') {
          _onClick(e, index, value, true);
        }
      },
      'data-index': index,
      selected: selected,
      role: 'menuitem',
      style: _extends({}, style)
    },
    children
  );
};

var BETAAutoComplete = function (_Component) {
  _inherits(BETAAutoComplete, _Component);

  function BETAAutoComplete(props) {
    _classCallCheck(this, BETAAutoComplete);

    var _this = _possibleConstructorReturn(this, (BETAAutoComplete.__proto__ || Object.getPrototypeOf(BETAAutoComplete)).call(this, props));

    _this.ref = null;
    _this.triggerRef = null;

    _this.isOpenControlled = _this.props.isOpen !== undefined;

    _this.state = {
      isOpen: _this.isOpenControlled ? _this.props.isOpen : false
    };

    _this.storeRef = _this.storeRef.bind(_this);
    _this.storeTriggerRef = _this.storeTriggerRef.bind(_this);
    _this.toggleVisibility = _this.toggleVisibility.bind(_this);
    _this.close = _this.close.bind(_this);
    _this.open = _this.open.bind(_this);
    return _this;
  }

  _createClass(BETAAutoComplete, [{
    key: 'focusFirstItem',
    value: function focusFirstItem() {
      var _this2 = this;

      if (this.ref && this.ref.firstElementChild // ul
      && this.ref.firstElementChild.firstElementChild // first li
      && this.ref.firstElementChild.firstElementChild.focus) {
        setTimeout(function () {
          return _this2.ref.firstElementChild.firstElementChild.focus();
        }, 8);
        // the ListWithNavigation should take care of the rest
      }
    }
  }, {
    key: 'focusInput',
    value: function focusInput() {
      if (this.triggerRef && this.triggerRef.querySelector) {
        var input = this.triggerRef.querySelector('input');
        if (input && input.focus) {
          setTimeout(function () {
            return input.focus();
          }, 8);
        }
      }
    }
  }, {
    key: 'storeRef',
    value: function storeRef(node) {
      this.ref = node;
    }
  }, {
    key: 'storeTriggerRef',
    value: function storeTriggerRef(node) {
      this.triggerRef = node;
    }
  }, {
    key: 'toggleVisibility',
    value: function toggleVisibility() {
      if (!this.isOpenControlled) {
        this.setState({ isOpen: this.state.isOpen });
      }
    }
  }, {
    key: 'close',
    value: function close() {
      if (!this.isOpenControlled) {
        this.setState({ isOpen: false });
      }
    }
  }, {
    key: 'open',
    value: function open() {
      if (!this.isOpenControlled) {
        this.setState({ isOpen: true });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          _onChange = _props.onChange,
          defaultValue = _props.defaultValue,
          value = _props.value,
          children = _props.children,
          isFullWidth = _props.isFullWidth,
          _props$style = _props.style,
          style = _props$style === undefined ? {} : _props$style,
          Input = _props.Input,
          placeholder = _props.placeholder,
          onSubmit = _props.onSubmit,
          inertMain = _props.inertMain,
          rest = _objectWithoutProperties(_props, ['onChange', 'defaultValue', 'value', 'children', 'isFullWidth', 'style', 'Input', 'placeholder', 'onSubmit', 'inertMain']);

      var isOpen = this.isOpenControlled ? this.props.isOpen : this.state.isOpen;

      var InputComponent = Input || InputUI;
      return _react2.default.createElement(
        'div',
        {
          onKeyDown: function onKeyDown(e) {
            if (e.key === 'Escape') {
              _this3.close();
            } else if (e.key === 'ArrowDown') {
              if (!e.ctrlKey && !e.metaKey && !e.altKey) {
                if (document.activeElement.nodeName === 'INPUT') {
                  _this3.focusFirstItem();
                } else if (document.activeElement.nextElementSibling) {
                  // this.focusNext()
                  document.activeElement.nextElementSibling.focus();
                }
              }
            } else if (e.key === 'ArrowUp') {
              if (document.activeElement.nodeName !== 'INPUT' && !document.activeElement.previousElementSibling) {
                _this3.focusInput();
              } else if (document.activeElement.previousElementSibling) {
                // this.focusPrev()
                document.activeElement.previousElementSibling.focus();
              }
            }

            // const open = this.getOpenState();
            // if (!open) {
            //   this.handleToggleVisibility();
            // }
          }
        },
        _react2.default.createElement(
          _DropDownWithClickOutside2.default,
          {
            onClickOutside: this.close,
            isOpen: isOpen,
            isFullWidth: isFullWidth,
            inertMain: inertMain,
            onChildrenWrapperRef: this.storeRef,
            onTriggerWrapperRef: this.storeTriggerRef,
            trigger: _react2.default.createElement(InputComponent, _extends({}, rest, {
              defaultValue: defaultValue,
              isFullWidth: isFullWidth,
              value: value,
              style: style,
              placeholder: placeholder,
              onClick: this.open,
              onFocus: this.open,
              onChange: function onChange(e) {
                _onChange(e, e.target.value);
              },
              onKeyPress: function onKeyPress(e) {
                if (e.key === 'Enter') {
                  onSubmit(e, e.target.value);
                  _this3.close();
                }
              }
            }))
          },
          _react2.default.createElement(
            'ul',
            { style: { background: 'white', overflowY: 'scroll' } },
            _react2.default.Children.map(children, function (c) {
              return c && _react2.default.createElement(
                KeyNavigationItem,
                {
                  tabIndex: '0'
                  // onClick={(c.props.onClick || (() => {}))}
                  , onClick: function onClick() {
                    var _ref3 = c.props || {},
                        onClick = _ref3.onClick;

                    if (onClick) {
                      onClick.apply(undefined, arguments);
                    }
                    _this3.close();
                  }
                },
                _react2.default.cloneElement(c, _extends({}, c.props || {}, {
                  tabIndex: 0
                }))
              );
            })
          )
        )
      );
    }
  }]);

  return BETAAutoComplete;
}(_react.Component);

exports.default = BETAAutoComplete;