'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var pad = function pad(v) {
  return v < 10 ? '0' + v : v;
};

var styles = {
  width: '100%',
  boxSizing: 'border-box',
  borderRadius: '3px',
  border: '1px solid #dcdcdc',
  padding: '6.75px 6.75px 6.75px 6.75px'

};
var DateTimeInput = function DateTimeInput(_ref) {
  var inputType = _ref.inputType,
      props = _objectWithoutProperties(_ref, ['inputType']);

  var intialDateValue = null;
  if (props.defaultValue) {
    var initialDateValueAsDate = new Date(props.defaultValue); // .toISOString();

    intialDateValue = props.defaultValue ? pad(initialDateValueAsDate.getFullYear()) + '-' + pad(initialDateValueAsDate.getMonth() + 1) + '-' + pad(initialDateValueAsDate.getDate()) : '';
  }

  return _react2.default.createElement('input', _extends({
    type: inputType || 'date'
  }, props, {
    defaultValue: intialDateValue,
    style: _extends({}, styles, 'style' in props ? props.style : {})
  }));
};

DateTimeInput.propTypes = {
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.instanceOf(Date), _propTypes2.default.string, _propTypes2.default.number])
};

DateTimeInput.defaultProps = {
  defaultValue: null
};

DateTimeInput.displayName = 'DateTimeInput';

exports.default = DateTimeInput;