'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  background: #fff;\n  box-sizing: border-box;\n  cursor: pointer;\n  user-select: none;\n  &:hover {\n    outline: none;\n    background-color: rgb(206, 206, 206);\n  }\n  &:focus {\n    outline: none;\n    background-color: rgb(206, 206, 206);\n  }\n  &:active {\n    outline: none;\n    background-color: rgb(206, 206, 206);\n  }\n'], ['\n  background: #fff;\n  box-sizing: border-box;\n  cursor: pointer;\n  user-select: none;\n  &:hover {\n    outline: none;\n    background-color: rgb(206, 206, 206);\n  }\n  &:focus {\n    outline: none;\n    background-color: rgb(206, 206, 206);\n  }\n  &:active {\n    outline: none;\n    background-color: rgb(206, 206, 206);\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var OptionsUI = _styledComponents2.default.li(_templateObject);

var KeyNavigationItem = function KeyNavigationItem(_ref) {
  var _onClick = _ref.onClick,
      selected = _ref.selected,
      value = _ref.value,
      index = _ref.index,
      children = _ref.children;
  return _react2.default.createElement(
    OptionsUI,
    {
      tabIndex: index,
      onClick: function onClick(e) {
        _onClick(e, index, value, true);
      },
      onKeyPress: function onKeyPress(e) {
        if (e.keyCode === 13 || e.key === 'Enter') {
          _onClick(e, index, value, true);
        }
      },
      'data-index': index,
      selected: selected,
      role: 'menuitem'
    },
    children
  );
};

var KeyNavigation = function (_Component) {
  _inherits(KeyNavigation, _Component);

  function KeyNavigation(props) {
    _classCallCheck(this, KeyNavigation);

    var _this = _possibleConstructorReturn(this, (KeyNavigation.__proto__ || Object.getPrototypeOf(KeyNavigation)).call(this, props));

    _this.state = {
      selectedIndex: 0
    };
    _this.preventScrollingOnSpace = _this.preventScrollingOnSpace.bind(_this);
    _this.clickHandler = _this.clickHandler.bind(_this);
    _this.mainRef = _react2.default.createRef();
    return _this;
  }

  _createClass(KeyNavigation, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('keydown', this.preventScrollingOnSpace, true);
      // this.mainRef.current.focus();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('keydown', this.preventScrollingOnSpace, true);
    }
  }, {
    key: 'getOptionsItem',
    value: function getOptionsItem() {
      var _this2 = this;

      var children = this.props.children;
      var selectedIndex = this.state.selectedIndex;


      return _react2.default.Children.map(children, function (child, i) {
        if (!child) {
          return null;
        }

        var value = child.props.value ? child.props.value : i;
        return _react2.default.createElement(
          KeyNavigationItem,
          {
            key: child.props.key,
            value: value,
            index: i,
            selected: selectedIndex === i,
            onClick: _this2.clickHandler
          },
          child
        );
      });
    }
  }, {
    key: 'preventScrollingOnSpace',
    value: function preventScrollingOnSpace(e) {
      var onClose = this.props.onClose;

      if (e.key === ' ' || e.key === 'Spacebar' || e.keyCode === 32 || e.key === 'Escape' || e.keyCode === 27) {
        if (onClose) {
          // onClose();
        }
      } else if (e.key === 'Tab' || e.keyCode === 9) {
        if (!(document.activeElement.nodeName === 'BUTTON')) {
          var _document = document,
              activeElement = _document.activeElement;

          var lastOptionItem = document.activeElement.parentNode.lastChild;
          var firstOptionItem = document.activeElement.parentNode.firstChild;

          if (e.shiftKey) {
            if (activeElement === firstOptionItem && lastOptionItem && lastOptionItem.focus) {
              lastOptionItem.focus();
            }
          } else if (activeElement === lastOptionItem && firstOptionItem && firstOptionItem.focus) {
            firstOptionItem.focus();
          }
        }
      } else if (e.key === 'ArrowDown' || e.keyCode === 40) {
        // just go to next sigblings:
        var nextSiblingMaybe = document.activeElement.nextElementSibling;
        if (nextSiblingMaybe && nextSiblingMaybe.focus) {
          nextSiblingMaybe.focus();
        } else {
          // focus from main triggerer to (first) item:
          var nextSiblingMaybeItem = document.activeElement.parentNode.nextElementSibling;
          if (nextSiblingMaybeItem) {
            var _firstOptionItem = nextSiblingMaybeItem.firstChild;
            if (_firstOptionItem && _firstOptionItem.focus) {
              _firstOptionItem.focus();
            }
          } else if (this.mainRef) {
            // go back to first option element
            var firstOption = this.mainRef.firstChild;
            if (firstOption && firstOption.focus) {
              firstOption.focus();
            }
          }
        }
      } else if (e.key === 'ArrowUp' || e.keyCode === 38) {
        var previousSiblingMaybe = document.activeElement.previousElementSibling;
        if (previousSiblingMaybe && previousSiblingMaybe.focus) {
          previousSiblingMaybe.focus();
        } else {
          var optionsWrapperDiv = document.activeElement.parentNode.nextElementSibling;
          if (optionsWrapperDiv) {
            var _lastOptionItem = document.activeElement.parentNode.nextElementSibling.lastChild;
            if (_lastOptionItem && _lastOptionItem.focus) {
              _lastOptionItem.focus();
            }
          } else {
            // go back to last option element
            var lastOption = document.activeElement.parentNode.lastChild;
            if (lastOption && lastOption.focus) {
              lastOption.focus();
            }
          }
        }
      }
    }
  }, {
    key: 'clickHandler',
    value: function clickHandler(e, index, value) {
      var _props = this.props,
          onChange = _props.onChange,
          onSubmit = _props.onSubmit;


      this.setState({
        selectedIndex: index
      });

      if (onChange) {
        onChange(e, value);
      }

      if (onSubmit) {
        onSubmit(e, value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var list = this.getOptionsItem();
      var _props$listStyle = this.props.listStyle,
          listStyle = _props$listStyle === undefined ? {} : _props$listStyle;


      return _react2.default.createElement(
        'ul',
        { ref: this.mainRef, role: 'menu', style: _extends({}, listStyle) },
        list
      );
    }
  }]);

  return KeyNavigation;
}(_react.Component);

exports.default = KeyNavigation;