'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  cursor: pointer;\n  opacity: 0;\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  box-sizing: border-box;\n  margin: 0;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  appearance: none;\n'], ['\n  cursor: pointer;\n  opacity: 0;\n  position: absolute;\n  width: 100%;\n  height: 100%;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  box-sizing: border-box;\n  margin: 0;\n  -webkit-appearance: none;\n  -moz-appearance: none;\n  appearance: none;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  display: flex;\n  align-items: center;\n  padding: 2px;\n  padding-left: 1px;\n  padding: 4px 6px;\n  & > *:nth-child(2) {\n    ', ';\n  }\n\n  cursor: pointer;\n  /* cannot use focus-within because IE */\n  border-radius: 2px;\n\n  border-radius: ', ';\n  transition: ', ';\n\n  @media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n    /* waiting for Edge to support focus-within */\n    ', ';\n  }\n\n  &:focus-within {\n    ', ';\n  }\n\n  svg {\n    transition: ', ';\n    ', ';\n  }\n\n'], ['\n  display: flex;\n  align-items: center;\n  padding: 2px;\n  padding-left: 1px;\n  padding: 4px 6px;\n  & > *:nth-child(2) {\n    ', ';\n  }\n\n  cursor: pointer;\n  /* cannot use focus-within because IE */\n  border-radius: 2px;\n\n  border-radius: ', ';\n  transition: ', ';\n\n  @media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n    /* waiting for Edge to support focus-within */\n    ', ';\n  }\n\n  &:focus-within {\n    ', ';\n  }\n\n  svg {\n    transition: ', ';\n    ', ';\n  }\n\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _getAppropriateIcon = require('../Icons/getAppropriateIcon');

var _getAppropriateIcon2 = _interopRequireDefault(_getAppropriateIcon);

var _Ripples = require('../Motion/Ripples');

var _Ripples2 = _interopRequireDefault(_Ripples);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
// eslint-disable-next-line import/no-named-as-default


var RadioInpuUI = _styledComponents2.default.input.attrs(function () {
  return (/* props */{
      type: 'radio',
      onMouseOut: function onMouseOut(_ref) {
        var target = _ref.target;
        return target.blur && target.blur();
      }
    }
  );
})(_templateObject);

/* eslint-disable indent */
var RadioLabelUI = _styledComponents2.default.label(_templateObject2, function (_ref2) {
  var label = _ref2.label;
  return label ? 'margin-right: 6px;' : '';
}, function (_ref3) {
  var radius = _ref3.theme.radius;
  return radius;
}, function (_ref4) {
  var transition = _ref4.theme.transition;
  return transition.defaultAll;
}, function (_ref5) {
  var hasFocus = _ref5.hasFocus,
      theme = _ref5.theme;
  return hasFocus ? '\n      bowShadow: ' + theme.outlineShadow + '; outline: ' + theme.outline + '\n    ' : '';
}, function (_ref6) {
  var disabled = _ref6.disabled,
      inert = _ref6.inert,
      theme = _ref6.theme;
  return !inert || !disabled ? 'box-shadow: ' + theme.outlineShadow + '; outline: ' + theme.outline : '';
}, function (_ref7) {
  var transition = _ref7.theme.transition;
  return transition.defaultAll;
}, function (_ref8) {
  var checker = _ref8.checker,
      palette = _ref8.theme.palette;
  return checker ? 'fill: ' + palette.accent.main + ' !important; }' : '';
});
/* eslint-enable indent */

var styles = {
  wrapper: {
    position: 'relative',
    display: 'inline-block',
    marginRight: '6px'
  }
};
// eslint-disable-next-line react/prefer-stateless-function

var Radio = function (_React$PureComponent) {
  _inherits(Radio, _React$PureComponent);

  function Radio(props) {
    _classCallCheck(this, Radio);

    var _this = _possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).call(this, props));

    _this.state = {
      hasFocus: false
    };

    _this.handleChange = _this.handleChange.bind(_this);
    _this.onFocus = _this.onFocus.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    return _this;
  }

  _createClass(Radio, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.isControlled = this.props.checked !== undefined;
      if (!this.isControlled) {
        // not controlled, use internal state
        this.setState({
          checked: this.props.defaultChecked !== undefined ? this.props.defaultChecked : false
        });
      }
    }

    /* since we still can't use :focus-within selector because of GD IE,
     * let's add more javascript handler...
     */

  }, {
    key: 'onFocus',
    value: function onFocus() {
      this.setState({ hasFocus: true });
    }
  }, {
    key: 'onBlur',
    value: function onBlur() {
      this.setState({ hasFocus: false });
    }
  }, {
    key: 'getWrapperStyles',
    value: function getWrapperStyles() {
      // disabled
      var _props = this.props,
          disabled = _props.disabled,
          wrapperStyle = _props.wrapperStyle;

      return _extends({}, styles.wrapper, disabled ? { opacity: 0.6 } : {}, wrapperStyle);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var checked = event.target.checked;

      if (!this.isControlled) {
        this.setState({ checked: checked });
      }

      var onChange = this.props.onChange;

      if (onChange) {
        onChange(event, checked);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          name = _props2.name,
          id = _props2.id,
          disabled = _props2.disabled,
          value = _props2.value,
          label = _props2.label;
      var hasFocus = this.state.hasFocus;


      var isChecked = this.isControlled ? this.props.checked : this.state.checked;
      var checker = this.isControlled ? { checked: this.props.checked } : { defaultChecked: this.state.checked };

      var iconIdentifier = isChecked ? 'radioInput' : 'RadioInputOutline';
      var Icon = (0, _getAppropriateIcon2.default)(iconIdentifier);

      /* eslint-disable jsx-a11y/label-has-for */
      return _react2.default.createElement(
        'div',
        { style: this.getWrapperStyles() },
        _react2.default.createElement(
          _Ripples2.default,
          null,
          _react2.default.createElement(
            RadioLabelUI,
            {
              htmlFor: name,
              style: {},
              label: label,
              hasFocus: hasFocus,
              checker: isChecked
            },
            _react2.default.createElement(RadioInpuUI, _extends({
              tabIndex: '0',
              id: id,
              style: {}
            }, checker, {
              name: name,
              value: value,
              disabled: disabled,
              onBlur: this.onBlur,
              onFocus: this.onFocus,
              onChange: function onChange() {
                _this2.handleChange.apply(_this2, arguments);
              }
            })),
            _react2.default.createElement(Icon, null),
            label
          )
        )
      );
    }
  }]);

  return Radio;
}(_react2.default.PureComponent);

Radio.propTypes = {
  onChange: _propTypes2.default.func,
  // icon: PropTypes.string,
  // checkedIcon: PropTypes.string,
  checked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  name: _propTypes2.default.string, // .isRequired,
  defaultChecked: _propTypes2.default.bool,
  wrapperStyle: _propTypes2.default.object
};

Radio.defaultProps = {
  name: 'myawesomecheckbox',
  onChange: function onChange() {},
  icon: 'Checkboxoutline',
  checkedIcon: 'Checkbox',
  checked: false,
  disabled: false,
  defaultChecked: false,
  wrapperStyle: {}
};

exports.default = Radio;