'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  width: ', ';\n'], ['\n  display: flex;\n  width: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _TextField = require('./TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icons = require('../Icons');

var _InputGroup = require('../List/InputGroup');

var _InputGroup2 = _interopRequireDefault(_InputGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FormUI = _styledComponents2.default.form(_templateObject, function (_ref) {
  var fullWidth = _ref.fullWidth;
  return fullWidth ? '100%' : 'auto';
});

var SearchForm = function (_Component) {
  _inherits(SearchForm, _Component);

  function SearchForm(props) {
    _classCallCheck(this, SearchForm);

    var _this = _possibleConstructorReturn(this, (SearchForm.__proto__ || Object.getPrototypeOf(SearchForm)).call(this, props));

    _this.handleSubmit = _this.handleSubmit.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);

    var _this$props = _this.props,
        value = _this$props.value,
        defaultValue = _this$props.defaultValue;

    var valueToInitStoreWith = value || defaultValue || '';
    _this.state = { value: valueToInitStoreWith };
    return _this;
  }

  _createClass(SearchForm, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          value = _props.value,
          defaultValue = _props.defaultValue;

      var valueToInitStoreWith = value || defaultValue || '';
      this.setState({ value: valueToInitStoreWith });
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var value = event.target.value;
      var onChange = this.props.onChange;


      this.setState({ value: value });

      if (onChange) {
        onChange(event, value);
      }
    }
  }, {
    key: 'handleSubmit',
    value: function handleSubmit(event) {
      event.preventDefault();
      var value = event.target.querySelector('input').value;
      var _props2 = this.props,
          onClick = _props2.onClick,
          onSubmit = _props2.onSubmit,
          onEnter = _props2.onEnter;


      var fakeEvent = {
        target: { value: value },
        currentTarget: { value: value }
      };

      if (onClick) {
        onClick(fakeEvent, value);
      }
      if (onSubmit) {
        onSubmit(fakeEvent, value);
      }
      if (onEnter) {
        onEnter(fakeEvent, value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          icon = _props3.icon,
          onChange = _props3.onChange,
          fullWidth = _props3.fullWidth,
          isFullWidth = _props3.isFullWidth,
          formProps = _props3.formProps,
          otherProps = _objectWithoutProperties(_props3, ['icon', 'onChange', 'fullWidth', 'isFullWidth', 'formProps']);

      var inputProps = _extends({}, otherProps, {
        isFullWidth: isFullWidth,
        onChange: this.handleChange
      });

      var finalIcon = icon || _react2.default.createElement(_Icons.Search, { style: { margin: 0 } });

      return _react2.default.createElement(
        FormUI,
        _extends({}, formProps, { fullWidth: isFullWidth || fullWidth, onSubmit: this.handleSubmit }),
        _react2.default.createElement(
          _InputGroup2.default,
          { fullWidth: isFullWidth || fullWidth },
          _react2.default.createElement(_TextField2.default, _extends({}, inputProps, { style: { margin: 0, paddingLeft: '8px' } })),
          _react2.default.createElement(_Button2.default, {
            type: 'primary',
            icon: finalIcon
          })
        )
      );
    }
  }]);

  return SearchForm;
}(_react.Component);

SearchForm.displayName = 'SearchForm';

SearchForm.propTypes = {
  isFullWidth: _propTypes2.default.bool
};

SearchForm.defaultProps = {
  isFullWidth: false
};

exports.default = SearchForm;