'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _DropDownWithClickOutside = require('../../internal/DropDownWithClickOutside');

var _DropDownWithClickOutside2 = _interopRequireDefault(_DropDownWithClickOutside);

var _Arrowdown = require('../../Icons/Arrowdown');

var _Arrowdown2 = _interopRequireDefault(_Arrowdown);

var _Button = require('../../Button/Button');

var _Button2 = _interopRequireDefault(_Button);

var _UnstyledButton = require('../../Button/UnstyledButton1');

var _UnstyledButton2 = _interopRequireDefault(_UnstyledButton);

var _SelectInputOptions = require('./SelectInputOptions');

var _SelectInputOptions2 = _interopRequireDefault(_SelectInputOptions);

var _StatusIcon = require('../utils/StatusIcon');

var _StatusIcon2 = _interopRequireDefault(_StatusIcon);

var _ErrorWrapperUI = require('../utils/ErrorWrapperUI');

var _ErrorWrapperUI2 = _interopRequireDefault(_ErrorWrapperUI);

var _Select = require('./Select.styles');

var _TriggererWrapperWithEllispsisChildren = require('./TriggererWrapperWithEllispsisChildren');

var _TriggererWrapperWithEllispsisChildren2 = _interopRequireDefault(_TriggererWrapperWithEllispsisChildren);

var _TriggererWrapper = require('./TriggererWrapper');

var _TriggererWrapper2 = _interopRequireDefault(_TriggererWrapper);

var _selectUtils = require('./select-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// eslint-disable-next-line import/no-named-as-default
// import DropDown from '../internal/DropDown';


var Select = function (_Component) {
  _inherits(Select, _Component);

  function Select(props) {
    _classCallCheck(this, Select);

    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.isOpenControlled = props.isOpen !== undefined;

    _this.isControlled = props.value !== undefined;

    var children = _this.props.children;

    var storedOptions = _this.mapChildrenForStorage(children) || {};

    _this.state = {
      isOpen: _this.isOpenControlled ? _this.props.isOpen : false,
      options: storedOptions.options || [],
      optionsNode: storedOptions.optionsNode || [],
      // TODO: handle multi select
      selectedIndex: null
    };

    _this.handleDropDownChange = _this.handleDropDownChange.bind(_this);
    _this.handleKeyboardEvents = _this.handleKeyboardEvents.bind(_this);
    _this.clickHandler = _this.clickHandler.bind(_this);
    _this.toggleVisibility = _this.toggleVisibility.bind(_this);
    _this.storeTriggerWrapperRef = _this.storeTriggerWrapperRef.bind(_this);
    _this.storeChildrenWrapperRef = _this.storeChildrenWrapperRef.bind(_this);
    _this.storeSelectWrapperRef = _this.storeSelectWrapperRef.bind(_this);
    return _this;
  }

  _createClass(Select, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!this.isControlled) {
        var defaultValue = this.props.defaultValue;

        if (defaultValue !== undefined) {
          var options = this.state.options;
          // not controlled, use internal state

          var foundIndex = options.findIndex(function (o) {
            return o === defaultValue;
          });
          var selectedIndex = foundIndex > -1 ? foundIndex : null;
          this.setState({ selectedIndex: selectedIndex });
        } else {
          this.setState({ selectedIndex: 0 });
        }
      } else {
        var value = this.props.value;
        var _options = this.state.options;
        // not controlled, use internal state

        var _foundIndex = _options.findIndex(function (o) {
          return o === value;
        });
        var _selectedIndex = _foundIndex > -1 ? _foundIndex : 0;
        this.setState({ selectedIndex: _selectedIndex });
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var _props = this.props,
          children = _props.children,
          isOpen = _props.isOpen,
          value = _props.value,
          disabled = _props.disabled;


      if (_react2.default.Children.count(nextProps.children) !== _react2.default.Children.count(children)) {
        return true;
      } else if (nextProps.isOpen !== isOpen) {
        return true;
      } else if (nextProps.value !== value) {
        return true;
      } else if (nextProps.disabled !== disabled) {
        return true;
      } else if (!(0, _isEqual2.default)(this.state, nextState)) {
        return true;
      }
      return false;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      // const { isOpen: isOpenState } = this.state;
      // const { isOpen: isOpenProps } = this.props;

      // const isOpen = this.isOpenControlled ? isOpenProps : isOpenState;

      if (this.isControlled) {
        // noop
      } else if (this.state.selectedIndex) {
        var selectedIndex = prevState.selectedIndex;
        var onChange = prevProps.onChange;


        if (selectedIndex !== this.state.selectedIndex) {
          if (onChange) {
            var options = this.state.options;

            var value = options[this.state.selectedIndex];
            var fakeEvent = {
              target: { value: value },
              currentTarget: { value: value }
            };
            onChange(fakeEvent, value);
          }
        }
      }

      // if (isOpen) {
      //   window.addEventListener('keydown', this.handleKeyboardEvents, { capture: true });
      // } else {
      //   window.removeEventListener('keydown', this.handleKeyboardEvents, { capture: true });
      // }

      var children = this.props.children;

      var shouldUpdateOptions = prevProps.children && children && (prevProps.children.length !== children.length || prevProps.children !== children);

      var storedOptions = null;
      if (shouldUpdateOptions) {
        storedOptions = this.mapChildrenForStorage(children) || {};
      }

      var shouldClose = this.isControlled && !this.isOpenControlled && this.props.value !== prevProps.value;

      if (shouldUpdateOptions || shouldClose) {
        setTimeout(function () {
          var newStateProps = {};

          if (storedOptions) {
            newStateProps = {
              options: storedOptions.options,
              optionsNode: storedOptions.optionsNode
            };
          }

          if (shouldClose) {
            newStateProps = _extends({}, newStateProps, {
              isOpen: false
            });
          }

          if (Object.keys(newStateProps).length) {
            _this2.setState(newStateProps);
          }
        }, 1);
      }
    }
  }, {
    key: 'getTrigerrerLabel',
    value: function getTrigerrerLabel() {
      var _this3 = this;

      var _state = this.state,
          selectedIndexState = _state.selectedIndex,
          optionsNode = _state.optionsNode,
          options = _state.options,
          _props2 = this.props,
          error = _props2.error,
          success = _props2.success,
          value = _props2.value,
          triggerElement = _props2.triggerElement,
          style = _props2.style,
          isFullWidth = _props2.isFullWidth,
          disabled = _props2.disabled;


      if (triggerElement) {
        return triggerElement;
      }

      var selectedIndex = selectedIndexState;
      var selecteIndexMaybe = options.findIndex(function (x) {
        return x === value;
      });
      if (this.isControlled) {
        if (selecteIndexMaybe > -1) {
          selectedIndex = selecteIndexMaybe;
        }
      }

      var mainContent = null;
      if (selectedIndex >= 0 && optionsNode[selectedIndex] !== undefined) {
        mainContent = _react2.default.createElement(
          _TriggererWrapperWithEllispsisChildren2.default,
          null,
          _react2.default.createElement(
            'div',
            {
              style: {
                padding: '2px 2px 2px 6px',
                marginRight: '64px',
                display: 'flex',
                width: '100%',
                boxSizing: 'border-box',
                height: '34px',
                overflow: 'hidden'
              }
            },
            _react2.default.cloneElement(optionsNode[selectedIndex], {
              onClick: function onClick() {},
              style: _extends({}, optionsNode[selectedIndex].props.style, {
                whiteSpace: 'nowrap',
                textOverflow: 'ellipsis',
                overflow: 'hidden',
                display: 'flex',
                alignItems: 'center'
              })
            })
          )
        );
      } else {
        mainContent = _react2.default.createElement(
          'div',
          null,
          '\xA0'
        );
      }

      var disabledStyle = disabled ? {
        opacity: 0.8,
        filter: 'grayscale(100%)',
        cursor: 'not-allowed'
      } : {};

      return _react2.default.createElement(
        _UnstyledButton2.default,
        {
          disabled: disabled,
          isFullWidth: isFullWidth,
          style: _extends({}, style.width ? { width: style.width } : {}, {
            border: '1px solid #cecece',
            // borderRadius: radiusPlusOne,
            maxHeight: '34px',
            boxSizing: 'border-box'
          }, disabledStyle)
          // onEsc={() => this.clickHandler(null)}
          , onClick: function onClick(e) {
            for (var _len = arguments.length, r = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              r[_key - 1] = arguments[_key];
            }

            // if (e && e.stopPropagation) {
            //   e.stopPropagation();
            // }
            _this3.toggleVisibility.apply(_this3, [e].concat(r));
          }
        },
        _react2.default.createElement(
          'div',
          { style: { position: 'relative', width: '100%' } },
          _react2.default.createElement(
            _TriggererWrapper2.default,
            null,
            mainContent,
            _react2.default.createElement(_StatusIcon2.default, { success: success, error: error, style: { top: '0', right: '48px' } })
          ),
          _react2.default.createElement(
            'div',
            { style: _Select.styles.trigerrerIcon },
            _react2.default.createElement(_Button2.default, {
              inert: true,
              type: 'primary',
              style: _extends({
                borderBottomLeftRadius: 0,
                borderTopLeftRadius: 0,
                minHeight: '34px'
              }, disabledStyle, {
                pointerEvents: 'none'
              }),
              icon: _react2.default.createElement(_Arrowdown2.default, null)
            })
          )
        )
      );
    }
  }, {
    key: 'getOptionsItem',
    value: function getOptionsItem() {
      var _this4 = this;

      var _props3 = this.props,
          children = _props3.children,
          isOpenProps = _props3.isOpen;
      var _state2 = this.state,
          isOpenState = _state2.isOpen,
          selectedIndex = _state2.selectedIndex;


      var isOpen = this.isOpenControlled ? isOpenProps : isOpenState;

      return _react2.default.Children.map(children, function (child, i) {
        var value = child.props.value ? child.props.value : i;
        var isTheOne = _this4.isControlled ? value === _this4.props.value : selectedIndex === '' + i;

        var isTheOneStyles = isTheOne ? {
          fontWeight: '900' // eslint-disable-line indent
          // opacity: 0.7, // eslint-disable-line indent
          // background: '#fafafa', // eslint-disable-line indent
          // color: 'grey', // eslint-disable-line indent
          // eslint-disable-line indent
        } : {};

        if (_react2.default.isValidElement(child)) {
          if (!(0, _selectUtils.isDOMTypeElement)(child)) {
            return _react2.default.createElement(
              _SelectInputOptions2.default,
              _extends({
                key: i,
                onClick: function onClick(e) {
                  if (isOpen) _this4.clickHandler(e);
                },
                onEsc: function onEsc() {
                  if (isOpen) _this4.clickHandler(null);
                },
                'data-index': i
              }, child.props, {
                isOpen: isOpen,
                selected: isTheOne,
                style: _extends({
                  textOverflow: 'ellipsis',
                  overflowX: 'hidden',
                  maxWidth: '100%',
                  foo: 'bar'
                }, isTheOneStyles)
              }),
              _react2.default.cloneElement(child, {
                value: value
              })
            );
          }

          return _react2.default.createElement(
            _SelectInputOptions2.default,
            _extends({
              key: i,
              onClick: function onClick(e) {
                if (isOpen) _this4.clickHandler(e);
              },
              onEsc: function onEsc() {
                if (isOpen) _this4.clickHandler(null);
              },
              'data-index': i
            }, child.props, {
              isOpen: isOpen,
              selected: isTheOne,
              style: _extends({
                textOverflow: 'ellipsis',
                overflowX: 'hidden',
                maxWidth: '100%',
                foo: 'bar'
              }, isTheOneStyles)
            }),
            _react2.default.cloneElement(child, {
              value: value
            })
          );
        }
        return null;
      });
    }
  }, {
    key: 'handleKeyboardEvents',
    value: function handleKeyboardEvents(e) {
      if (e.key === ' ' || e.key === 'Spacebar' || e.keyCode === 32) {
        if (this.isOpenControlled) {
          var onIsOpenChange = this.props.onIsOpenChange;

          if (onIsOpenChange) {
            onIsOpenChange(!this.props.isOpen, e);
          }
        } else {
          e.preventDefault();
          e.stopPropagation();

          this.setState({
            isOpen: false
          }, this.focusTrigger);
        }
      } else if (e.key === 'Tab' || e.keyCode === 9) {
        if (!(document.activeElement.nodeName === 'BUTTON')) {
          var _document = document,
              activeElement = _document.activeElement;

          var lastOptionItem = document.activeElement.parentNode.lastChild;
          var firstOptionItem = document.activeElement.parentNode.firstChild;

          if (e.shiftKey) {
            if (activeElement === firstOptionItem && lastOptionItem && lastOptionItem.focus) {
              lastOptionItem.focus();
              if (!this.isOpenControlled) {
                e.preventDefault();
              }
            }
          } else if (activeElement === lastOptionItem && firstOptionItem && firstOptionItem.focus) {
            firstOptionItem.focus();
            if (!this.isOpenControlled) {
              e.preventDefault();
            }
          }
        }
      } else if (e.key === 'Escape' || e.keyCode === 27) {
        if (this.isOpenControlled) {
          if (this.props.onIsOpenChange) {
            this.props.onIsOpenChange(false, e);
          }
        } else {
          e.stopPropagation(); // if a drawer is open, do not let propagate
          // e.stopImmediatePropagation(); // if a drawer is open, do not let propagate
          // e.preventDefault();
          if (e && e.nativeEvent) {
            if (e.nativeEvent.stopImmediatePropagation) {
              e.nativeEvent.stopImmediatePropagation();
            }
            if (e.nativeEvent.stopPropagation) {
              e.nativeEvent.stopPropagation();
            }
          }
          this.setState({
            isOpen: false
          }, this.focusTrigger);
        }
      } else if (e.key === 'ArrowDown' || e.keyCode === 40) {
        if (!this.isOpenControlled) {
          e.preventDefault();
          e.stopPropagation();
        }

        // just go to next sigblings:
        var nextSiblingMaybe = document.activeElement.nextElementSibling;
        if (nextSiblingMaybe && nextSiblingMaybe.focus) {
          nextSiblingMaybe.focus();
        } else {
          // focus from main triggerer to (first) item:
          var nextSiblingMaybeItem = document.activeElement.parentNode.nextElementSibling;
          if (nextSiblingMaybeItem) {
            var _firstOptionItem = nextSiblingMaybeItem.firstChild;
            if (_firstOptionItem && _firstOptionItem.focus) {
              _firstOptionItem.focus();
            }
          } // else if (this.itemRef) {
          // go back to first option element
          // const firstOption = this.itemRef.firstChild;
          // if (firstOption && firstOption.focus) {
          //   firstOption.focus();
          // }
          // }
        }
      } else if (e.key === 'ArrowUp' || e.keyCode === 38) {
        if (!this.isOpenControlled) {
          e.preventDefault();
          e.stopPropagation();
        }

        var previousSiblingMaybe = document.activeElement.previousElementSibling;
        if (previousSiblingMaybe && previousSiblingMaybe.focus) {
          previousSiblingMaybe.focus();
        } else {
          var optionsWrapperDiv = document.activeElement.parentNode.nextElementSibling;
          if (optionsWrapperDiv) {
            var _lastOptionItem = document.activeElement.parentNode.nextElementSibling.lastChild;
            if (_lastOptionItem && _lastOptionItem.focus) {
              _lastOptionItem.focus();
            }
          } else {
            // go back to last option element NO!
            // const lastOption = document.activeElement.parentNode.lastChild;
            // if (lastOption && lastOption.focus) {
            //   lastOption.focus();
            // }
          }
        }
      }
    }
  }, {
    key: 'mapChildrenForStorage',
    value: function mapChildrenForStorage(children) {
      // eslint-disable-line class-methods-use-this
      var options = [];
      var optionsNode = [];
      _react2.default.Children.forEach(children, function (child, i) {
        var value = child.props.value !== undefined ? child.props.value : i;
        options[i] = value; // garanties ordering
        optionsNode[i] = _react2.default.cloneElement(child, {
          style: _extends({}, child.props.style)
        });
      });

      return {
        options: options,
        optionsNode: optionsNode
      };
    }

    // storeOptions(children) {
    //   this.setState({
    //     options: this.mapChildrenForStorage(children).options,
    //     optionsNode: this.mapChildrenForStorage(children).optionsNode,
    //   });
    // }

  }, {
    key: 'clickHandler',
    value: function clickHandler(e) {
      if (!e) {
        if (this.isOpenControlled) {
          var onIsOpenChange = this.props.onIsOpenChange;

          if (onIsOpenChange) {
            onIsOpenChange(false, null);
          }
        } else {
          if (this.isControlled) {
            // notify consumer ?
          } else {
            this.setState({
              selectedIndex: this.state.selectedIndex || null,
              isOpen: false
            }, this.focusTrigger);
          }
          this.forceUpdate();
        }

        return;
      }

      // TODO actually implement an conotrlled input on selectinput
      if (e.currentTarget && e.currentTarget.dataset && e.currentTarget.dataset.index !== undefined) {
        if (this.isControlled) {
          var onChange = this.props.onChange;

          var selectedIndex = e.currentTarget.dataset.index;
          if (!this.isOpenControlled) {
            this.setState({
              isOpen: false
            }, this.focusTrigger);
          }
          if (onChange) {
            var options = this.state.options;

            var value = options[selectedIndex];
            var fakeEvent = {
              target: { value: value },
              currentTarget: { value: value }
            };
            onChange(fakeEvent, value);
          }
        } else {
          var _selectedIndex2 = e.currentTarget.dataset.index;
          this.setState({
            selectedIndex: _selectedIndex2,
            isOpen: false
          }, this.focusTrigger);
          this.forceUpdate();
        }
      }
    }
  }, {
    key: 'toggleVisibility',
    value: function toggleVisibility() {
      if (!this.isOpenControlled) {
        var nextIsOpen = !this.state.isOpen;
        var cb = nextIsOpen === true ? this.focusContent : this.focusTrigger;

        this.setState({ isOpen: nextIsOpen }, cb);
      }
    }
  }, {
    key: 'handleDropDownChange',
    value: function handleDropDownChange(isOpen) {
      if (!this.isOpenControlled) {
        if (this.state.isOpen !== isOpen) {
          var cb = isOpen ? this.focusContent : this.focusTrigger;

          this.setState({ isOpen: isOpen }, cb);
        }
      }
      if (this.props.onIsOpenChange) {
        if (this.props.isOpen !== isOpen) {
          this.props.onIsOpenChange(isOpen);
        }
      }
    }

    // storeItemsRef(itemsNode) {
    //   this.itemRef = itemsNode;
    // }


  }, {
    key: 'focusTrigger',
    value: function focusTrigger() {
      var _this5 = this;

      // return;
      var focusTarget = this.triggerWrapperRef;

      if (focusTarget) {
        if (this.triggerWrapperRef && this.triggerWrapperRef.querySelector && this.triggerWrapperRef.querySelector('button')) {
          focusTarget = this.triggerWrapperRef.querySelector('button');
        } else if (this.triggerWrapperRef && this.triggerWrapperRef.firstChild && this.triggerWrapperRef.firstChild.focus) {
          focusTarget = this.triggerWrapperRef.firstChild;
        }

        if (focusTarget.focus) {
          var r = setTimeout(function () {
            // abort if focus has already passed to something outside the select,
            // like a second input in a form
            if (_this5.selectWrapperRef && _this5.selectWrapperRef.contains(document.activeElement) || _this5.selectWrapperRef && document.activeElement === document.body) {
              // make sure dom node still mounted
              if (focusTarget && focusTarget.focus) {
                focusTarget.focus();
              }
            }
            clearTimeout(r);
          }, 10);
        }
      }
    }
  }, {
    key: 'focusContent',
    value: function focusContent() {
      var _this6 = this;

      var selectedIndex = this.state.selectedIndex;


      var hasSelectedValue = selectedIndex && selectedIndex >= 0;

      var theIndex = this.isControlled ? this.state.options.indexOf(this.props.value) : selectedIndex;

      var getTarget = hasSelectedValue ? function () {
        var targetNode = _this6.selectWrapperRef && _this6.selectWrapperRef.querySelector('[data-index="' + theIndex + '"]');
        return targetNode;
      } : function () {
        return _this6.childrenWrapperRef && _this6.childrenWrapperRef.firstChild && _this6.childrenWrapperRef.firstChild.firstChild;
      };

      var targetMaybe = getTarget();
      if (targetMaybe && targetMaybe.focus) {
        var r = setTimeout(function () {
          // abort if focus has already passed to something outside the select,
          // like a second input in a form
          var focusIsStillWithinSelect = _this6.selectWrapperRef && _this6.selectWrapperRef.contains(document.activeElement);

          if (focusIsStillWithinSelect) {
            var _targetMaybe = getTarget(); // eslint-disable-line no-shadow
            if (_targetMaybe && _targetMaybe.focus) {
              _targetMaybe.focus();
            }
          }
          clearTimeout(r);
        }, 10);
      }
    }
  }, {
    key: 'storeTriggerWrapperRef',
    value: function storeTriggerWrapperRef(node) {
      this.triggerWrapperRef = node;
    }
  }, {
    key: 'storeChildrenWrapperRef',
    value: function storeChildrenWrapperRef(node) {
      this.childrenWrapperRef = node;
    }
  }, {
    key: 'storeSelectWrapperRef',
    value: function storeSelectWrapperRef(node) {
      this.selectWrapperRef = node;
    }
  }, {
    key: 'render',
    value: function render() {
      var isOpenState = this.state.isOpen;
      var _props4 = this.props,
          isFullWidth = _props4.isFullWidth,
          error = _props4.error,
          style = _props4.style,
          isOpenProp = _props4.isOpen;


      var isOpen = this.isOpenControlled ? isOpenProp : isOpenState;

      var optionsItems = this.getOptionsItem();

      var trigerer = this.getTrigerrerLabel();

      // if (isOpen) {
      //   window.addEventListener('keydown', this.handleKeyboardEvents, { capture: true });
      // } else {
      //   window.removeEventListener('keydown', this.handleKeyboardEvents, { capture: true });
      // }

      var keyboardKeyDownHandler = isOpen ? this.handleKeyboardEvents : null;

      return _react2.default.createElement(
        'div',
        {
          onKeyDown: keyboardKeyDownHandler,
          style: _extends({
            style: style
          }, isFullWidth ? { width: '100%' } : {}),
          ref: this.storeSelectWrapperRef
        },
        _react2.default.createElement(
          _DropDownWithClickOutside2.default,
          {
            isFullWidth: isFullWidth,
            fullWidthContent: true,
            isOpen: isOpen,
            onClickOutside: this.handleDropDownChange,
            trigger: trigerer,
            onTriggerWrapperRef: this.storeTriggerWrapperRef,
            onChildrenWrapperRef: this.storeChildrenWrapperRef
          },
          _react2.default.createElement(
            'div',
            {
              style: _extends({
                maxHeight: '320px',
                overflowY: 'auto',
                width: '100%',
                // minWidth: '180px',
                background: 'white'
              }, style.width ? { width: style.width } : {}, isFullWidth ? { width: '100%' } : {})
            },
            optionsItems
          )
        ),
        _react2.default.createElement(
          _ErrorWrapperUI2.default,
          null,
          error
        )
      );
    }
  }]);

  return Select;
}(_react.Component);

Select.defaultProps = {
  style: {},
  onChange: function onChange() {},
  children: [],
  disabled: false
};

exports.default = Select;