'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  position: relative;\n'], ['\n  position: relative;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  max-width: 100%;\n  min-height: 40px;\n  max-height: 200px;\n  border-radius: 3px;\n  box-sizing: border-box;\n  font-size: 14px;\n  border: 1px solid ', ';\n  padding: 6.5px 26px 6.5px 6.5px;\n  min-width: 100%;\n  border: 1px solid ', ';\n  &:focus {\n    outline: none;\n    border: 1px solid ', ';\n    box-shadow: 0 0 10px #719ECE; /* where\'s that color from ? */\n  }\n'], ['\n  max-width: 100%;\n  min-height: 40px;\n  max-height: 200px;\n  border-radius: 3px;\n  box-sizing: border-box;\n  font-size: 14px;\n  border: 1px solid ', ';\n  padding: 6.5px 26px 6.5px 6.5px;\n  min-width: 100%;\n  border: 1px solid ', ';\n  &:focus {\n    outline: none;\n    border: 1px solid ', ';\n    box-shadow: 0 0 10px #719ECE; /* where\'s that color from ? */\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

require('../Icons');

var _Theme = require('../Theme');

var _StatusIcon = require('./utils/StatusIcon');

var _StatusIcon2 = _interopRequireDefault(_StatusIcon);

var _ErrorWrapperUI = require('./utils/ErrorWrapperUI');

var _ErrorWrapperUI2 = _interopRequireDefault(_ErrorWrapperUI);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
// import { palette } from '../Theme/palette';

// import default theme in case not themeprovider is used


// const { semantic } = palette;

var InputWrapperUI = _styledComponents2.default.div.attrs(function (_ref) {
  var theme = _ref.theme;
  return {
    theme: theme || _Theme.theme
  };
})(_templateObject);

var InputUI = _styledComponents2.default.textarea.attrs(function (_ref2) {
  var theme = _ref2.theme;
  return {
    theme: theme || _Theme.theme,
    rows: 3
  };
})(_templateObject2, function (_ref3) {
  var semantic = _ref3.theme.palette.semantic;
  return semantic.default;
}, function (_ref4) {
  var error = _ref4.error,
      success = _ref4.success,
      semantic = _ref4.theme.palette.semantic;
  return error // eslint-disable-line no-nested-ternary
  ? semantic.error : success ? semantic.success : semantic.default;
}, function (_ref5) {
  var theme = _ref5.theme;
  return theme.palette.accent.main;
});

// eslint-disable-next-line react/prefer-stateless-function

var TextArea = function (_Component) {
  _inherits(TextArea, _Component);

  // TODO handle generating uid that doesn't force rerebder
  function TextArea(props) {
    _classCallCheck(this, TextArea);

    var _this = _possibleConstructorReturn(this, (TextArea.__proto__ || Object.getPrototypeOf(TextArea)).call(this, props));

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(TextArea, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.isControlled = this.props.value !== undefined;
      if (!this.isControlled) {
        // not controlled, use internal state
        this.setState({
          value: this.props.defaultValue !== undefined ? this.props.defaultValue : ''
        });
      }
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var value = event.target.value;

      if (!this.isControlled) {
        this.setState({ value: value });
      }

      var onChange = this.props.onChange;

      if (onChange) {
        onChange(event, value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          onChange = _props.onChange,
          style = _props.style,
          type = _props.type,
          placeholder = _props.placeholder,
          success = _props.success,
          error = _props.error,
          defaultValue = _props.defaultValue,
          attributes = _objectWithoutProperties(_props, ['onChange', 'style', 'type', 'placeholder', 'success', 'error', 'defaultValue']);

      // const stateIcon = error // eslint-disable-line no-nested-ternary
      //   ? <ErrorIcon size="16" />
      //   : (success ? <SuccessIcon size="16" /> : null
      //   );

      var inputAttributes = _extends({}, attributes, {
        value: this.isControlled ? this.props.value : this.state.value
      });

      return _react2.default.createElement(
        InputWrapperUI,
        null,
        _react2.default.createElement(InputUI, _extends({}, inputAttributes, {
          type: type,
          style: style,
          placeholder: placeholder,
          onChange: this.handleChange,
          error: error,
          success: success
        })),
        _react2.default.createElement(_StatusIcon2.default, { error: error, success: success }),
        _react2.default.createElement(
          _ErrorWrapperUI2.default,
          null,
          error
        )
      );
    }
  }]);

  return TextArea;
}(_react.Component);

TextArea.propTypes = {
  type: _propTypes2.default.oneOf(['text', 'email', 'password', 'search', 'file', 'number'])
};

TextArea.defaultProps = {
  type: 'text'
};

TextArea.displayName = 'TextArea';

exports.default = TextArea;