'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  position: relative;\n  ', ';\n'], ['\n  position: relative;\n  ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  border-radius: 3px;\n  border-radius: ', ';\n  box-sizing: border-box;\n  font-size: 14px;\n  border: 1px solid ', ';\n  padding: 6.5px 26px 6.5px 6.5px;\n  padding: ', ';\n  min-width: 100%;\n  border: 1px solid ', ';\n  transition: ', ';\n  &:focus {\n    outline: none;\n    border: 1px solid ', ';\n    box-shadow: ', ';\n    outline: ', ';\n  }\n'], ['\n  border-radius: 3px;\n  border-radius: ', ';\n  box-sizing: border-box;\n  font-size: 14px;\n  border: 1px solid ', ';\n  padding: 6.5px 26px 6.5px 6.5px;\n  padding: ', ';\n  min-width: 100%;\n  border: 1px solid ', ';\n  transition: ', ';\n  &:focus {\n    outline: none;\n    border: 1px solid ', ';\n    box-shadow: ', ';\n    outline: ', ';\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Theme = require('../Theme');

var _StatusIcon = require('./utils/StatusIcon');

var _StatusIcon2 = _interopRequireDefault(_StatusIcon);

var _ErrorWrapperUI = require('./utils/ErrorWrapperUI');

var _ErrorWrapperUI2 = _interopRequireDefault(_ErrorWrapperUI);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var InputWrapperUI = _styledComponents2.default.div.attrs(function (_ref) {
  var theme = _ref.theme;
  return {
    theme: theme || _Theme.theme
  };
})(_templateObject, function (_ref2) {
  var isFullWidth = _ref2.isFullWidth;
  return isFullWidth ? 'width: 100%' : '';
});

var InputUI = _styledComponents2.default.input.attrs(function (_ref3) {
  var theme = _ref3.theme;
  return {
    theme: theme || _Theme.theme
  };
})(_templateObject2, function (_ref4) {
  var radius = _ref4.theme.radius;
  return radius;
}, function (_ref5) {
  var semantic = _ref5.theme.palette.semantic;
  return semantic.default;
}, function (_ref6) {
  var radius = _ref6.theme.radius;
  return '6.5px 26px 6.5px ' + (6.5 + parseInt(radius.replace('px', ''), 10) * 0.6) + 'px';
}, function (_ref7) {
  var error = _ref7.error,
      success = _ref7.success,
      semantic = _ref7.theme.palette.semantic;
  return error // eslint-disable-line no-nested-ternary
  ? semantic.error : success ? semantic.success : semantic.default;
}, function (_ref8) {
  var transition = _ref8.theme.transition;
  return transition.defaultAll;
}, function (_ref9) {
  var theme = _ref9.theme;
  return theme.palette.accent.main;
}, function (_ref10) {
  var outlineShadow = _ref10.theme.outlineShadow;
  return outlineShadow;
}, function (_ref11) {
  var outlineShadow = _ref11.theme.outlineShadow;
  return outlineShadow;
});

// eslint-disable-next-line react/prefer-stateless-function

var TextField = function (_Component) {
  _inherits(TextField, _Component);

  // TODO handle generating uid that doesn't force rerebder
  function TextField(props) {
    _classCallCheck(this, TextField);

    var _this = _possibleConstructorReturn(this, (TextField.__proto__ || Object.getPrototypeOf(TextField)).call(this, props));

    _this.handleChange = _this.handleChange.bind(_this);
    _this.isControlled = _this.props.value !== undefined;
    if (!_this.isControlled) {
      _this.state = { value: '' };
    }
    return _this;
  }

  _createClass(TextField, [{
    key: 'handleChange',
    value: function handleChange(event) {
      var value = event.target.value;

      if (!this.isControlled) {
        this.setState({ value: value });
      }

      var onChange = this.props.onChange;

      if (onChange) {
        onChange(event, value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          onChange = _props.onChange,
          style = _props.style,
          type = _props.type,
          placeholder = _props.placeholder,
          success = _props.success,
          error = _props.error,
          defaultValue = _props.defaultValue,
          _props$tabIndex = _props.tabIndex,
          tabIndex = _props$tabIndex === undefined ? 0 : _props$tabIndex,
          isFullWidth = _props.isFullWidth,
          attributes = _objectWithoutProperties(_props, ['onChange', 'style', 'type', 'placeholder', 'success', 'error', 'defaultValue', 'tabIndex', 'isFullWidth']);

      var inputAttributes = _extends({}, attributes, tabIndex !== undefined ? { tabIndex: tabIndex } : {}, !this.isControlled ? { value: this.state.value } : {});

      return _react2.default.createElement(
        InputWrapperUI,
        { isFullWidth: isFullWidth },
        _react2.default.createElement(InputUI, _extends({}, inputAttributes, {

          type: type,
          style: style,
          placeholder: placeholder,
          onChange: this.handleChange,
          error: error,
          success: success
        })),
        _react2.default.createElement(_StatusIcon2.default, { error: error, success: success }),
        _react2.default.createElement(
          _ErrorWrapperUI2.default,
          null,
          error
        )
      );
    }
  }]);

  return TextField;
}(_react.Component);

TextField.propTypes = {
  type: _propTypes2.default.oneOf(['text', 'email', 'password', 'search', 'file', 'number']),
  /**
   * onChange: callback function
   * will be passed a first arg 'event' (ReactEvent)
   * as well as a énd arg 'value' (String)
   */
  onChange: _propTypes2.default.func
};

TextField.defaultProps = {
  type: 'text',

  onChange: function onChange(event, value) {} // eslint-disable-line no-unused-vars
};

TextField.displayName = 'TextField';

exports.default = TextField;