'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  cursor: pointer;\n  align-items: center;\n'], ['\n  display: flex;\n  cursor: pointer;\n  align-items: center;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  width: 30px;\n  display: flex;\n  align-items: center;\n'], ['\n  width: 30px;\n  display: flex;\n  align-items: center;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Arrowdown = require('../Icons/Arrowdown');

var _Arrowdown2 = _interopRequireDefault(_Arrowdown);

var _Arrowright = require('../Icons/Arrowright');

var _Arrowright2 = _interopRequireDefault(_Arrowright);

var _Checkbox = require('./Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var TreeNodeContainer = _styledComponents2.default.div(_templateObject);

var ToogleLink = _styledComponents2.default.a(_templateObject2);

var forEachTreeElement = function forEachTreeElement(tree, cb, predicate) {
  if (tree.childNodes) {
    tree.childNodes.forEach(function (n) {
      forEachTreeElement(n, cb, predicate);
    });
  }

  if ((!predicate || predicate(tree)) && cb) {
    cb(tree);
  }
};

var searchTree = function searchTree(element, predicate) {
  if (predicate(element)) {
    return element;
  }

  var result = null;
  (element.childNodes || []).forEach(function (child) {
    if (!result) {
      result = searchTree(child, predicate);
    }
  });

  return result;
};

var updateTree = function updateTree(node, checked, selectedId) {
  var foundNode = searchTree(node, function (n) {
    return n.id === selectedId;
  });

  // when false we chould update the tree backwards
  foundNode.isChecked = checked;

  if (foundNode.childNodes) {
    forEachTreeElement(foundNode, function (n) {
      // eslint-disable-next-line no-param-reassign
      n.isChecked = checked;
    });
  }

  return node;
};

var getUpdatedSelection = function getUpdatedSelection(node) {
  var result = [];

  forEachTreeElement(node, function (n) {
    if (n.isChecked) {
      result.push(n.id);
    }
  });

  return result;
};

var arrayToTree = function arrayToTree(arr) {
  var parentId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  return !arr || !arr.filter ? [] : arr.filter(function (n) {
    return n.Parent === parentId;
  }).map(function (n) {
    return _extends({}, n, { childNodes: arrayToTree(arr, n.id) });
  });
};

var TreeNode = function (_Component) {
  _inherits(TreeNode, _Component);

  function TreeNode(props) {
    _classCallCheck(this, TreeNode);

    var _this = _possibleConstructorReturn(this, (TreeNode.__proto__ || Object.getPrototypeOf(TreeNode)).call(this, props));

    _this.state = {
      visible: true,
      isChecked: props.isChecked || false,
      node: props.rootNode || {}
    };

    _this.select = _this.select.bind(_this);
    _this.toggle = _this.toggle.bind(_this);
    _this.onMainChange = _this.onMainChange.bind(_this);
    return _this;
  }

  _createClass(TreeNode, [{
    key: 'onMainChange',
    value: function onMainChange(selectedNode, isChecked) {
      var onChange = this.props.onChange;
      var node = this.state.node;


      var updateNodes = updateTree(node, isChecked, selectedNode.id);
      var selectedNodes = getUpdatedSelection(updateNodes) || [];

      this.setState({
        node: updateNodes,
        selectedNodes: selectedNodes
      });

      if (onChange) {
        onChange(updateNodes, selectedNodes);
      }
    }
  }, {
    key: 'getNodeContent',
    value: function getNodeContent() {
      var _this2 = this;

      var node = this.state.node;
      var onMainChange = this.props.onMainChange;


      var nodeValue = node.isChecked || false;
      var title = node.title || node.Name;
      var expanderIconContent = this.getToggleLink();

      return _react2.default.createElement(
        TreeNodeContainer,
        null,
        expanderIconContent,
        _react2.default.createElement(_Checkbox2.default, {
          checked: nodeValue,
          onChange: function onChange(e, isChecked) {
            if (onMainChange) {
              onMainChange(node, isChecked);
            } else {
              _this2.onMainChange(node, isChecked);
            }
          },
          label: title
        })
      );
    }
  }, {
    key: 'getToggleLink',
    value: function getToggleLink() {
      var _state = this.state,
          visible = _state.visible,
          node = _state.node;


      if (!node || !node.childNodes || node.childNodes.length === 0) {
        return _react2.default.createElement('span', { style: { paddingLeft: '30px' } });
      }

      return _react2.default.createElement(
        ToogleLink,
        { onClick: this.toggle },
        visible ? _react2.default.createElement(_Arrowdown2.default, { size: 16, style: { paddingLeft: '5px' } }) : _react2.default.createElement(_Arrowright2.default, { size: 16, style: { paddingLeft: '5px' } })
      );
    }
  }, {
    key: 'select',
    value: function select(currentNode, isChecked) {
      var onSelect = this.props.onSelect;


      if (onSelect) {
        onSelect(currentNode, isChecked);
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      this.setState({ visible: !this.state.visible });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          onMainChange = _props.onMainChange;
      var _state2 = this.state,
          node = _state2.node,
          visible = _state2.visible;


      if (!node || !node.id) {
        return _react2.default.createElement('div', { className: className, style: style || {} });
      }

      var currentNodeContent = this.getNodeContent();

      return _react2.default.createElement(
        'div',
        { className: className, style: style || {} },
        currentNodeContent,
        node && node.childNodes != null && visible && _react2.default.createElement(
          'ul',
          { style: { marginLeft: '30px' } },
          node.childNodes.map(function (n, index) {
            return _react2.default.createElement(
              'li',
              { key: index },
              _react2.default.createElement(TreeNode, {
                onMainChange: onMainChange || _this3.onMainChange,
                rootNode: n
              })
            );
          })
        )
      );
    }
  }]);

  return TreeNode;
}(_react.Component);

TreeNode.propTypes = {
  isChecked: _propTypes2.default.bool.isRequired,
  onSelect: _propTypes2.default.func.isRequired,
  rootNode: _propTypes2.default.shape({
    Id: _propTypes2.default.string.isRequired,
    Name: _propTypes2.default.string.isRequired,
    IsChecked: _propTypes2.default.bool,
    Parent: _propTypes2.default.any
  }).isRequired
};
exports.default = TreeNode;