'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.appLayoutCSSString = undefined;

var _templateObject = _taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/**
 * This comp takes 3 children and make a simple
 * fully responsive, always at least full-height/width
 * vertical header-content-footer layout
 *
 * If you want to use it for the entire viewport,
 * it's up to you to make the space around available
 * e.g. remove body margin, make the html and body full height...
 *
 * same goes if you want it not to spen wider that a ertain width or height
 * you need to constrict/constrain the available space yourself
 */

var appLayoutCSSString = exports.appLayoutCSSString = '\n  height: 100%;\n  display: flex;\n  flex-flow: column nowrap;\n  position: relative;\n  & > * {\n    box-sizing: border-box;\n    flex-grow: 0;\n    flex-shrink: 0;\n  }\n  & > *:nth-child(2) {\n    flex-grow: 99;\n    flex-shrink: 1;\n    overflow-y: auto;\n  }\n';

// TODO: would using flexbasis allow for auto transitionalbe layout ?
var AppLayout = _styledComponents2.default.div(_templateObject, appLayoutCSSString);

AppLayout.displayName = 'AppLayout';

exports.default = AppLayout;