'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  ', ';\n  width: 100vh;\n  min-width: 100vh;\n  max-width: 100vh;\n  justify-content: flex-start;\n  align-items: stretch;\n'], ['\n  ', ';\n  ', ';\n  width: 100vh;\n  min-width: 100vh;\n  max-width: 100vh;\n  justify-content: flex-start;\n  align-items: stretch;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  ', ';\n  min-height: 100vh;\n  height: 100vh;\n  max-height: 100vh;\n  width: auto;\n  display: flex;\n  align-items: flex-start;\n  justify-content: flex-start;\n  flex-flow: column nowrap;\n  &>* {}\n  &>*:first-child() { }\n  &>*:nth-child(2) {\n    flex-grow: 9;\n    overflow-y: auto; /* applies to same elem as line 49 */\n    overflow-scrolling: touch;\n    -webkit-overflow-scrolling: touch;\n  }\n  /* TODO: make the entire cluedin content mobile first! */\n  &>* { width: calc(100vw - ', ') }\n  @media (min-width: ', ') {\n    &>* { width: calc(100vw - ', ') }\n  }\n'], ['\n  ', ';\n  min-height: 100vh;\n  height: 100vh;\n  max-height: 100vh;\n  width: auto;\n  display: flex;\n  align-items: flex-start;\n  justify-content: flex-start;\n  flex-flow: column nowrap;\n  &>* {}\n  &>*:first-child() { }\n  &>*:nth-child(2) {\n    flex-grow: 9;\n    overflow-y: auto; /* applies to same elem as line 49 */\n    overflow-scrolling: touch;\n    -webkit-overflow-scrolling: touch;\n  }\n  /* TODO: make the entire cluedin content mobile first! */\n  &>* { width: calc(100vw - ', ') }\n  @media (min-width: ', ') {\n    &>* { width: calc(100vw - ', ') }\n  }\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  ', ';\n  & > *:nth-child(1) {\n    flex-grow: 99;\n    flex-shrink: 0;\n  }\n  & > *:nth-child(2) {\n    flex-grow: 1;\n    flex-shrink: 0;\n  }\n'], ['\n  ', ';\n  & > *:nth-child(1) {\n    flex-grow: 99;\n    flex-shrink: 0;\n  }\n  & > *:nth-child(2) {\n    flex-grow: 1;\n    flex-shrink: 0;\n  }\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  min-height: 100%;\n  box-shadow: 0 53px 1px 2px rgba(72, 72, 72, 0.27), 0 53px 1px 2px rgba(32, 32, 32, 0.22);\n  z-index: 2;\n'], ['\n  min-height: 100%;\n  box-shadow: 0 53px 1px 2px rgba(72, 72, 72, 0.27), 0 53px 1px 2px rgba(32, 32, 32, 0.22);\n  z-index: 2;\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  box-shadow: 0 0 1px 2px rgba(72, 72, 72, .27), 0 0 1px 2px rgba(32, 32, 32, 0.22);\n  z-index: 1;\n'], ['\n  box-shadow: 0 0 1px 2px rgba(72, 72, 72, .27), 0 0 1px 2px rgba(32, 32, 32, 0.22);\n  z-index: 1;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _ = require('./');

var _defaults = require('../Menu/defaults');

var _defaults2 = _interopRequireDefault(_defaults);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// eslint-disable-line import/no-named-as-default

// TODO: would using flexbasis allow for auto transitionalbe layout ?


var breakpoint = _defaults2.default.breakpoint,
    menuWidth = _defaults2.default.menuWidth,
    bigMenuWidth = _defaults2.default.bigMenuWidth;
/**
 * the only reason we"'re forcing width
 * is because the content lower down the tree
 * is not worry of being accessible within a small are enough
 * the 'calc(100vw - ${(big)menuWidth})' should be remove eventually
*/

var FlexLeftColExtended = _styledComponents2.default.div(_templateObject, function () {
  return (/* props */_.flexLeftColCSSString
  );
}, function () {
  return (/* props */_.flexCSSString
  );
});

var AppLayoutExtended = _styledComponents2.default.div(_templateObject2, function () {
  return (/* props */_.appLayoutCSSString
  );
}, menuWidth, breakpoint, bigMenuWidth);

var InnerAppLayoutUI = _styledComponents2.default.div(_templateObject3, _.appLayoutCSSString);

var FlexLeftColumnInnerWrapper = _styledComponents2.default.div(_templateObject4);

var HeaderWrapper = _styledComponents2.default.div(_templateObject5);

var errorMsg = 'GlobalAppLayout will only work with all those props:\n  - globalMenu,\n  - globalHeader,\n  - globalContent,\n  - globalFooter\n';

var GlobalAppLayout = function GlobalAppLayout(props) {
  var menu = props.menu,
      _props$menuStyle = props.menuStyle,
      menuStyle = _props$menuStyle === undefined ? {} : _props$menuStyle,
      header = props.header,
      _props$headerStyle = props.headerStyle,
      headerStyle = _props$headerStyle === undefined ? {} : _props$headerStyle,
      content = props.content,
      footer = props.footer,
      children = props.children,
      wrapperStyle = props.wrapperStyle,
      innerWrapperStyle = props.innerWrapperStyle;


  if (!(menu && header && content && footer)) {
    console.error(errorMsg);
    return _react2.default.createElement('div', null);
  }

  return _react2.default.createElement(
    FlexLeftColExtended,
    { className: 'uxi_FlexLeftColExtended', style: _extends({}, wrapperStyle) },
    _react2.default.createElement(
      FlexLeftColumnInnerWrapper,
      { style: menuStyle },
      menu
    ),
    _react2.default.createElement(
      AppLayoutExtended,
      { style: _extends({}, innerWrapperStyle) },
      _react2.default.createElement(
        HeaderWrapper,
        { style: headerStyle },
        header
      ),
      _react2.default.createElement(
        InnerAppLayoutUI,
        { className: 'uxi_GAL-main-scrolling-element' },
        content,
        footer
      )
    ),
    children
  );
};

GlobalAppLayout.displayName = 'GlobalAppLayout';

exports.default = GlobalAppLayout;