'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  box-sizing: border-box;\n  margin: 0 auto;\n  display: flex;  /* for IE11 only */\n  flex-flow: row wrap;  /* for IE11 only */\n  display: grid;\n  grid-gap: ', ';\n  grid-template-columns: ', ';\n  font-size: inherit;\n  & > * {\n    box-sizing: border-box;\n    ', ';\n    ', ';\n  }\n\n  /**\n   * add gap for flax layout, (no margin collapse with flex)\n   * Target exclusively IE10 and above: */\n  @media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n    & {\n      padding: ', ';\n      margin-left: auto !important;\n      margin-right: auto !important;\n      width: ', ';\n      /* width: ', '; */\n    }\n    & > * {\n      margin: ', ';\n      ', ';\n      ', ';    }\n  }\n'], ['\n  ', ';\n  box-sizing: border-box;\n  margin: 0 auto;\n  display: flex;  /* for IE11 only */\n  flex-flow: row wrap;  /* for IE11 only */\n  display: grid;\n  grid-gap: ', ';\n  grid-template-columns: ', ';\n  font-size: inherit;\n  & > * {\n    box-sizing: border-box;\n    ', ';\n    ', ';\n  }\n\n  /**\n   * add gap for flax layout, (no margin collapse with flex)\n   * Target exclusively IE10 and above: */\n  @media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n    & {\n      padding: ', ';\n      margin-left: auto !important;\n      margin-right: auto !important;\n      width: ', ';\n      /* width: ', '; */\n    }\n    & > * {\n      margin: ', ';\n      ', ';\n      ', ';    }\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PropsMapperContainerQueries = require('../internal/PropsMapperContainerQueries');

var _PropsMapperContainerQueries2 = _interopRequireDefault(_PropsMapperContainerQueries);

var _SimpleGrid = require('./SimpleGrid');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
// eslint-disable-next-line import/no-named-as-default


/* eslint-disable indent */
var ExtendedGridUI = _styledComponents2.default.div(_templateObject, _SimpleGrid.gridUICSSString, function (_ref) {
  var gap = _ref.gap;
  return gap + 'px';
}, function (_ref2) {
  var itemWidth = _ref2.itemWidth;
  return 'repeat(auto-fill, minmax(' + itemWidth + 'px, 1fr));';
}, function (_ref3) {
  var itemWidth = _ref3.itemWidth;
  return 'min-width: ' + itemWidth + 'px';
}, function (_ref4) {
  var itemHeight = _ref4.itemHeight;
  return 'height: ' + itemHeight + 'px';
}, function (_ref5) {
  var gap = _ref5.gap;
  return gap / 2 + 'px';
}, function (_ref6) {
  var columns = _ref6.columns,
      itemWidth = _ref6.itemWidth,
      gap = _ref6.gap;
  return columns * (itemWidth + gap) + gap + 'px;';
}, function (_ref7) {
  var columns = _ref7.columns,
      itemWidth = _ref7.itemWidth,
      gap = _ref7.gap;
  return 'calc(' + columns + ' * calc(' + itemWidth + 'px + ' + 2 * gap + 'px))';
}, function (_ref8) {
  var gap = _ref8.gap;
  return gap / 2 + 'px';
}, function (_ref9) {
  var itemWidth = _ref9.itemWidth;
  return 'max-width: ' + itemWidth + 'px';
}, function (_ref10) {
  var itemWidth = _ref10.itemWidth;
  return 'width: ' + itemWidth + 'px';
});
/* eslint-enable indent */

var rules = [{
  minWidth: 0,
  mapper: function mapper(_ref11) {
    var itemWidth = _ref11.itemWidth,
        containerWidth = _ref11.containerWidth,
        gap = _ref11.gap;

    var columns = Math.floor(Math.floor(containerWidth) / (itemWidth + gap));

    return {
      columns: columns
    };
  }
}];

var Grid = function Grid(_ref12) {
  var children = _ref12.children,
      restOfProps = _objectWithoutProperties(_ref12, ['children']);

  return _react2.default.createElement(
    _PropsMapperContainerQueries2.default,
    _extends({}, restOfProps, {
      rules: rules
    }),
    _react2.default.createElement(
      ExtendedGridUI,
      null,
      children
    )
  );
};

Grid.propTypes = {
  itemWidth: _propTypes2.default.number,
  itemHeight: _propTypes2.default.number,
  gap: _propTypes2.default.number,
  style: _propTypes2.default.object
};

Grid.defaultProps = {
  itemWidth: 96,
  itemHeight: undefined,
  gap: 16,
  style: {}
};

Grid.displayName = 'Grid';

exports.default = Grid;