'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Tabs = require('../Tabs');

var _Col = require('./Col');

var _Col2 = _interopRequireDefault(_Col);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultPlaceHolder = 'main';
var defaultGridSize = 4;

var defaultLayout = {
  name: 'Default',
  children: [{
    type: 'row',
    columns: [{ size: 12, name: 'main' }]
  }]
};

var DefaultComponent = function DefaultComponent(props) {
  return _react2.default.createElement(
    'div',
    null,
    'LayoutName: ',
    props.identifier,
    _react2.default.createElement('br', null),
    'RenderingContext: ',
    JSON.stringify(props || {})
  );
};

var DebugComponentRenderer = function DebugComponentRenderer(_ref) {
  var identifier = _ref.identifier,
      renderingContext = _ref.renderingContext,
      componentDefinition = _ref.componentDefinition;
  return _react2.default.createElement(componentDefinition.component || DefaultComponent, Object.assign({ identifier: identifier }, renderingContext));
};

var Layout = function (_Component) {
  _inherits(Layout, _Component);

  function Layout() {
    _classCallCheck(this, Layout);

    return _possibleConstructorReturn(this, (Layout.__proto__ || Object.getPrototypeOf(Layout)).apply(this, arguments));
  }

  _createClass(Layout, [{
    key: 'getTabMenu',
    value: function getTabMenu(tabs) {
      return tabs.map(Layout.buildTabMenu, this);
    }
  }, {
    key: 'getLayoutLayoutConfiguration',
    value: function getLayoutLayoutConfiguration() {
      var layoutName = this.props.layoutName;

      if (!layoutName) {
        return defaultLayout;
      }
      var foundLayout = this.findLayout(layoutName);

      return foundLayout || defaultLayout;
    }
  }, {
    key: 'getTabConfig',
    value: function getTabConfig(tab) {
      var _props = this.props,
          componentDefinitions = _props.componentDefinitions,
          renderingContext = _props.renderingContext;


      return {
        renderingContext: Object.assign({}, renderingContext, {
          ignoreContext: tab.skipContext,
          includeSuggestedSearches: tab.includeSuggestedSearches,
          suggestedSearchFilter: tab.suggestedSearchFilter
        }),
        layoutName: tab.layout ? tab.layout.name : '',
        componentDefinitions: componentDefinitions
      };
    }
  }, {
    key: 'getTabContent',
    value: function getTabContent(tabs) {
      var _this2 = this;

      var layoutName = this.props.layoutName;

      return tabs.map(function (tab) {
        // TODO: separate the rendering Context from the Components to render
        var tabConfiguration = _this2.getTabConfig(tab);
        var layoutNameWithTab = layoutName + '-' + (tab.name || tab.displayName);
        return _react2.default.createElement(
          _Tabs.TabPanel,
          { key: layoutNameWithTab },
          _react2.default.createElement(
            'div',
            { className: 'cluedIn_container' },
            _react2.default.createElement(Layout, {
              componentDefinitions: tabConfiguration.componentDefinitions,
              renderingContext: tabConfiguration.renderingContext,
              layoutName: tab.layout ? tab.layout.name : '',
              id: layoutNameWithTab,
              currentPlaceholderName: tab.name,
              isMain: false
            })
          )
        );
      });
    }
  }, {
    key: 'findLayout',
    value: function findLayout(layoutName) {
      if (!this.context && !this.context.layouts) {
        return undefined;
      }

      return this.context.layouts.find(function (l) {
        return l.code === layoutName;
      });
    }
  }, {
    key: 'renderComponent',
    value: function renderComponent(layoutName, componentDefinition) {
      var _props2 = this.props,
          renderingContext = _props2.renderingContext,
          ComponentRenderer = _props2.ComponentRenderer;


      return _react2.default.createElement(ComponentRenderer, {
        layoutName: layoutName,
        renderingContext: renderingContext,
        componentDefinition: componentDefinition
      });
    }
  }, {
    key: 'renderComponents',
    value: function renderComponents(parentPlaceholderName, placeHolderName, componentDefinitions) {
      var _props3 = this.props,
          renderingContext = _props3.renderingContext,
          ComponentRenderer = _props3.ComponentRenderer;

      var currentPlaceholderName = parentPlaceholderName ? parentPlaceholderName + '.' + placeHolderName : placeHolderName;

      var filteredComponents = Layout.filterComponents(componentDefinitions, currentPlaceholderName);

      return filteredComponents.map(function (componentDefinition) {
        return _react2.default.createElement(ComponentRenderer, {
          key: currentPlaceholderName,
          identifier: currentPlaceholderName,
          renderingContext: renderingContext,
          componentDefinition: componentDefinition
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props4 = this.props,
          componentDefinitions = _props4.componentDefinitions,
          layoutName = _props4.layoutName,
          isMain = _props4.isMain,
          tabs = _props4.tabs,
          currentPlaceholderName = _props4.currentPlaceholderName;

      var mainLayoutConfiguration = this.getLayoutLayoutConfiguration();
      var hasTab = tabs && tabs[0] && tabs[0].children;

      var letTabContent = void 0;
      var tabContentPlaceholder = void 0;

      if (hasTab) {
        tabContentPlaceholder = tabs.place || 'main';

        var tabMenuContent = this.getTabMenu(tabs[0].children);
        var tabListContent = this.getTabContent(tabs[0].children, tabContentPlaceholder);

        if (tabListContent) {
          letTabContent = _react2.default.createElement(
            _Tabs.Tabs,
            { isMainStyle: isMain },
            _react2.default.createElement(
              _Tabs.TabList,
              null,
              tabMenuContent
            ),
            tabListContent
          );
        }
      }

      var layoutContent = mainLayoutConfiguration.children.map(function (row, index) {
        if (row.type === 'row') {
          if (hasTab && mainLayoutConfiguration.children && mainLayoutConfiguration.children.length === 1 && mainLayoutConfiguration.children[0].columns && mainLayoutConfiguration.children[0].columns.length === 1) {
            return _react2.default.createElement(
              'div',
              { key: layoutName + '-mainCol-' + index },
              row.columns.map(function (col, i) {
                return _react2.default.createElement(
                  'div',
                  { key: layoutName + '-mainRow-' + i },
                  letTabContent && col.name === tabContentPlaceholder ? letTabContent : undefined,
                  _this3.renderComponents(currentPlaceholderName, col.name, componentDefinitions)
                );
              })
            );
          }
          return _react2.default.createElement(
            _Row2.default,
            { key: 'row-' + index },
            row.columns.map(function (col, i) {
              return _react2.default.createElement(
                _Col2.default,
                { key: 'col-' + i, size: col.size, mobileSize: col.mobileSize },
                _this3.renderComponents(currentPlaceholderName, col.name, componentDefinitions)
              );
            })
          );
        }
        var gridSize = row.size || defaultGridSize;
        var gridPlaceHolderName = row.name || defaultPlaceHolder;

        return _react2.default.createElement(
          _Row2.default,
          { key: 'row-' + index },
          Layout.filterComponents(componentDefinitions, gridPlaceHolderName).map(function (componentDefinition, i) {
            return _react2.default.createElement(
              _Col2.default,
              { key: 'col-' + i, size: gridSize },
              _this3.renderComponent(gridPlaceHolderName, componentDefinition)
            );
          })
        );
      });

      return _react2.default.createElement(
        'div',
        null,
        layoutContent
      );
    }
  }], [{
    key: 'filterComponents',
    value: function filterComponents(componentDefinitions, placeHolderName) {
      return componentDefinitions.filter(function (componentDefinition) {
        if (componentDefinition.place) {
          return componentDefinition.place === placeHolderName;
        }

        return defaultPlaceHolder === placeHolderName;
      });
    }
  }, {
    key: 'buildTabMenu',
    value: function buildTabMenu(tab, index) {
      return _react2.default.createElement(
        _Tabs.Tab,
        { key: index },
        tab.displayName || tab.name
      );
    }
  }]);

  return Layout;
}(_react.Component);

Layout.defaultProps = {
  ComponentRenderer: DebugComponentRenderer,
  componentDefinitions: [],
  isMain: true
};
Layout.contextTypes = {
  layouts: _propTypes2.default.array
};
exports.default = Layout;