'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  display:flex;\n  flex-wrap: wrap;\n  @media (min-width: ', ') {\n    justify-content: space-between;\n  }\n'], ['\n  display:flex;\n  flex-wrap: wrap;\n  @media (min-width: ', ') {\n    justify-content: space-between;\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  position: relative;\n  box-sizing:border-box;\n  width: ', '%;\n  margin-bottom: ', '\x1B};\n  min-height: ', ';\n\n  @media screen and (min-width: ', ') {\n    width: ', '%;\n    width: ', ';\n    min-height: ', ';\n  }\n  @media screen and (min-width: ', ') {\n    width: ', '%;\n    width: ', ';\n    min-height: ', ';\n  }\n'], ['\n  position: relative;\n  box-sizing:border-box;\n  width: ', '%;\n  margin-bottom: ', '\x1B};\n  min-height: ', ';\n\n  @media screen and (min-width: ', ') {\n    width: ', '%;\n    width: ', ';\n    min-height: ', ';\n  }\n  @media screen and (min-width: ', ') {\n    width: ', '%;\n    width: ', ';\n    min-height: ', ';\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SimpleFlexLayoutWrapper = _styledComponents2.default.div(_templateObject, function (_ref) {
  var tabletBreakPoint = _ref.tabletBreakPoint;
  return tabletBreakPoint;
});

var SimpleFlexLayoutItem = _styledComponents2.default.div(_templateObject2, function (_ref2) {
  var mobileWidth = _ref2.mobileWidth;
  return mobileWidth;
}, function (_ref3) {
  var gutterInt = _ref3.gutterInt;
  return gutterInt * 1.5 + 'px;';
}, function (_ref4) {
  var itemMinHeight = _ref4.itemMinHeight;
  return itemMinHeight;
}, function (_ref5) {
  var tabletBreakPoint = _ref5.tabletBreakPoint;
  return tabletBreakPoint;
}, function (_ref6) {
  var tabletColumnWidth = _ref6.tabletColumnWidth;
  return tabletColumnWidth;
}, function (_ref7) {
  var tabletColumnWidth = _ref7.tabletColumnWidth,
      gutterTabletInt = _ref7.gutterTabletInt;
  return 'calc(' + tabletColumnWidth + '% - ' + gutterTabletInt + 'px);';
}, function (_ref8) {
  var itemTabletMinHeight = _ref8.itemTabletMinHeight;
  return itemTabletMinHeight;
}, function (_ref9) {
  var desktopBreakPoint = _ref9.desktopBreakPoint;
  return desktopBreakPoint;
}, function (_ref10) {
  var desktopWidth = _ref10.desktopWidth;
  return desktopWidth;
}, function (_ref11) {
  var desktopWidth = _ref11.desktopWidth,
      gutterDesktopInt = _ref11.gutterDesktopInt;
  return 'calc(' + desktopWidth + '% - ' + gutterDesktopInt + 'px);';
}, function (_ref12) {
  var itemDesktopMinHeight = _ref12.itemDesktopMinHeight;
  return itemDesktopMinHeight;
});

var SimpleFlexLayout = function SimpleFlexLayout(_ref13) {
  var _ref13$columnNumber = _ref13.columnNumber,
      columnNumber = _ref13$columnNumber === undefined ? 1 : _ref13$columnNumber,
      _ref13$children = _ref13.children,
      children = _ref13$children === undefined ? [] : _ref13$children,
      desktopColumnNumber = _ref13.desktopColumnNumber,
      tabletColumnNumber = _ref13.tabletColumnNumber,
      _ref13$gutter = _ref13.gutter,
      gutter = _ref13$gutter === undefined ? '0' : _ref13$gutter,
      style = _ref13.style,
      tabletBreakPoint = _ref13.tabletBreakPoint,
      desktopBreakPoint = _ref13.desktopBreakPoint,
      itemMinHeight = _ref13.itemMinHeight,
      itemTabletMinHeight = _ref13.itemTabletMinHeight,
      itemDesktopMinHeight = _ref13.itemDesktopMinHeight,
      itemStyle = _ref13.itemStyle;

  var simplayLayoutContent = [];

  var desktopWidth = Math.round(1 / (desktopColumnNumber || columnNumber) * 10000) / 100;
  var mobileWidth = Math.round(1 / columnNumber * 10000) / 100;
  var tabletColumnWidth = Math.round(1 / (tabletColumnNumber || columnNumber) * 10000) / 100;
  var gutterInt = parseInt(gutter, 10);
  var gutterTabletInt = parseInt(gutter, 10) * (tabletColumnNumber - 1) / tabletColumnNumber;
  var gutterDesktopInt = parseInt(gutter, 10) * (desktopColumnNumber - 1) / desktopColumnNumber;

  _react2.default.Children.forEach(children, function (child, index) {
    if (!_react2.default.isValidElement(child)) return;

    simplayLayoutContent.push(_react2.default.createElement(
      SimpleFlexLayoutItem,
      {
        key: 'simpleLayout-row-' + index,
        desktopWidth: desktopWidth,
        mobileWidth: mobileWidth,
        tabletColumnWidth: tabletColumnWidth,
        className: 'uxi-simple-flex-layout-col',
        gutter: gutter,
        gutterInt: gutterInt,
        gutterTabletInt: gutterTabletInt,
        gutterDesktopInt: gutterDesktopInt,
        tabletBreakPoint: tabletBreakPoint,
        desktopBreakPoint: desktopBreakPoint,
        columnNumber: columnNumber,
        tabletColumnNumber: tabletColumnNumber,
        desktopColumnNumber: desktopColumnNumber,
        itemMinHeight: itemMinHeight,
        itemTabletMinHeight: itemTabletMinHeight,
        itemDesktopMinHeight: itemDesktopMinHeight,
        style: itemStyle
      },
      child
    ));
  });

  return _react2.default.createElement(
    SimpleFlexLayoutWrapper,
    {
      style: style,
      className: 'uxi-simple-flex-layout',
      tabletBreakPoint: tabletBreakPoint,
      desktopBreakPoint: desktopBreakPoint
    },
    simplayLayoutContent
  );
};

SimpleFlexLayout.defaultProps = {
  tabletBreakPoint: '768px',
  desktopBreakPoint: '992px',
  gutter: '0',
  columnNumber: 1,
  tabletColumnNumber: 1,
  desktopColumnNumber: 1,
  itemMinHeight: '1px',
  itemTabletMinHeight: '1px',
  itemDesktopMinHeight: '1px'

};

exports.default = SimpleFlexLayout;