'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GridUI = exports.gridUICSSString = undefined;

var _templateObject = _taggedTemplateLiteral(['\n  box-sizing: border-box;\n  margin: 0 auto;\n  display: flex;  /* for IE11 only */\n  flex-flow: row wrap;  /* for IE11 only */\n  display: grid;\n  grid-gap: ', ';\n  grid-template-columns: ', ';\n  grid-template-rows: ', ';\n  font-size: inherit;\n  & > * {\n    box-sizing: border-box;\n    ', ';\n    ', ';\n  }\n\n  /**\n   * add gap for flax layout, (no margin collapse with flex)\n   * Target exclusively IE10 and above: */\n  @media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n    & {\n      padding: ', ';\n    }\n    & > * {\n      margin: ', ';\n      ', ';\n      ', ';\n      ', ';\n      ', ';\n      ', ';\n    }\n  }\n'], ['\n  box-sizing: border-box;\n  margin: 0 auto;\n  display: flex;  /* for IE11 only */\n  flex-flow: row wrap;  /* for IE11 only */\n  display: grid;\n  grid-gap: ', ';\n  grid-template-columns: ', ';\n  grid-template-rows: ', ';\n  font-size: inherit;\n  & > * {\n    box-sizing: border-box;\n    ', ';\n    ', ';\n  }\n\n  /**\n   * add gap for flax layout, (no margin collapse with flex)\n   * Target exclusively IE10 and above: */\n  @media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {\n    & {\n      padding: ', ';\n    }\n    & > * {\n      margin: ', ';\n      ', ';\n      ', ';\n      ', ';\n      ', ';\n      ', ';\n    }\n  }\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  ', ';\n'], ['\n  ', ';\n']);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var getValueWithUnit = function getValueWithUnit(prop) {
  return typeof prop === 'string' ? prop : prop + 'px';
};

/* eslint-disable indent */
var gridUICSSString = exports.gridUICSSString = (0, _styledComponents.css)(_templateObject, function (_ref) {
  var gap = _ref.gap;
  return '' + getValueWithUnit(gap);
}, function (_ref2) {
  var itemWidth = _ref2.itemWidth,
      columnAutoSizing = _ref2.columnAutoSizing;
  return 'repeat(auto-' + columnAutoSizing + ', minmax(' + getValueWithUnit(itemWidth) + ', 1fr));';
}, function (_ref3) {
  var itemHeight = _ref3.itemHeight,
      rowAutoSizing = _ref3.rowAutoSizing;
  return 'repeat(auto-' + rowAutoSizing + ', minmax(' + getValueWithUnit(itemHeight) + ', 1fr));';
}, function (_ref4) {
  var itemWidth = _ref4.itemWidth;
  return 'min-width: ' + getValueWithUnit(itemWidth);
}, function (_ref5) {
  var itemHeight = _ref5.itemHeight;
  return 'height: ' + getValueWithUnit(itemHeight) + ' !important';
}, function (_ref6) {
  var gap = _ref6.gap;
  return '' + getValueWithUnit(gap);
}, function (_ref7) {
  var gap = _ref7.gap;
  return gap ? getValueWithUnit(gap) : '0';
}, function (_ref8) {
  var itemWidth = _ref8.itemWidth;
  return 'max-width: ' + getValueWithUnit(itemWidth);
}, function (_ref9) {
  var itemWidth = _ref9.itemWidth;
  return 'width: ' + getValueWithUnit(itemWidth);
}, function (_ref10) {
  var itemHeight = _ref10.itemHeight;
  return 'max-height: ' + getValueWithUnit(itemHeight);
}, function (_ref11) {
  var itemHeight = _ref11.itemHeight;
  return 'height: ' + getValueWithUnit(itemHeight) + ' !important';
}, function (_ref12) {
  var itemHeight = _ref12.itemHeight;
  return 'min-height: ' + getValueWithUnit(itemHeight) + ' !important';
});

var GridUI = exports.GridUI = _styledComponents2.default.div(_templateObject2, gridUICSSString);
/* eslint-enable indent */

GridUI.defaultProps = {
  style: {},
  itemWidth: '100%',
  gap: 0,
  columnAutoSizing: 'fill',
  rowAutoSizing: 'fill'
};

GridUI.propTypes = {
  style: _propTypes2.default.object,
  itemWidth: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  gap: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  columnAutoSizing: _propTypes2.default.string,
  rowAutoSizing: _propTypes2.default.string
};

exports.default = GridUI;