'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SimpleLayout = function SimpleLayout(_ref) {
  var _ref$columnNumber = _ref.columnNumber,
      columnNumber = _ref$columnNumber === undefined ? 1 : _ref$columnNumber,
      _ref$children = _ref.children,
      children = _ref$children === undefined ? [] : _ref$children,
      desktopColumnNumber = _ref.desktopColumnNumber,
      tabletColumnNumber = _ref.tabletColumnNumber;

  var simplayLayoutContent = [];
  var mobileSize = parseInt(12 / columnNumber, 10);
  var tabletSize = parseInt(12 / tabletColumnNumber, 10);
  var desktopSize = parseInt(12 / desktopColumnNumber, 10);

  _react2.default.Children.forEach(children, function (child, index) {
    if (!_react2.default.isValidElement(child)) return;

    var classNameMobile = mobileSize ? 'uxi_s_col s' + mobileSize : '';
    var classNameTablet = tabletColumnNumber ? 'uxi_m_col m' + tabletSize : '';
    var classNameDesktop = desktopColumnNumber ? 'uxi_l_col l' + desktopSize : '';

    simplayLayoutContent.push(_react2.default.createElement(
      'div',
      {
        key: 'simpleLayout-row-' + index,
        className: classNameMobile + ' ' + classNameTablet + ' ' + classNameDesktop
      },
      child
    ));
  });

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'div',
      { className: 'uxi_s_row' },
      simplayLayoutContent
    )
  );
};

exports.default = SimpleLayout;