'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  flex-direction: ', ';\n'], ['\n  display: flex;\n  flex-direction: ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  padding: ', ';\n  margin-left: ', ';\n  margin-top: ', ';\n  &:first-child{\n    margin-left:0;\n    margin-top:0;\n  }\n  ', ';\n  &:hover svg {\n    /* opacity: 0.9; */\n    ', ';\n  }\n'], ['\n  padding: ', ';\n  margin-left: ', ';\n  margin-top: ', ';\n  &:first-child{\n    margin-left:0;\n    margin-top:0;\n  }\n  ', ';\n  &:hover svg {\n    /* opacity: 0.9; */\n    ', ';\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _getAppropriateIcon = require('../Icons/getAppropriateIcon');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SocialUL = _styledComponents2.default.ul(_templateObject, function (_ref) {
  var horizontal = _ref.horizontal;
  return horizontal ? 'row' : 'column';
});

var SocialLI = _styledComponents2.default.li(_templateObject2, function (_ref2) {
  var horizontal = _ref2.horizontal;
  return horizontal ? '2px' : 0;
}, function (_ref3) {
  var horizontal = _ref3.horizontal,
      spacing = _ref3.spacing;
  return horizontal && spacing ? spacing : 0;
}, function (_ref4) {
  var horizontal = _ref4.horizontal,
      spacing = _ref4.spacing;
  return !horizontal && spacing ? spacing : 0;
}, function (_ref5) {
  var iconColor = _ref5.iconColor;
  return iconColor ? 'svg { fill: ' + iconColor + '; }' : '';
}, function (_ref6) {
  var iconHoverColor = _ref6.iconHoverColor;
  return iconHoverColor ? 'fill: ' + iconHoverColor + ';' : '';
});

var SocialLinks = function SocialLinks(_ref7) {
  var socialLinks = _ref7.socialLinks,
      horizontal = _ref7.horizontal,
      spacing = _ref7.spacing,
      iconColor = _ref7.iconColor,
      iconHoverColor = _ref7.iconHoverColor,
      style = _ref7.style,
      iconSize = _ref7.iconSize;
  return _react2.default.createElement(
    SocialUL,
    { horizontal: horizontal, style: style },
    socialLinks.map(function (_ref8) {
      var name = _ref8.name,
          url = _ref8.url;
      return _react2.default.createElement(
        SocialLI,
        {
          horizontal: horizontal,
          iconColor: iconColor,
          iconHoverColor: iconHoverColor,
          spacing: spacing,
          key: name
        },
        _react2.default.createElement(
          'a',
          {
            target: '_blank',
            rel: 'noopener noreferrer',
            href: url,
            style: _extends({}, horizontal ? { display: 'flex' } : {})
          },
          (0, _getAppropriateIcon.getAppropriateIcon)(name)(_extends({}, iconSize ? { size: iconSize } : {}))
        )
      );
    })
  );
};

SocialLinks.propTypes = {
  socialLinks: _propTypes2.default.array,
  horizontal: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  spacing: _propTypes2.default.string,
  iconColor: _propTypes2.default.string
};

SocialLinks.defaultProps = {
  socialLinks: [],
  horizontal: false,
  style: {},
  spacing: '',
  iconColor: undefined
};

exports.default = SocialLinks;