'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  * {\n    box-sizing: border-box;\n  }\n'], ['\n  * {\n    box-sizing: border-box;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DropDownWithClickOutside = require('../../internal/DropDownWithClickOutside');

var _DropDownWithClickOutside2 = _interopRequireDefault(_DropDownWithClickOutside);

var _Button = require('../../Button');

var _Icons = require('../../Icons');

var _ButtonMenuItem = require('./ButtonMenuItem');

var _ButtonMenuItem2 = _interopRequireDefault(_ButtonMenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // eslint-disable-line
// eslint-disable-line
// eslint-disable-line


var ButtonMenuUI = _styledComponents2.default.div(_templateObject);

var focusTimeout = 128;

var ButtonMenu = function (_Component) {
  _inherits(ButtonMenu, _Component);

  function ButtonMenu(props) {
    _classCallCheck(this, ButtonMenu);

    var _this = _possibleConstructorReturn(this, (ButtonMenu.__proto__ || Object.getPrototypeOf(ButtonMenu)).call(this, props));

    _this.childrenWrapperRef = null;
    _this.triggerWrapperRef = null;

    _this.isControlled = _this.props.isOpen !== undefined;

    _this.state = {
      isOpen: _this.isControlled ? _this.props.isOpen : false
    };

    _this.toggleVisibility = _this.toggleVisibility.bind(_this);
    _this.close = _this.close.bind(_this);
    // this.focusButton = this.focusButton.bind(this);
    _this.focusMenu = _this.focusMenu.bind(_this);
    _this.storeChildrenWrapperRef = _this.storeChildrenWrapperRef.bind(_this);
    _this.storeTriggerWrapperRef = _this.storeTriggerWrapperRef.bind(_this);
    return _this;
  }

  /*
  focusButton() {
    return
    // return;
    let focusTarget = this.triggerWrapperRef;
     if (focusTarget) {
      if (
        this.triggerWrapperRef
        && this.triggerWrapperRef.querySelector
        && this.triggerWrapperRef.querySelector('button')
      ) {
        focusTarget = this.triggerWrapperRef.querySelector('button');
      } else if (
        this.triggerWrapperRef
        && this.triggerWrapperRef.firstChild
        && this.triggerWrapperRef.firstChild.focus
      ) {
        focusTarget = this.triggerWrapperRef.firstChild;
      }
       if (focusTarget.focus) {
        const timerRef = setTimeout(() => {
          if (focusTarget && focusTarget.focus) {
            focusTarget.focus();
          }
          clearTimeout(timerRef);
        }, focusTimeout);
      }
    }
  }
    */

  _createClass(ButtonMenu, [{
    key: 'focusMenu',
    value: function focusMenu() {
      var elem = this.childrenWrapperRef && this.childrenWrapperRef.firstChild && this.childrenWrapperRef.firstChild.firstChild;

      if (elem && elem.focus) {
        var timerRef = setTimeout(function () {
          if (elem && elem.focus) {
            elem.focus();
          }
          clearTimeout(timerRef);
        }, focusTimeout);
      }
    }
  }, {
    key: 'storeTriggerWrapperRef',
    value: function storeTriggerWrapperRef(node) {
      this.triggerWrapperRef = node;
    }
  }, {
    key: 'storeChildrenWrapperRef',
    value: function storeChildrenWrapperRef(node) {
      this.childrenWrapperRef = node;
    }
  }, {
    key: 'toggleVisibility',
    value: function toggleVisibility() {
      if (!this.isControlled) {
        var nextIsOpen = !this.state.isOpen;

        if (nextIsOpen) {
          this.setState({ isOpen: true }, this.focusMenu);
        } else {
          this.setState({ isOpen: false } /* this.focusButton */);
        }
      }
    }
  }, {
    key: 'close',
    value: function close() {
      if (!this.isControlled) {
        this.setState({ isOpen: false });
        // this.focusButton();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          button = _props.button,
          anchor = _props.anchor,
          menuWidth = _props.menuWidth,
          menuMinWidth = _props.menuMinWidth,
          menuMaxWidth = _props.menuMaxWidth,
          menuMaxHeight = _props.menuMaxHeight,
          visibleOverflow = _props.visibleOverflow;


      var isOpen = this.isControlled ? this.props.isOpen : this.state.isOpen;

      var extendedButton = _react2.default.cloneElement(button, {

        onClick: function onClick() {
          if (button.props.onClick) {
            var _button$props;

            (_button$props = button.props).onClick.apply(_button$props, arguments);
          }

          _this2.toggleVisibility();
        }
      });

      return _react2.default.createElement(
        ButtonMenuUI,
        {
          onKeyDown: function onKeyDown(e) {
            if (e.key === 'Escape') {
              _this2.close();
            } else if (e.key === 'ArrowDown') {
              e.preventDefault();
              // e.stopPropagation();
              var _document = document,
                  activeElement = _document.activeElement;


              if (activeElement.nextElementSibling && activeElement.nextElementSibling && activeElement.nextElementSibling.focus) {
                if (activeElement.nodeName !== activeElement.nextElementSibling.nodeName) {
                  // divider
                  if (activeElement.nextElementSibling.nextElementSibling && activeElement.nextElementSibling.nextElementSibling.focus) {
                    activeElement.nextElementSibling.nextElementSibling.focus();
                  }
                } else {
                  activeElement.nextElementSibling.focus();
                }
              } /*  else if (
                 activeElement.nextElementSibling
                 && activeElement.nextElementSibling
                 && activeElement.nextElementSibling.nextElementSibling
                 && activeElement.nextElementSibling.nextElementSibling.focus
                ) {
                 activeElement.nextElementSibling.nextElementSibling.focus();
                } */
            } else if (e.key === 'ArrowUp') {
              e.preventDefault();
              // e.stopPropagation();
              var _document2 = document,
                  _activeElement = _document2.activeElement;


              if (_activeElement.previousElementSibling && _activeElement.previousElementSibling.nodeName !== 'BUTTON' && _activeElement.previousElementSibling.focus) {
                // activeElement.previousElementSibling.focus();
                if (_activeElement.nodeName !== _activeElement.previousElementSibling.nodeName) {
                  // divider
                  if (_activeElement.previousElementSibling.previousElementSibling && _activeElement.previousElementSibling.previousElementSibling.focus) {
                    _activeElement.previousElementSibling.previousElementSibling.focus();
                  }
                } else {
                  _activeElement.previousElementSibling.focus();
                }
              }
            }
          }
        },
        _react2.default.createElement(
          _DropDownWithClickOutside2.default,
          {
            visibleOverflow: visibleOverflow
            // isFullWidth={isFullWidth}
            , anchor: anchor,
            onClickOutside: this.close,
            isOpen: isOpen,
            trigger: extendedButton,
            onTriggerWrapperRef: this.storeTriggerWrapperRef,
            onChildrenWrapperRef: this.storeChildrenWrapperRef
          },
          _react2.default.createElement(
            'ul',
            {
              style: _extends({
                // padding: 0,
                // margin: 0,
                // listStyle: 'none',
                background: 'white',
                maxHeight: menuMaxHeight,
                overflowY: visibleOverflow ? 'visible' : 'auto',
                overflowX: visibleOverflow ? 'visible' : 'hidden'
              }, menuWidth ? { width: menuWidth } : {}, menuMinWidth ? { minWidth: menuMinWidth } : {}, menuMaxWidth ? { maxWidth: menuMaxWidth } : {})
            },
            _react2.default.Children.map(children, function (child) {
              if (child && child.type && child.type === _ButtonMenuItem2.default) {
                return _react2.default.cloneElement(child, {
                  shouldClose: _this2.close
                });
              }
              return child;
            })
          )
        )
      );
    }
  }]);

  return ButtonMenu;
}(_react.Component);

ButtonMenu.defaultProps = {
  children: [],
  button: _react2.default.createElement(_Button.FlatButton, { icon: _react2.default.createElement(_Icons.Options, null) }),
  menuMaxHeight: '396px',
  menuWidth: undefined,
  menuMinWidth: undefined,
  menuMaxWidth: '300px'
};

ButtonMenu.propTypes = {
  button: _propTypes2.default.element,
  children: _propTypes2.default.arrayOf(_propTypes2.default.node),
  menuMaxHeight: _propTypes2.default.string,
  menuWidth: _propTypes2.default.string,
  menuMinWidth: _propTypes2.default.string,
  menuMaxWidth: _propTypes2.default.string
};

exports.default = ButtonMenu;