'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  position: ', ';\n  top: 0;\n  top: ', ';\n  bottom: 0;\n  bottom: ', ';\n  margin-left: 0px;\n  background: #fff;\n  border-right: 1px solid #ececec;\n  border-left: 1px solid #ececec;\n  transition: width 0.3s ease-in-out 0.3s, opacity 0.3s ease-in-out 0.3s;\n  z-index: 90;\n  overflow-x: hidden;\n  overflow-y: scroll;\n  width: ', '; /* in case 680 was passed */\n  width: ', '; /* in case auto was passed */\n  width: ', ';\n  will-change: transform;\n  transform: ', ';\n  transition: ', ';\n\n  @media (min-width: ', ') {\n    width: ', '; /* in case auto was passed */\n    width: ', ';\n    transform: ', ';\n    transition: ', ';\n  }\n\n  /* render inert when not visible */\n  /* ', '; */\n  ', ';\n'], ['\n  position: ', ';\n  top: 0;\n  top: ', ';\n  bottom: 0;\n  bottom: ', ';\n  margin-left: 0px;\n  background: #fff;\n  border-right: 1px solid #ececec;\n  border-left: 1px solid #ececec;\n  transition: width 0.3s ease-in-out 0.3s, opacity 0.3s ease-in-out 0.3s;\n  z-index: 90;\n  overflow-x: hidden;\n  overflow-y: scroll;\n  width: ', '; /* in case 680 was passed */\n  width: ', '; /* in case auto was passed */\n  width: ', ';\n  will-change: transform;\n  transform: ', ';\n  transition: ', ';\n\n  @media (min-width: ', ') {\n    width: ', '; /* in case auto was passed */\n    width: ', ';\n    transform: ', ';\n    transition: ', ';\n  }\n\n  /* render inert when not visible */\n  /* ', '; */\n  ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _GlobalMenuPanel = require('./GlobalMenuPanel.style');

var _GlobalMenuPanel2 = _interopRequireDefault(_GlobalMenuPanel);

var _Icons = require('../Icons');

var _defaults = require('./defaults');

var _defaults2 = _interopRequireDefault(_defaults);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// eslint-disable-line import/no-named-as-default

var breakpoint = _defaults2.default.breakpoint,
    bigMenuWidth = _defaults2.default.bigMenuWidth,
    menuWidth = _defaults2.default.menuWidth;

// eslint-disable-next-line no-unused-vars

var getWidth = function getWidth(_ref, breakpoint) {
  var isOpen = _ref.isOpen,
      panelWidth = _ref.panelWidth,
      fullWidth = _ref.fullWidth,
      attachToViewport = _ref.attachToViewport,
      fullViewportWidthPanel = _ref.fullViewportWidthPanel;
  // eslint-disable-line no-shadow
  var theMenuWidth = breakpoint === 'desktop' ? bigMenuWidth : menuWidth;
  var unit = fullViewportWidthPanel ? 'vw' : '%';

  if (fullWidth) {
    // if (fullViewportWidthPanel) {
    // return `calc(100vw - ${theMenuWidth})` // yep it's weird, layout context stuff...
    // }
    // return '100%';
    return 'calc(100' + unit + ' - ' + theMenuWidth + ')';
  }

  return panelWidth + 'px';
};

// eslint-disable-next-line no-shadow
var getTransform = function getTransform(_ref2, breakpoint) {
  var panelWidth = _ref2.panelWidth,
      fullWidth = _ref2.fullWidth,
      isOpen = _ref2.isOpen;

  var x = panelWidth;
  // const theMenuWidth = breakpoint === 'desktop' ? bigMenuWidth : menuWidth;

  if (isOpen) {
    if (breakpoint === 'desktop') {
      x = bigMenuWidth;
    } else {
      x = menuWidth;
    }
  } else if (fullWidth) {
    // x = `calc(-100vh - ${theMenuWidth})`;
    x = '-100vw';
  } else {
    // x = `calc(-${width}px)`;
    x = '-' + panelWidth + 'px';
  }

  return 'translate3d(' + x + ', 0, 0)';
};

var getAccessibilityRules = function getAccessibilityRules(_ref3) {
  var isOpen = _ref3.isOpen;

  if (isOpen) {
    return 'pointer-events: all; visibility: visible';
  }
  return 'pointer-events: none; visibility: collapse';
};

var GlobalMenuPanelWrapper = _styledComponents2.default.div(_templateObject, function (_ref4) {
  var attachToViewport = _ref4.attachToViewport;
  return attachToViewport ? 'fixed' : 'absolute';
}, function (_ref5) {
  var panelOffsetTop = _ref5.panelOffsetTop;
  return panelOffsetTop;
}, function (_ref6) {
  var panelOffsetBottom = _ref6.panelOffsetBottom;
  return panelOffsetBottom;
}, function (_ref7) {
  var panelWidth = _ref7.panelWidth;
  return panelWidth + 'px';
}, function (_ref8) {
  var panelWidth = _ref8.panelWidth;
  return panelWidth;
}, function (props) {
  return getWidth(props);
}, function (props) {
  return getTransform(props);
}, function (_ref9) {
  var transition = _ref9.theme.transition;
  return transition.defaultAll;
}, breakpoint, function (_ref10) {
  var panelWidth = _ref10.panelWidth;
  return panelWidth;
}, function (props) {
  return getWidth(props, 'desktop');
}, function (props) {
  return getTransform(props, 'desktop');
}, function (_ref11) {
  var transition = _ref11.theme.transition;
  return transition.defaultAll;
}, function (_ref12) {
  var isOpen = _ref12.isOpen;
  return isOpen ? '' : 'pointer-events: none; visibility: hidden';
}, function (props) {
  return getAccessibilityRules(props);
});

var GlobalMenuPanel = function (_Component) {
  _inherits(GlobalMenuPanel, _Component);

  function GlobalMenuPanel() {
    _classCallCheck(this, GlobalMenuPanel);

    return _possibleConstructorReturn(this, (GlobalMenuPanel.__proto__ || Object.getPrototypeOf(GlobalMenuPanel)).apply(this, arguments));
  }

  _createClass(GlobalMenuPanel, [{
    key: 'handleClickOutside',
    value: function handleClickOutside() {
      var _props = this.props,
          onClickOutside = _props.onClickOutside,
          isOpen = _props.isOpen;

      if (isOpen) {
        if (onClickOutside) {
          onClickOutside();
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          isOpen = _props2.isOpen,
          Title = _props2.Title,
          Content = _props2.Content,
          Action = _props2.Action,
          width = _props2.width,
          onClickOutside = _props2.onClickOutside,
          fullWidth = _props2.fullWidth,
          attachToViewport = _props2.attachToViewport,
          fullViewportWidthPanel = _props2.fullViewportWidthPanel,
          panelOffsetTop = _props2.panelOffsetTop,
          panelOffsetBottom = _props2.panelOffsetBottom;

      var actionContent = void 0;
      var closeContent = void 0;

      if (fullWidth) {
        closeContent = _react2.default.createElement(_Icons.Close, {
          style: { marginLeft: '15px', cursor: 'pointer' },
          onClick: onClickOutside
        });
      }

      if (Action) {
        actionContent = _react2.default.createElement(
          'div',
          { style: _GlobalMenuPanel2.default.action },
          _react2.default.createElement(Action, { close: onClickOutside }),
          closeContent
        );
      }

      if (!Action && fullWidth) {
        actionContent = _react2.default.createElement(
          'div',
          { style: _GlobalMenuPanel2.default.action },
          closeContent
        );
      }

      var isTitleString = Title && typeof Title === 'string';
      var title = Title;

      var attributes = _extends({}, !isOpen ? { tabIndex: -1, 'aria-hidden': 'true' } : { tabIndex: 0, autofocus: 'true' });

      return _react2.default.createElement(
        GlobalMenuPanelWrapper,
        _extends({
          className: 'rc-GlobalMenuPanelWrapper',
          panelOffsetTop: panelOffsetTop,
          panelOffsetBottom: panelOffsetBottom,
          isOpen: isOpen,
          panelWidth: width,
          fullWidth: fullWidth,
          attachToViewport: attachToViewport,
          fullViewportWidthPanel: fullViewportWidthPanel
        }, attributes),
        _react2.default.createElement(
          'div',
          { style: _GlobalMenuPanel2.default.titleContainer },
          actionContent,
          _react2.default.createElement(
            'div',
            { style: _GlobalMenuPanel2.default.title },
            Title && !isTitleString && _react2.default.createElement(Title, { close: onClickOutside }),
            Title && isTitleString && title
          )
        ),
        _react2.default.createElement(
          'div',
          { style: _GlobalMenuPanel2.default.panel },
          Content && _react2.default.createElement(Content, { close: onClickOutside })
        )
      );
    }
  }]);

  return GlobalMenuPanel;
}(_react.Component);

GlobalMenuPanel.propTypes = {
  onClickOutside: _propTypes2.default.func,
  isOpen: _propTypes2.default.bool,
  Title: _propTypes2.default.any,
  Content: _propTypes2.default.any,
  Action: _propTypes2.default.any,
  width: _propTypes2.default.number,
  fullWidth: _propTypes2.default.bool,
  attachToViewport: _propTypes2.default.bool,
  fullViewportWidthPanel: _propTypes2.default.bool,
  panelOffsetTop: _propTypes2.default.string,
  panelOffsetBottom: _propTypes2.default.string

};

GlobalMenuPanel.defaultProps = {
  width: 400,
  attachToViewport: false,
  onClickOutside: function onClickOutside() {},
  isOpen: false,
  Title: null,
  Content: null,
  Action: null,
  fullWidth: false,
  fullViewportWidthPanel: false,
  panelOffsetTop: '0px',
  panelOffsetBottom: '0px'
};

exports.default = (0, _reactClickOutside2.default)(GlobalMenuPanel);