'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  align-items: flex-end;\n  /* position: relative; */\n  margin-top: auto;\n  /* top: auto;\n  left: 0;\n  right: 0;\n  bottom: 0; */\n  z-index: 97;\n  /* height: 100%; */\n  background: ', ';\n'], ['\n  ', ';\n  align-items: flex-end;\n  /* position: relative; */\n  margin-top: auto;\n  /* top: auto;\n  left: 0;\n  right: 0;\n  bottom: 0; */\n  z-index: 97;\n  /* height: 100%; */\n  background: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _GlobalMenuContainer = require('./GlobalMenuContainer');

var _GlobalMenuContainer2 = _interopRequireDefault(_GlobalMenuContainer);

var _GlobalMenuItem = require('./GlobalMenuItem');

var _GlobalMenuItem2 = _interopRequireDefault(_GlobalMenuItem);

var _GlobalMenuSubItem = require('./GlobalMenuSubItem');

var _GlobalMenuSubItem2 = _interopRequireDefault(_GlobalMenuSubItem);

var _GlobalMenuPanel = require('./GlobalMenuPanel');

var _GlobalMenuPanel2 = _interopRequireDefault(_GlobalMenuPanel);

var _Layout = require('../Layout');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FlexExtended = _styledComponents2.default.div(_templateObject, _Layout.flexCSSString, function (_ref) {
  var palette = _ref.theme.palette;
  return palette.primary.dark || '#15303f';
});

var GlobalMenuWrapper = function GlobalMenuWrapper(_ref2) {
  var selectedKey = _ref2.selectedKey,
      logo = _ref2.logo,
      backgroundColor = _ref2.backgroundColor,
      primaryColor = _ref2.primaryColor,
      menuDescriptors = _ref2.menuDescriptors,
      attachToViewport = _ref2.attachToViewport,
      innerStyle = _ref2.innerStyle,
      fullViewportWidthPanel = _ref2.fullViewportWidthPanel,
      handlePanelClickOutside = _ref2.handlePanelClickOutside,
      breakpoint = _ref2.breakpoint,
      menuWidth = _ref2.menuWidth,
      bigMenuWidth = _ref2.bigMenuWidth,
      panelOffsetTop = _ref2.panelOffsetTop,
      panelOffsetBottom = _ref2.panelOffsetBottom,
      appStamp = _ref2.appStamp;

  var menuDescriptorsContent = [];

  (menuDescriptors || []).forEach(function (menuDescriptor) {
    menuDescriptorsContent.push(_react2.default.createElement(_GlobalMenuItem2.default, {
      breakpoint: breakpoint,
      key: menuDescriptor.key + '-rootitem',
      isSelected: menuDescriptor.isSelected,
      isActive: menuDescriptor.isActive,
      onClick: function onClick() {
        if (menuDescriptor.onClick && menuDescriptor.onClick) {
          menuDescriptor.onClick();
        }
      },
      hasNew: menuDescriptor.hasNew,
      label: menuDescriptor.displayName,
      index: menuDescriptor.key,
      dataKey: menuDescriptor.key,
      icon: menuDescriptor.icon,
      Link: menuDescriptor.Link,
      to: menuDescriptor.to,
      href: menuDescriptor.href,
      primaryColor: primaryColor,
      hasPanel: !!menuDescriptor.panel
    }));

    if (menuDescriptor.children && menuDescriptor.children.length > 0) {
      menuDescriptor.children.forEach(function (child, idx, list) {
        menuDescriptorsContent.push(_react2.default.createElement(_GlobalMenuSubItem2.default, {
          breakpoint: breakpoint,
          isFirstSubItem: idx === 0,
          isLastSubItem: idx === list.length - 1,
          key: menuDescriptor.key + '-subitem-' + child.key,
          isSelected: child.isSelected,
          isParentSelected: menuDescriptor.isActive || child.isActive,
          isActive: child.isActive,
          onClick: child.onClick,
          hasNew: child.hasNew,
          content: child.content,
          label: child.displayName,
          index: child.key,
          primaryColor: primaryColor,
          Link: child.Link,
          to: child.to,
          href: child.href
        }));
      });
    }

    if (menuDescriptor && menuDescriptor.panel) {
      menuDescriptorsContent.push(
      /* this wrapper div required for layout context */
      _react2.default.createElement(
        'div',
        {
          key: menuDescriptor.key + '-panel-' + menuDescriptor.panel.key
        },
        _react2.default.createElement(_GlobalMenuPanel2.default, {
          panelOffsetTop: panelOffsetTop,
          panelOffsetBottom: panelOffsetBottom,
          onClickOutside: function onClickOutside() {
            handlePanelClickOutside(menuDescriptor.key);
          },
          Title: menuDescriptor.panel.Title,
          Content: menuDescriptor.panel.Content,
          Action: menuDescriptor.panel.Action,
          width: menuDescriptor.panel.width,
          fullWidth: menuDescriptor.panel.fullWidth,
          isOpen: menuDescriptor.key === selectedKey,
          attachToViewport: attachToViewport,
          fullViewportWidthPanel: fullViewportWidthPanel
        })
      ));
    }
  });

  var gapFiller = _react2.default.createElement(
    FlexExtended,
    { key: 'single-gap-filler' },
    appStamp
  );

  return _react2.default.createElement(
    _GlobalMenuContainer2.default,
    {
      breakpoint: breakpoint,
      menuWidth: menuWidth,
      bigMenuWidth: bigMenuWidth,
      backgroundColor: backgroundColor,
      attachToViewport: attachToViewport,
      innerStyle: innerStyle,
      fullViewportWidthPanel: fullViewportWidthPanel
    },
    logo,
    menuDescriptorsContent,
    fullViewportWidthPanel && gapFiller
  );
};

GlobalMenuWrapper.propTypes = {
  selectedKey: _propTypes2.default.string,
  logo: _propTypes2.default.node,
  backgroundColor: _propTypes2.default.string,
  primaryColor: _propTypes2.default.string,
  menuDescriptors: _propTypes2.default.array
};

GlobalMenuWrapper.defaultProps = {
  selectedKey: '',
  activeKey: '',
  logo: null,
  backgroundColor: '',
  primaryColor: '',
  menuDescriptors: []
};

exports.default = GlobalMenuWrapper;