'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  --itemWidth: 190px;\n  --itemHeight: 34px;\n\n  * {\n    box-sizing: border-box;\n    transition: none !important; /* svg needs the authority */\n  }\n\n  width: ', ';\n  min-width: var(--itemWidth);\n  max-width: ', ';\n  box-shadow: ', ';\n  border-radius: ', ';\n\n  li > & { display: none; }\n\n  li > & {\n    position: absolute;\n    right: 0;\n    top: 0;\n    transform: translateX(100%);\n    &:before {\n      content: \'\';\n      display: block;\n      width: ', ';\n      height: 100%;\n      position: absolute;\n      left: calc(var(--itemWidth) * -1);\n      transform: translateY(var(--itemHeight));\n    }\n  }\n\n  li:hover > &,\n  li:focus-within > & {\n    display: block;\n    width: var(--itemWidth);\n    & {\n      z-index: 1;\n      &:before { z-index: 0; }\n      &:hover { z-index: 99; }\n      &:hover * { z-index: 99; }\n      &:hover > * { z-index: 100; }\n    }\n  }\n\n'], ['\n  --itemWidth: 190px;\n  --itemHeight: 34px;\n\n  * {\n    box-sizing: border-box;\n    transition: none !important; /* svg needs the authority */\n  }\n\n  width: ', ';\n  min-width: var(--itemWidth);\n  max-width: ', ';\n  box-shadow: ', ';\n  border-radius: ', ';\n\n  li > & { display: none; }\n\n  li > & {\n    position: absolute;\n    right: 0;\n    top: 0;\n    transform: translateX(100%);\n    &:before {\n      content: \'\';\n      display: block;\n      width: ', ';\n      height: 100%;\n      position: absolute;\n      left: calc(var(--itemWidth) * -1);\n      transform: translateY(var(--itemHeight));\n    }\n  }\n\n  li:hover > &,\n  li:focus-within > & {\n    display: block;\n    width: var(--itemWidth);\n    & {\n      z-index: 1;\n      &:before { z-index: 0; }\n      &:hover { z-index: 99; }\n      &:hover * { z-index: 99; }\n      &:hover > * { z-index: 100; }\n    }\n  }\n\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _MlMenuItem = require('./MlMenuItem');

var _MlMenuItem2 = _interopRequireDefault(_MlMenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var MlMenuListUI = _styledComponents2.default.ul(_templateObject, function (_ref) {
  var isFullWidth = _ref.isFullWidth;
  return isFullWidth ? '100%' : 'var(--itemWidth)';
}, function (_ref2) {
  var isFullWidth = _ref2.isFullWidth;
  return isFullWidth ? '100%' : 'var(--itemWidth)';
}, function (_ref3) {
  var theme = _ref3.theme;
  return '' + theme.outlineShadow2;
}, function (_ref4) {
  var radius = _ref4.theme.radius;
  return radius;
}, function (_ref5) {
  var isFullWidth = _ref5.isFullWidth;
  return isFullWidth ? '100%' : 'var(--itemWidth)';
});

var MlMenuList = function MlMenuList(props) {
  var menuDescriptor = props.menuDescriptor,
      isFullWidth = props.isFullWidth,
      onSelfClose = props.onSelfClose;


  return _react2.default.createElement(
    MlMenuListUI,
    { isFullWidth: isFullWidth },
    (menuDescriptor || []).map(function (itemDescriptor, i) {
      var _itemDescriptor$onCli = itemDescriptor.onClick,
          consumerOnClick = _itemDescriptor$onCli === undefined ? function () {} : _itemDescriptor$onCli;

      var onClickHandler = function onClickHandler() {
        if (itemDescriptor.children === undefined) {
          onSelfClose();
        }
        return consumerOnClick.apply(undefined, arguments);
      };

      return _react2.default.createElement(_MlMenuItem2.default, _extends({
        key: i,
        isFullWidth: isFullWidth
      }, itemDescriptor, {
        onClick: onClickHandler,
        onSelfClose: onSelfClose
      }));
    })
  );
};

exports.default = MlMenuList;