'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  & {\n    .uxi-menu-item {\n      border-right: 5px solid transparent;\n    }\n    .uxi-menu-item:hover {\n      background:  ', ' ;\n      border-right: ', ' solid transparent;\n    }\n    .uxi-menu-item a {\n      color:  ', ' ;\n      text-decoration: none;\n      display: block;\n    }\n    .uxi-menu-item a:hover {\n      color:  ', ' ;\n    }\n    .uxi-menu-item.uxi-active {\n      background:  ', ' ;\n      border-right:  ', ' ;\n      color:  ', ' ;\n    }\n    .uxi-menu-item.uxi-active:hover {\n      background:  ', ' ;\n      color:  ', ' ;\n    }\n    .uxi-menu-item.uxi-active a {\n      color:  ', ' ;\n    }\n  }\n'], ['\n  & {\n    .uxi-menu-item {\n      border-right: 5px solid transparent;\n    }\n    .uxi-menu-item:hover {\n      background:  ', ' ;\n      border-right: ', ' solid transparent;\n    }\n    .uxi-menu-item a {\n      color:  ', ' ;\n      text-decoration: none;\n      display: block;\n    }\n    .uxi-menu-item a:hover {\n      color:  ', ' ;\n    }\n    .uxi-menu-item.uxi-active {\n      background:  ', ' ;\n      border-right:  ', ' ;\n      color:  ', ' ;\n    }\n    .uxi-menu-item.uxi-active:hover {\n      background:  ', ' ;\n      color:  ', ' ;\n    }\n    .uxi-menu-item.uxi-active a {\n      color:  ', ' ;\n    }\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _ThemeComponent2 = require('../Base/ThemeComponent');

var _ThemeComponent3 = _interopRequireDefault(_ThemeComponent2);

var _colorManipulator = require('../Theme/colorManipulator');

var _defaults = require('./defaults');

var _defaults2 = _interopRequireDefault(_defaults);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// eslint-disable-line import/no-named-as-default

var borderThickness = _defaults2.default.borderThickness;


var VerticalMenuUI = _styledComponents2.default.ul(_templateObject, function (_ref) {
  var palette = _ref.theme.palette;
  return (0, _colorManipulator.lighten)(palette.accent.main, 0.9);
}, borderThickness, function (_ref2) {
  var palette = _ref2.theme.palette;
  return palette.neutral.dark;
}, function (_ref3) {
  var palette = _ref3.theme.palette;
  return palette.accent.light;
}, function (_ref4) {
  var palette = _ref4.theme.palette;
  return (0, _colorManipulator.lighten)(palette.accent.main, 0.9);
}, function (_ref5) {
  var palette = _ref5.theme.palette;
  return borderThickness + ' solid ' + palette.accent.main;
}, function (_ref6) {
  var palette = _ref6.theme.palette;
  return palette.accent.dark;
}, function (_ref7) {
  var palette = _ref7.theme.palette;
  return (0, _colorManipulator.lighten)(palette.accent.main, 0.7);
}, function (_ref8) {
  var palette = _ref8.theme.palette;
  return palette.neutral.darker;
}, function (_ref9) {
  var palette = _ref9.theme.palette;
  return palette.accent.dark;
});

var VerticalMenu = function (_ThemeComponent) {
  _inherits(VerticalMenu, _ThemeComponent);

  function VerticalMenu() {
    _classCallCheck(this, VerticalMenu);

    return _possibleConstructorReturn(this, (VerticalMenu.__proto__ || Object.getPrototypeOf(VerticalMenu)).apply(this, arguments));
  }

  _createClass(VerticalMenu, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          style = _props.style;

      var verticalMergedStyle = this.getStyle('VerticalMenu', {});

      var menuItems = _react2.default.Children.map(children, function (child, menuNumber) {
        if (_react2.default.isValidElement(child)) {
          return _react2.default.cloneElement(child, {
            fromParentStyle: {
              display: 'block',
              height: '40px',
              lineHeight: '40px',
              padding: '0 15px',
              cursor: 'pointer'
            },
            key: 'menuItem-' + menuNumber
          });
        }
        return child;
      });

      return _react2.default.createElement(
        VerticalMenuUI,
        _extends({}, this.props, {
          style: _extends({}, verticalMergedStyle, style)
        }),
        menuItems
      );
    }
  }]);

  return VerticalMenu;
}(_ThemeComponent3.default);

exports.default = VerticalMenu;