'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  background: none;\n  rect {\n    fill: ', '\n  };\n'], ['\n  background: none;\n  rect {\n    fill: ', '\n  };\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Svg = _styledComponents2.default.svg(_templateObject, function (_ref) {
  var palette = _ref.theme.palette,
      type = _ref.type,
      colorProp = _ref.colorProp;

  if (type) {
    return palette.semantic[type] || palette.accent;
  }
  if (colorProp) {
    return colorProp;
  }
  return palette.accent.main;
});

var MiniLoader = function MiniLoader(_ref2) {
  var size = _ref2.size,
      colorProp = _ref2.color,
      type = _ref2.type;
  return _react2.default.createElement(
    Svg,
    {
      colorProp: colorProp,
      type: type,
      className: 'lds-spinner-zefv',
      width: size ? size + 'px' : '34px',
      height: size ? size + 'px' : '34px',
      viewBox: '0 0 100 100',
      preserveAspectRatio: 'xMidYMid'
    },
    _react2.default.createElement(
      'g',
      { transform: 'rotate(0 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.875s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(45 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.75s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(90 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.625s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(135 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.5s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(180 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.375s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(225 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.25s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(270 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '-0.125s', repeatCount: 'indefinite' })
      )
    ),
    _react2.default.createElement(
      'g',
      { transform: 'rotate(315 50 50)' },
      _react2.default.createElement(
        'rect',
        { x: '48', y: '20', rx: '4.8', ry: '2', width: '4', height: '20' },
        _react2.default.createElement('animate', { attributeName: 'opacity', values: '1;0', times: '0;1', dur: '1s', begin: '0s', repeatCount: 'indefinite' })
      )
    )
  );
};

MiniLoader.defaultProps = {
  color: '#25bcbc',
  type: 'success'
};

MiniLoader.propTypes = {
  color: _propTypes2.default.string,
  type: _propTypes2.default.oneOf(['default', 'success', 'error', 'warning', 'information'])
};

exports.default = MiniLoader;