'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _debounce = require('lodash/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _SlideInWhenInBoundUI = require('./SlideInWhenInBoundUI');

var _SlideInWhenInBoundUI2 = _interopRequireDefault(_SlideInWhenInBoundUI);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SlideInWhenInBound = function (_Component) {
  _inherits(SlideInWhenInBound, _Component);

  function SlideInWhenInBound(props) {
    _classCallCheck(this, SlideInWhenInBound);

    var _this = _possibleConstructorReturn(this, (SlideInWhenInBound.__proto__ || Object.getPrototypeOf(SlideInWhenInBound)).call(this, props));

    _this.node = null;
    _this.storeRef = _this.storeRef.bind(_this);
    _this.handleScrollDebounced = (0, _debounce2.default)(_this.handleScroll, 8);
    _this.handleResizeDebounced = (0, _debounce2.default)(_this.handleResize, 80);
    _this.attachListeners = _this.attachListeners.bind(_this);
    _this.removeListeners = _this.removeListeners.bind(_this);

    _this.state = {
      viewportHeight: null,
      className: 'scroll-anim-before load-anim animIn'
    };
    return _this;
  }

  _createClass(SlideInWhenInBound, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.attachListeners();
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (this.state.className !== nextState.className) {
        return true;
      }
      return false;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeListeners();
    }
  }, {
    key: 'readDOMPosition',
    value: function readDOMPosition(viewportHeightParam) {
      var node = this.node;

      if (!node) {
        return null;
      }
      var viewportHeight = this.state.viewportHeight || viewportHeightParam || 2000;

      var _node$getBoundingClie = this.node.getBoundingClientRect(),
          top = _node$getBoundingClie.top,
          height = _node$getBoundingClie.height;

      var isInBound = viewportHeight - top >= height / 10;
      // const isOutBound = top >= viewportHeight * 1.5;
      var className = 'scroll-anim-before load-anim ' + (isInBound ? ' animIn ' : '');

      this.setState({ className: className });

      return null;
    }
  }, {
    key: 'storeRef',
    value: function storeRef(node) {
      this.node = node;
      this.setState({ viewportHeight: window.innerHeight });
      this.readDOMPosition(window.innerHeight);
    }
  }, {
    key: 'handleScroll',
    value: function handleScroll() {
      this.readDOMPosition();
    }
  }, {
    key: 'handleResize',
    value: function handleResize(e) {
      this.setState({
        viewportHeight: e.target.innerHeight
      });
    }
  }, {
    key: 'attachListeners',
    value: function attachListeners() {
      if (window && window.document) {
        var scrollElementSelector = this.props.scrollElementSelector;

        var theElementToWatchScrollOn = document.querySelector(scrollElementSelector) || window.document;
        window.addEventListener('resize', this.handleResizeDebounced.bind(this));
        theElementToWatchScrollOn.addEventListener('scroll', this.handleScrollDebounced.bind(this));
      }
    }
  }, {
    key: 'removeListeners',
    value: function removeListeners() {
      if (window && window.document) {
        var scrollElementSelector = this.props.scrollElementSelector;

        var theElementToWatchScrollOn = document.querySelector(scrollElementSelector) || window.document;
        window.removeEventListener('resize', this.handleResizeDebounced.bind(this));
        theElementToWatchScrollOn.removeEventListener('scroll', this.handleScrollDebounced.bind(this));
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var className = this.state.className;
      var anchor = this.props.anchor;


      return _react2.default.createElement(
        _SlideInWhenInBoundUI2.default,
        { anchor: anchor },
        _react2.default.createElement(
          'div',
          {
            className: '' + className,
            ref: this.storeRef
          },
          _react2.default.Children.only(this.props.children)
        )
      );
    }
  }]);

  return SlideInWhenInBound;
}(_react.Component);

SlideInWhenInBound.defaultProps = {
  anchor: 'bottom'
};
SlideInWhenInBound.propTypes = {
  anchor: _propTypes2.default.oneOf(['bottom', 'top', 'left', 'right'])
};
exports.default = SlideInWhenInBound;