'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Layout = require('../Layout');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Panel = function Panel(_ref) {
  var children = _ref.children,
      style = _ref.style,
      onClose = _ref.onClose,
      rounded = _ref.rounded;
  return _react2.default.createElement(
    _Layout.AppLayout,
    { style: style },

    /* Pass Panel's onClose to its children */
    _react2.default.Children.map(children, function (child) {
      return child && _react2.default.cloneElement(child, _extends({
        onClose: onClose
      }, child.type && child.type.displayName && child.type.displayName.indexOf('Panel') === 0 ? { rounded: rounded } : {}, child.props || {}) // allow consumer final overwrite privilege for onClose
      );
    })
  );
};

Panel.displayName = 'Panel';

Panel.defaultProps = {
  rounded: false
};

exports.default = Panel;