'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  box-sizing: border-box;\n  background-color: ', ';\n  transition: ', ';\n  border-top: 1px solid ', ';\n  padding: 8px 16px;\n  display: flex;\n  justify-content: flex-end;\n  min-height: 50px;\n  min-height: ', ';\n  border-radius: ', ';\n'], ['\n  box-sizing: border-box;\n  background-color: ', ';\n  transition: ', ';\n  border-top: 1px solid ', ';\n  padding: 8px 16px;\n  display: flex;\n  justify-content: flex-end;\n  min-height: 50px;\n  min-height: ', ';\n  border-radius: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _defaults = require('./defaults');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var PanelFooterUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var palette = _ref.theme.palette;
  return palette.white;
}, function (_ref2) {
  var transition = _ref2.theme.transition;
  return transition.defaultAll;
}, function (_ref3) {
  var palette = _ref3.theme.palette;
  return palette.lightGrey;
}, _defaults.footerHeight, function (_ref4) {
  var round = _ref4.round,
      radius = _ref4.theme.radius;
  return round && '0 0 ' + radius + ' ' + radius;
});

var PanelFooter = function PanelFooter(props) {
  var children = props.children,
      hasCancel = props.hasCancel,
      cancelLabel = props.cancelLabel,
      onClose = props.onClose,
      style = props.style,
      rounded = props.rounded;


  var cancel = hasCancel || onClose ? _react2.default.createElement(
    _Button2.default,
    { onClick: onClose, style: { marginLeft: '16px' } },
    cancelLabel
  ) : null;

  return _react2.default.createElement(
    PanelFooterUI,
    { style: style, round: rounded || undefined },
    children,
    cancel
  );
};

PanelFooter.displayName = 'PanelFooter';

PanelFooter.defaultProps = {
  cancelLabel: 'Cancel'
};

exports.default = PanelFooter;