'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  flex-flow: row wrap;\n  align-items: center;\n  width: 100%;\n'], ['\n  ', ';\n  flex-flow: row wrap;\n  align-items: center;\n  width: 100%;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  box-sizing: border-box;\n  background-color: ', ';\n  transition: ', ';\n  * { transition: ', '; }\n  padding: 8px 16px;\n  color: ', ';\n  display: flex;\n  align-items: center;\n  min-height: 50px;\n  min-height: ', ';\n  border-radius: ', ';\n'], ['\n  box-sizing: border-box;\n  background-color: ', ';\n  transition: ', ';\n  * { transition: ', '; }\n  padding: 8px 16px;\n  color: ', ';\n  display: flex;\n  align-items: center;\n  min-height: 50px;\n  min-height: ', ';\n  border-radius: ', ';\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  font-weight: bold;\n'], ['\n  font-weight: bold;\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  margin-left: auto;\n  cursor: pointer;\n  display: flex;\n  align-items: center;\n  & * {\n    fill: currentColor;\n  }\n  opacity: .7;\n  &:hover {\n    opacity: 1;\n    transform: scale(1.15);\n    transform-origin: center;\n  }\n'], ['\n  margin-left: auto;\n  cursor: pointer;\n  display: flex;\n  align-items: center;\n  & * {\n    fill: currentColor;\n  }\n  opacity: .7;\n  &:hover {\n    opacity: 1;\n    transform: scale(1.15);\n    transform-origin: center;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Icons = require('../Icons');

var _Layout = require('../Layout');

var _defaults = require('./defaults');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var HorizontalAppLayout = _styledComponents2.default.div(_templateObject, _Layout.appLayoutCSSString);

var PanelHeaderUI = _styledComponents2.default.div(_templateObject2, function (_ref) {
  var palette = _ref.theme.palette;
  return palette.accent.main;
}, function (_ref2) {
  var transition = _ref2.theme.transition;
  return transition.defaultAll;
}, function (_ref3) {
  var transition = _ref3.theme.transition;
  return transition.defaultAll;
}, function (_ref4) {
  var palette = _ref4.theme.palette;
  return palette.pureWhite;
}, _defaults.headerHeight, function (_ref5) {
  var round = _ref5.round,
      radius = _ref5.theme.radius;
  return round && radius + ' ' + radius + ' 0 0';
});

var PanelHeaderTitleWrapper = _styledComponents2.default.div(_templateObject3);

var CloseWrapperUI = _styledComponents2.default.div(_templateObject4);

var PanelHeader = function PanelHeader(props) {
  var children = props.children,
      title = props.title,
      hasClose = props.hasClose,
      onClose = props.onClose,
      style = props.style,
      rounded = props.rounded;


  var close = hasClose || onClose ? _react2.default.createElement(
    CloseWrapperUI,
    { tabindex: '0', onClick: onClose },
    _react2.default.createElement(_Icons.Close, { size: '14px' })
  ) : null;

  return _react2.default.createElement(
    PanelHeaderUI,
    { style: style, round: rounded || undefined },
    _react2.default.createElement(
      HorizontalAppLayout,
      null,
      _react2.default.createElement(
        PanelHeaderTitleWrapper,
        null,
        title
      ),
      _react2.default.createElement(
        'div',
        null,
        children
      ),
      _react2.default.createElement(
        'div',
        null,
        close
      )
    )
  );
};

PanelHeader.displayName = 'PanelHeader';

PanelHeader.defaultProps = {
  title: null
};

exports.default = PanelHeader;