'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  min-width: 280px;\n  width: 500px;\n  max-width: 100vw;\n  background: #fff;\n  box-shadow: 0px 3px 10px rgba(0, 0, 0, 0) , 0px 3px 10px rgba(0, 0, 0, 0);\n  };\n  ', ';\n  /* height | width */\n  ', ';\n  /* top&bottom | right&left */\n  ', ';\n  &>*:last-child { ', ' }\n'], ['\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  min-width: 280px;\n  width: 500px;\n  max-width: 100vw;\n  background: #fff;\n  box-shadow: 0px 3px 10px rgba(0, 0, 0, 0) , 0px 3px 10px rgba(0, 0, 0, 0);\n  };\n  ', ';\n  /* height | width */\n  ', ';\n  /* top&bottom | right&left */\n  ', ';\n  &>*:last-child { ', ' }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Modal = require('../internal/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _Slide = require('../internal/Slide');

var _Slide2 = _interopRequireDefault(_Slide);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); } // @inheritedComponent Modal

function getSlideDirection(anchor) {
  if (anchor === 'left') {
    return 'right';
  } else if (anchor === 'right') {
    return 'left';
  } else if (anchor === 'top') {
    return 'bottom';
  }
  return 'top';
}
var slidesHorizontaly = function slidesHorizontaly(direction) {
  return direction === 'right' || direction === 'left';
};

var SidePanelUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var isIn = _ref.inAttr;
  return isIn ? 'box-shadow: 0px 3px 10px rgba(0, 0, 0, 0.16) , 0px 3px 10px rgba(0, 0, 0, 0.23)' : '';
}, function (_ref2) {
  var dir = _ref2.dir;
  return slidesHorizontaly(dir) ? 'height: 100vh' : 'width: 100vw';
}, function (_ref3) {
  var dir = _ref3.dir;
  return slidesHorizontaly(dir) ? 'top: 0; bottom: 0' : 'left: 0; right: 0';
}, function (_ref4) {
  var dir = _ref4.dir,
      children = _ref4.children;
  return _react2.default.Children.count(children) >= 3 && slidesHorizontaly(dir) ? 'margin-top: auto' : '';
});

var SidePanel = function (_React$Component) {
  _inherits(SidePanel, _React$Component);

  function SidePanel(props) {
    _classCallCheck(this, SidePanel);

    var _this = _possibleConstructorReturn(this, (SidePanel.__proto__ || Object.getPrototypeOf(SidePanel)).call(this, props));

    _this.handleEsc = _this.handleEsc.bind(_this);
    _this.state = {
      // Let's assume that the Drawer will always be rendered on user space.
      // We use that state is order to skip the appear transition during the
      // initial mount of the component.
      firstMount: true
    };
    return _this;
  }

  _createClass(SidePanel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (window) {
        window.addEventListener('keyup', this.handleEsc);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps() {
      this.setState({
        firstMount: false
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (window) {
        window.removeEventListener('keyup', this.handleEsc);
      }
    }
  }, {
    key: 'handleEsc',
    value: function handleEsc(e) {
      var key = e.key;
      var _props = this.props,
          onClose = _props.onClose,
          open = _props.open;

      if (open && onClose && key === 'Escape') {
        onClose();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          anchor = _props2.anchor,
          children = _props2.children,
          _onClose = _props2.onClose,
          open = _props2.open,
          showOverlay = _props2.showOverlay,
          style = _props2.style,
          modal = _props2.modal,
          offsetBottom = _props2.offsetBottom,
          offsetTop = _props2.offsetTop,
          offsetLeft = _props2.offsetLeft,
          offsetRight = _props2.offsetRight;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _Slide2.default,
          {
            inAttr: open,
            direction: getSlideDirection(anchor),
            appear: !this.state.firstMount,
            offsetTop: offsetTop,
            offsetBottom: offsetBottom,
            offsetLeft: offsetLeft,
            offsetRight: offsetRight
          },
          _react2.default.createElement(
            SidePanelUI,
            {
              inAttr: open,
              dir: getSlideDirection(anchor),
              style: style
            },
            _react2.default.Children.map(children, function (c, index) {
              return _react2.default.isValidElement(c) && _react2.default.cloneElement(c, {
                key: 'sidePanel-' + index,
                onClose: function onClose() {
                  if (c.props && c.props.onClose) {
                    var _c$props;

                    (_c$props = c.props).onClose.apply(_c$props, arguments);
                    _onClose.apply(undefined, arguments);
                  }
                },
                anchor: anchor
              });
            })
          )
        ),
        showOverlay ? _react2.default.createElement(_Modal2.default, {
          show: open,
          onClose: modal ? null : _onClose
        }) : null
      );
    }
  }]);

  return SidePanel;
}(_react2.default.Component);

SidePanel.propTypes = {
  anchor: _propTypes2.default.oneOf(['left', 'top', 'right', 'bottom']),
  children: _propTypes2.default.node,
  onClose: _propTypes2.default.func,
  open: _propTypes2.default.bool,
  showOverlay: _propTypes2.default.bool,
  // transitionDuration: PropTypes.oneOfType([
  //   PropTypes.number,
  //   PropTypes.shape({ enter: PropTypes.number, exit: PropTypes.number }),
  // ]), // not used
  offsetTop: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  offsetBottom: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  offsetRight: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  offsetLeft: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])
};

SidePanel.defaultProps = {
  anchor: 'right',
  open: false,
  showOverlay: false,
  children: null,
  onClose: function onClose() {},
  // transitionDuration: 0,
  offsetTop: 0,
  offsetBottom: 0,
  offsetRight: 0,
  offsetLeft: 0
};

exports.default = SidePanel;