'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  padding: ', ';\n  margin: ', ';\n'], ['\n  padding: ', ';\n  margin: ', ';\n']);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/*
  xs = 4px 4px 4px 4px;
  s = 8px 8px 8px 8px;
  m = 16px 16px 16px 16px;
  l = 32px 32px 32px 32px;
  xl = 64px 64px 64px 64px;
  stack-xs = 0 0 4px 0;
  stack-s = 0 0 8px 0;
  stack-m = 0 0 16px 0;
  stack-l = 0 0 32px 0;
  stack-xl = 0 0 64px 0;
*/
var sizes = {
  xs: '4px',
  s: '8px',
  m: '16px',
  l: '32px',
  xl: '64px'
};

var getValue = function getValue(value) {
  if (!value) {
    return '0';
  }

  if (value.toLowerCase() === 'xs' || value.toLowerCase() === 's' || value.toLowerCase() === 'm' || value.toLowerCase() === 'l' || value.toLowerCase() === 'xl') {
    return sizes[value.toLowerCase()];
  }

  if (value.indexOf('stack-') > -1) {
    var sizeString = value.replace('stack-', '').toLowerCase();
    var sizeValue = sizes[sizeString] || '0';
    return '0 0 ' + sizeValue + ' 0';
  }

  return '0';
};

var Spacer = _styledComponents2.default.div(_templateObject, function (_ref) {
  var padding = _ref.padding;
  return getValue(padding);
}, function (_ref2) {
  var margin = _ref2.margin;
  return getValue(margin);
});

exports.default = Spacer;