'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  box-sizing: border-box;\n  color: #ffffff ;\n  color: ', ';\n  overflow: hidden;\n  font-size: 13px;\n  border-radius: 7px;\n  border-radius: 50%;\n  display: flex;\n  justify-content: flex-start;\n  justify-content: center;\n  align-items: center;\n  white-space: nowrap;\n  min-width: 20px;\n  width: 20px;\n  min-height: 20px;\n  max-height: 20px;\n  margin-right: 4px;\n  padding: 0;\n  background-color: ', ';\n'], ['\n  box-sizing: border-box;\n  color: #ffffff ;\n  color: ', ';\n  overflow: hidden;\n  font-size: 13px;\n  border-radius: 7px;\n  border-radius: 50%;\n  display: flex;\n  justify-content: flex-start;\n  justify-content: center;\n  align-items: center;\n  white-space: nowrap;\n  min-width: 20px;\n  width: 20px;\n  min-height: 20px;\n  max-height: 20px;\n  margin-right: 4px;\n  padding: 0;\n  background-color: ', ';\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  user-select: none;\n  display: flex;\n  flex-grow: 3;\n  justify-content: center;\n  align-items: center;\n  padding: 16px 12px;\n  background: white;\n  background: ', ';\n  ', ';\n  &:hover {\n    background: ', ';\n  };\n  cursor: ', ';\n  /* this next line is a tad too agressive: */\n  /* pointer-events: ', '; */\n  border-radius: 3px;\n'], ['\n  user-select: none;\n  display: flex;\n  flex-grow: 3;\n  justify-content: center;\n  align-items: center;\n  padding: 16px 12px;\n  background: white;\n  background: ', ';\n  ', ';\n  &:hover {\n    background: ', ';\n  };\n  cursor: ', ';\n  /* this next line is a tad too agressive: */\n  /* pointer-events: ', '; */\n  border-radius: 3px;\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  opacity: ', ';\n  margin-left: 4px;\n  display: flex;\n  flex-flow: ', ';\n  justify-content: ', ';\n  text-align: ', ';\n'], ['\n  opacity: ', ';\n  margin-left: 4px;\n  display: flex;\n  flex-flow: ', ';\n  justify-content: ', ';\n  text-align: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Icons = require('../Icons');

var _Theme = require('../Theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Badge = _styledComponents2.default.div(_templateObject, function (_ref) {
  var theme = _ref.theme;
  return theme.palette.pureWhite;
}, function (_ref2) {
  var theme = _ref2.theme,
      type = _ref2.type;
  return type === 'success' ? theme.palette.accent.main : theme.palette.lightGrey;
});

var StepWrapperUI = _styledComponents2.default.div(_templateObject2, function (_ref3) {
  var active = _ref3.active;
  return active ? 'white' : 'inherit';
}, function (_ref4) {
  var disabled = _ref4.disabled;
  return disabled ? 'background: white' : '';
}, function (_ref5) {
  var disabled = _ref5.disabled;
  return disabled ? 'inherit' : '#efefef';
}, function (_ref6) {
  var disabled = _ref6.disabled;
  return disabled ? 'not-allowed' : 'pointer';
}, function (_ref7) {
  var disabled = _ref7.disabled;
  return disabled ? 'none' : 'inherit';
});

var ChildrenWrapper = _styledComponents2.default.div(_templateObject3, function (_ref8) {
  var disabled = _ref8.disabled;
  return disabled ? 0.4 : 1;
}, function (_ref9) {
  var nowrap = _ref9.nowrap;
  return nowrap ? 'inherit' : 'row wrap';
}, function (_ref10) {
  var nowrap = _ref10.nowrap;
  return !nowrap ? 'center' : 'inherit';
}, function (_ref11) {
  var nowrap = _ref11.nowrap;
  return !nowrap ? 'center' : '';
});

var Step = function Step(_ref12) {
  var active = _ref12.active,
      disabled = _ref12.disabled,
      completed = _ref12.completed,
      stricltyLinear = _ref12.stricltyLinear,
      children = _ref12.children,
      step = _ref12.step,
      nowrap = _ref12.nowrap,
      style = _ref12.style;

  var progressBadge = null;
  if (active) {
    progressBadge = _react2.default.createElement(
      Badge,
      { type: 'success', style: { marginRight: '4px' } },
      step
    );
  } else if (stricltyLinear && completed) {
    progressBadge = _react2.default.createElement(_Icons.Done, { size: '20', color: _Theme.palette.semantic.success, style: { opacity: 0.4, marginRight: '4px' } });
  } else if (completed) {
    progressBadge = _react2.default.createElement(_Icons.Done, { size: '20', color: _Theme.palette.semantic.success, style: { marginRight: '4px' } });
  } else {
    progressBadge = _react2.default.createElement(
      Badge,
      { style: { marginRight: '4px' } },
      step
    );
  }

  return _react2.default.createElement(
    StepWrapperUI,
    { active: active, disabled: disabled, completed: completed, style: style },
    _react2.default.createElement(
      ChildrenWrapper,
      { disabled: disabled, nowrap: nowrap },
      progressBadge,
      children
    )
  );
};

Step.displayName = 'Step';

exports.default = Step;