'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  width: 100%;\n  display: flex;\n  justify-content: space-around;\n  align-items: center;\n  flex-wrap: ', ';\n'], ['\n  width: 100%;\n  display: flex;\n  justify-content: space-around;\n  align-items: center;\n  flex-wrap: ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _StepConnector = require('./StepConnector');

var _StepConnector2 = _interopRequireDefault(_StepConnector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var StepperWrapperUI = _styledComponents2.default.div(_templateObject, function (_ref) {
  var nowrap = _ref.nowrap;
  return nowrap ? 'nowrap' : 'wrap';
});

/* eslint-disable */

var Stepper = function (_Component) {
  _inherits(Stepper, _Component);

  function Stepper() {
    _classCallCheck(this, Stepper);

    return _possibleConstructorReturn(this, (Stepper.__proto__ || Object.getPrototypeOf(Stepper)).apply(this, arguments));
  }

  _createClass(Stepper, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          activeStep = _props.activeStep,
          children = _props.children,
          linear = _props.linear,
          strictlyLinear = _props.strictlyLinear,
          connectorProp = _props.connector,
          nowrap = _props.nowrap,
          style = _props.style;


      var childrenArray = _react2.default.Children.toArray(children);
      var steps = childrenArray.map(function (step, index) {
        var stepIndex = index + 1;
        var isLast = childrenArray.length === index + 1;
        var props = _extends({
          last: isLast,
          active: false
        }, step.props, {
          linear: linear,
          strictlyLinear: strictlyLinear,
          index: index,
          step: stepIndex
        });
        if (activeStep === stepIndex) {
          props.active = true;
        }
        if (linear) {
          props.disabled = stepIndex > activeStep ? true : false;
        }
        if (strictlyLinear) {
          props.disabled = stepIndex !== activeStep ? true : false;
        }
        if (linear || strictlyLinear) {
          props.completed = stepIndex < activeStep ? true : false;
        }

        var connector = connectorProp ? _react2.default.cloneElement(connectorProp) : null;

        return [connector && index > 0 && _react2.default.cloneElement(connector, { key: 'connect-' + (stepIndex - 1) + '-to-' + stepIndex }), _react2.default.createElement(
          'div',
          {
            key: 'stepper-step-' + stepIndex
            // remove event handler for disabled step button:
            , onClick: props.disabled ? function () {} : props.children.props.onClick,
            style: nowrap ? { width: '100%' } : {}
          },
          _react2.default.cloneElement(step, _extends({}, props, {
            children: _react2.default.cloneElement(props.children, _extends({}, props.children.props))
          }))
        )];
      });

      return _react2.default.createElement(
        StepperWrapperUI,
        { nowrap: nowrap, style: style },
        steps
      );
    }
  }]);

  return Stepper;
}(_react.Component);

Stepper.propTypes = {
  connector: _propTypes2.default.object
};

Stepper.defaultProps = {
  connector: _react2.default.createElement(_StepConnector2.default, null)
};

exports.default = Stepper;