'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  justify-content: center;\n  align-items: center;\n'], ['\n  display: flex;\n  justify-content: center;\n  align-items: center;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  /* z-index: 0;\n    solves an issue related to having sticky table header via data grid\n  */\n  z-index: 0;\n\n  width: 100%;\n  border-collapse: collapse;\n  border-spacing: 0px;\n  table-layout: fixed;\n  border: none;\n'], ['\n  /* z-index: 0;\n    solves an issue related to having sticky table header via data grid\n  */\n  z-index: 0;\n\n  width: 100%;\n  border-collapse: collapse;\n  border-spacing: 0px;\n  table-layout: fixed;\n  border: none;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var TableWrapperUI = _styledComponents2.default.div(_templateObject);

var TableUI = _styledComponents2.default.table(_templateObject2);

var createTableBody = function createTableBody(base) {
  return _react2.default.cloneElement(base, {
    isSelectionControlled: this.isSelectionControlled,
    activeRow: this.props.activeRow,
    multiSelectable: this.props.multiSelectable,
    onRowSelection: this.props.onRowSelection,
    onActivateRow: this.props.onActivateRow,
    selectable: this.props.selectable,
    condensed: this.props.condensed,
    noBorder: this.props.noBorder,
    isRowSelected: this.props.isRowSelected,
    activable: this.props.activable,
    getID: this.props.getID,
    sperateRows: this.props.sperateRows,
    style: Object.assign({ height: this.props.height }, base.props.style || {})
  });
};

var createTableHeader = function createTableHeader(base) {
  return _react2.default.cloneElement(base, {
    allRowsSelected: this.props.allRowsSelected,
    selectable: this.props.selectable,
    multiSelectable: this.props.multiSelectable,
    onSelectAll: this.props.onSelectAll,
    condensed: this.props.condensed,
    noBorder: this.props.noBorder
  });
};

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.createTableBody = createTableBody.bind(_this);
    _this.createTableHeader = createTableHeader.bind(_this);

    _this.isSelectionControlled = props.selectedEntities !== undefined;
    return _this;
  }

  _createClass(Table, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          style = _props.style;


      var tBody = void 0;
      var tHead = void 0;
      var tFoot = void 0;

      _react2.default.Children.forEach(children, function (child) {
        if (!_react2.default.isValidElement(child)) return;

        var componentName = child.type.componentName;

        if (componentName === 'TableBody') {
          tBody = _this2.createTableBody(child, _this2.isSelectionControlled);
        } else if (componentName === 'TableHeader') {
          tHead = _this2.createTableHeader(child);
        } else if (componentName === 'TableFooter') {
          tFoot = child;
        } else {
          console.warn('cluedin-ui: Children of the Table component must be TableBody or TableHeader or TableFooter. Nothing is rendered.');
        }
      });

      return _react2.default.createElement(
        TableWrapperUI,
        null,
        _react2.default.createElement(
          TableUI,
          { style: style },
          tHead,
          tBody,
          tFoot
        )
      );
    }
  }]);

  return Table;
}(_react.Component);

Table.componentName = 'Table';


Table.propTypes = {
  children: _propTypes2.default.node
  // multiSelectable: PropTypes.bool,
  // allRowsSelected: PropTypes.bool,
  // onRowSelection: PropTypes.func,
  // selectable: PropTypes.bool,
  // height: PropTypes.string,
  // sperateRows: PropTypes.bool,
};

Table.defaultProps = {
  children: null,
  multiSelectable: false,
  allRowsSelected: false,
  onRowSelection: function onRowSelection() {},
  selectable: false,
  height: '',
  sperateRows: false
};

exports.default = Table;