'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TableRowCheckedCell = require('./TableRowCheckedCell');

var _TableRowCheckedCell2 = _interopRequireDefault(_TableRowCheckedCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableBody = function (_Component) {
  _inherits(TableBody, _Component);

  function TableBody() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TableBody);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TableBody.__proto__ || Object.getPrototypeOf(TableBody)).call.apply(_ref, [this].concat(args))), _this), _this.onRowSelect = function (rowProps, event, rowNumber) {
      if (_this.props.selectable && _this.props.onRowSelection) {
        _this.props.onRowSelection(rowNumber);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TableBody, [{
    key: 'createRows',
    value: function createRows() {
      var _this2 = this;

      var _props = this.props,
          selectable = _props.selectable,
          condensed = _props.condensed,
          noBorder = _props.noBorder,
          onActivateRow = _props.onActivateRow,
          activeRow = _props.activeRow,
          isRowSelected = _props.isRowSelected,
          activable = _props.activable,
          sperateRows = _props.sperateRows;


      var numChildren = _react2.default.Children.count(this.props.children);
      var rowNumber = 0;

      var rowChildren = _react2.default.Children.map(this.props.children, function (child, i) {
        if (!_react2.default.isValidElement(child)) {
          return undefined; // consistent-return
        }

        var isSelected = isRowSelected && isRowSelected(rowNumber, child.props.value);

        var handlers = {
          onClick: function onClick(event, rowIndex) {
            if (onActivateRow) {
              onActivateRow(event, rowIndex);
            }

            if (child.props.onClick) {
              child.props.onClick(event, rowIndex);
            }
          }
        };

        var props = Object.assign({}, {
          condensed: condensed,
          noBorder: noBorder,
          selected: isSelected,
          readOnly: child.props.readOnly,
          readOnlyText: child.props.readOnlyText,
          locked: child.props.locked,
          rowNumber: rowNumber,
          onRowSelect: _this2.onRowSelect.bind(_this2),
          isActive: activeRow === rowNumber,
          displayBorder: rowNumber !== numChildren,
          sperateRows: sperateRows,
          activable: activable,
          // key: i,
          key: child.key
        });

        var children = [];

        var checked = isSelected;
        if (selectable) {
          children.push(_react2.default.createElement(_TableRowCheckedCell2.default, _extends({}, props, { childKey: child.key, checked: checked })));
        }

        _react2.default.Children.forEach(child.props.children, function (aChild, j) {
          if (aChild && _react2.default.isValidElement(aChild)) {
            var augmentedChildren = _react2.default.cloneElement(aChild, _extends({}, aChild.props, {
              key: (child.key || i) + '-' + j,
              onClickHandler: aChild.props.onClick,
              condensed: condensed,
              noBorder: noBorder,
              selected: isSelected
            }));
            children.push(augmentedChildren);
          }
        });

        rowNumber += 1;

        return _react2.default.cloneElement(child, _extends({}, props, handlers), children);
      });
      return rowChildren;
    }
  }, {
    key: 'render',
    value: function render() {
      var style = this.props.style;

      return _react2.default.createElement(
        'tbody',
        { style: style },
        this.createRows()
      );
    }
  }]);

  return TableBody;
}(_react.Component);

TableBody.componentName = 'TableBody';


TableBody.propTypes = {
  selectable: _propTypes2.default.bool,
  onRowSelection: _propTypes2.default.func,
  children: _propTypes2.default.node
};

TableBody.defaultProps = {
  selectable: false,
  onRowSelection: function onRowSelection() {},
  children: null
};

exports.default = TableBody;