'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n\n  th {\n    ', ';\n\n    & > * {\n      ', ';\n    }\n  }\n'], ['\n\n  th {\n    ', ';\n\n    & > * {\n      ', ';\n    }\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TableHeaderCheckedAllCell = require('./TableHeaderCheckedAllCell');

var _TableHeaderCheckedAllCell2 = _interopRequireDefault(_TableHeaderCheckedAllCell);

var _TableHeaderCheckedPlaceholderCell = require('./TableHeaderCheckedPlaceholderCell');

var _TableHeaderCheckedPlaceholderCell2 = _interopRequireDefault(_TableHeaderCheckedPlaceholderCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/* eslint-disable indent */
var Thead = _styledComponents2.default.thead(_templateObject, function (_ref) {
  var stickyHeader = _ref.stickyHeader;
  return stickyHeader ? 'background: white;\n        position: sticky;\n        top: 0;\n        z-index: 1;\n      ' : '';
}, function (_ref2) {
  var stickyHeader = _ref2.stickyHeader;
  return stickyHeader ? 'border-bottom: 2px solid #cecece' : '';
});
/* eslint-enable indent */

var TableHeader = function (_Component) {
  _inherits(TableHeader, _Component);

  function TableHeader() {
    _classCallCheck(this, TableHeader);

    return _possibleConstructorReturn(this, (TableHeader.__proto__ || Object.getPrototypeOf(TableHeader)).apply(this, arguments));
  }

  _createClass(TableHeader, [{
    key: 'createSuperHeaderRows',
    value: function createSuperHeaderRows() {
      var numChildren = _react2.default.Children.count(this.props.children);
      if (numChildren === 1) return undefined;

      var superHeaders = [];
      for (var index = 0; index < numChildren - 1; index += 1) {
        var child = this.props.children[index];

        if (!_react2.default.isValidElement(child)) continue; // eslint-disable-line no-continue

        var props = _extends({}, child.props, {
          key: 'sh' + index,
          rowNumber: index
        });
        superHeaders.push(this.createSuperHeaderRow(child, props, index));
      }

      if (superHeaders.length) {
        return superHeaders;
      }
      return null;
    }
  }, {
    key: 'createSuperHeaderRow',
    value: function createSuperHeaderRow(child, props, index) {
      var _props = this.props,
          condensed = _props.condensed,
          noBorder = _props.noBorder,
          adjustForCheckbox = _props.adjustForCheckbox,
          enableSelectAll = _props.enableSelectAll,
          rowNumber = _props.rowNumber;


      var children = [];
      if (adjustForCheckbox) {
        children.push(_react2.default.createElement(_TableHeaderCheckedPlaceholderCell2.default, {
          enableSelectAll: enableSelectAll,
          rowNumber: rowNumber,
          key: rowNumber
        }));
      }

      _react2.default.Children.forEach(child.props.children, function (aChild, i) {
        if (aChild) {
          var augmentedChildren = _react2.default.cloneElement(aChild, _extends({}, aChild && aChild.props || {}, {
            key: i,
            condensed: condensed,
            noBorder: noBorder
          }));
          children.push(augmentedChildren);
        }
      });

      return _react2.default.cloneElement(child, _extends({}, props, {
        condensed: condensed,
        noBorder: noBorder,
        isTableHeader: true,
        key: index
      }), children);
    }
  }, {
    key: 'createBaseHeaderRow',
    value: function createBaseHeaderRow() {
      var _props2 = this.props,
          multiSelectable = _props2.multiSelectable,
          selectable = _props2.selectable,
          condensed = _props2.condensed,
          noBorder = _props2.noBorder,
          allRowsSelected = _props2.allRowsSelected,
          enableSelectAll = _props2.enableSelectAll,
          onSelectAll = _props2.onSelectAll;


      var numChildren = _react2.default.Children.count(this.props.children);
      var child = numChildren === 1 ? this.props.children : this.props.children[numChildren - 1];

      var children = [];

      if (selectable) {
        if (multiSelectable) {
          children.push(_react2.default.createElement(_TableHeaderCheckedAllCell2.default, {
            key: 'TableHeaderCheckedAllCell',
            onCheckAll: function onCheckAll(event, checked) {
              if (onSelectAll) {
                onSelectAll(checked);
              }
            },
            allRowsSelected: allRowsSelected,
            rowNumber: numChildren
          }));
        } else {
          children.push(_react2.default.createElement(_TableHeaderCheckedPlaceholderCell2.default, {
            key: 'TableHeaderCheckedPlaceholderCell',
            enableSelectAll: enableSelectAll,
            rowNumber: numChildren
          }));
        }
      }

      _react2.default.Children.forEach(child.props.children, function (aChild, i) {
        if (aChild) {
          var augmentedChildren = _react2.default.cloneElement(aChild, _extends({}, aChild.props, {
            key: i,
            onClick: aChild.props.onClick,
            onClickHandler: aChild.props.onClick,
            condensed: condensed,
            noBorder: noBorder
          }));
          children.push(augmentedChildren);
        }
      });

      return _react2.default.cloneElement(child, {
        key: 'h' + numChildren,
        rowNumber: numChildren,
        condensed: condensed,
        noBorder: noBorder,
        isTableHeader: true
      }, children);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          className = _props3.className,
          style = _props3.style,
          stickyHeader = _props3.stickyHeader;


      var superHeaderRows = this.createSuperHeaderRows();
      var baseHeaderRow = this.createBaseHeaderRow();

      return _react2.default.createElement(
        Thead,
        { stickyHeader: stickyHeader, className: className, style: style },
        superHeaderRows,
        baseHeaderRow
      );
    }
  }]);

  return TableHeader;
}(_react.Component);

TableHeader.componentName = 'TableHeader';
TableHeader.propTypes = {
  /**
   * Controls whether or not header rows should be
   * adjusted for a checkbox column. If the select all
   * checkbox is true, this property will not influence
   * the number of columns. This is mainly useful for
   * "super header" rows so that the checkbox column
   * does not create an offset that needs to be accounted
   * for manually.
   */
  adjustForCheckbox: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  /**
   * The css class name of the root element.
   */
  className: _propTypes2.default.string,
  /**
   * Controls whether or not the select all checkbox is displayed.
   */
  // displaySelectAll: PropTypes.bool, // commented out because it is never used
  /**
   * If set to true, the select all button will be interactable.
   * If set to false, the button will not be interactable.
   * To hide the checkbox, set displaySelectAll to false.
   */
  enableSelectAll: _propTypes2.default.bool,
  /**
   * @ignore
   * Callback when select all has been checked.
   */
  onSelectAll: _propTypes2.default.func,
  /**
   * @ignore
   * True when select all has been checked.
   */
  // selectAllSelected: PropTypes.bool, // commented out because it is never used
  /**
   * Override the inline-styles of the root element.
   */
  style: _propTypes2.default.object
};
TableHeader.defaultProps = {
  adjustForCheckbox: true,
  // displaySelectAll: true,  // commented out because it is never used
  enableSelectAll: true,
  // selectAllSelected: false, // commented out because it is never used
  /**
    * Controls whether or not header rows should be
    * adjusted for a checkbox column. If the select all
    * checkbox is true, this property will not influence
    * the number of columns. This is mainly useful for
    * "super header" rows so that the checkbox column
    * does not create an offset that needs to be accounted
    * for manually.
    */
  children: null,
  className: '',
  onSelectAll: function onSelectAll() {},
  style: {}
};
exports.default = TableHeader;