'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  font-weight: normal;\n  font-size: ', ';\n  text-align: left;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  color: rgb(158, 158, 158);\n  position: relative;\n  text-transform: uppercase;\n  padding:0;\n'], ['\n  font-weight: normal;\n  font-size: ', ';\n  text-align: left;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  color: rgb(158, 158, 158);\n  position: relative;\n  text-transform: uppercase;\n  padding:0;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Th = _styledComponents2.default.th(_templateObject, function (_ref) {
  var condensed = _ref.condensed;
  return condensed ? '12px' : '13px';
});

var TableHeaderColumn = function (_Component) {
  _inherits(TableHeaderColumn, _Component);

  function TableHeaderColumn() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, TableHeaderColumn);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = TableHeaderColumn.__proto__ || Object.getPrototypeOf(TableHeaderColumn)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      hovered: false
    }, _this.onClick = function (event) {
      if (_this.props.onClickHandler) {
        _this.props.onClickHandler(event, _this.props.columnNumber);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TableHeaderColumn, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          columnNumber = _props.columnNumber,
          hoverable = _props.hoverable,
          style = _props.style,
          noPadding = _props.noPadding,
          other = _objectWithoutProperties(_props, ['children', 'className', 'columnNumber', 'hoverable', 'style', 'noPadding']);

      var handlers = {
        onClick: this.onClick
      };

      return _react2.default.createElement(
        Th,
        _extends({
          className: className
        }, other, handlers, {
          style: style
        }),
        _react2.default.createElement(
          'div',
          {
            style: {
              paddingLeft: noPadding ? 0 : '24px',
              paddingRight: noPadding ? 0 : '24px',
              height: '100%',
              boxSizing: 'border-box',
              display: 'flex',
              alignItems: 'center'
              // lineHeight: '46px',
            }
          },
          children
        )
      );
    }
  }]);

  return TableHeaderColumn;
}(_react.Component);

TableHeaderColumn.propTypes = {
  children: _propTypes2.default.node,
  /**
   * The css class name of the root element.
   */
  className: _propTypes2.default.string,
  /**
   * Number to identify the header row. This property
   * is automatically populated when used with TableHeader.
   */
  columnNumber: _propTypes2.default.number,
  /**
   * @ignore
   * Not used here but we need to remove it from the root element.
   */
  hoverable: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  onClickHandler: _propTypes2.default.func, // what is this ?
  /**
   * Override the inline-styles of the root element.
   */
  style: _propTypes2.default.object,
  selectable: _propTypes2.default.bool,
  allRowsSelected: _propTypes2.default.bool,
  multiSelectable: _propTypes2.default.bool,
  onRowSelection: _propTypes2.default.func
};

TableHeaderColumn.defaultProps = {
  children: null,
  /**
   * The css class name of the root element.
   */
  className: '',
  /**
   * Number to identify the header row. This property
   * is automatically populated when used with TableHeader.
   */
  columnNumber: 0,
  /**
   * @ignore
   * Not used here but we need to remove it from the root element.
   */
  hoverable: false,
  onClick: function onClick() {},
  onClickHandler: function onClickHandler() {}, // what is this ?
  /**
   * Override the inline-styles of the root element.
   */
  style: {},
  selectable: false,
  allRowsSelected: false,
  multiSelectable: false,
  onRowSelection: function onRowSelection() {}
};

exports.default = TableHeaderColumn;