'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTooltip = require('rc-tooltip');

var _rcTooltip2 = _interopRequireDefault(_rcTooltip);

var _Icons = require('../Icons');

var _Checkbox = require('../Input/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _TableRowColumn = require('./TableRowColumn');

var _TableRowColumn2 = _interopRequireDefault(_TableRowColumn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createCheckbox = function createCheckbox(rowProps) {
  var condensed = rowProps.condensed,
      onRowSelect = rowProps.onRowSelect,
      checkboxId = rowProps.checkboxId,
      uniqueId = rowProps.uniqueId,
      locked = rowProps.locked,
      readOnlyText = rowProps.readOnlyText,
      rowNumber = rowProps.rowNumber,
      checked = rowProps.checked;
  // const key = `${uniqueId}-cb`;

  if (locked) {
    var icon = _react2.default.createElement(_Icons.Markassensitive, {
      style: { color: 'rgb(158, 158, 158)', fill: 'rgb(158, 158, 158)' },
      size: condensed ? 14 : 20
    });

    if (readOnlyText) {
      return _react2.default.createElement(
        _rcTooltip2.default,
        { placement: 'bottom', overlay: readOnlyText },
        icon
      );
    }

    return icon;
  }

  return _react2.default.createElement(
    'div',
    { 'data-uniqueid': uniqueId },
    _react2.default.createElement(_Checkbox2.default
    // ref="rowSelectCB" // ref have to be fn
    , { id: checkboxId,
      name: checkboxId
      // disabled={false}
      , defaultChecked: undefined,
      checked: checked,
      onChange: function onChange(event) {
        return onRowSelect(rowProps, event, rowNumber);
      }
    })
  );
};

var TableRowCheckedCell = function TableRowCheckedCell(props) {
  var condensed = props.condensed,
      locked = props.locked,
      rowNumber = props.rowNumber,
      noBorder = props.noBorder,
      childKey = props.childKey;

  var key = childKey ? childKey + '-selectCB' : rowNumber;
  var checkBoxCellStyle = {
    cursor: locked ? 'not-allowed' : 'inherit',
    width: '42px',
    paddingLeft: '8px',
    paddingRight: '8px',
    textAlign: 'center'
  };

  return _react2.default.createElement(
    _TableRowColumn2.default,
    {
      key: key,
      'data-key': childKey + '-selectCB',
      columnNumber: 0,
      style: checkBoxCellStyle,
      condensed: condensed,
      noBorder: noBorder
    },
    createCheckbox(_extends({}, props, { checkboxId: childKey + '-selectCB' }))
  );
};

exports.default = TableRowCheckedCell;