'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabList = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Tab = require('./Tab');

var _Tab2 = _interopRequireDefault(_Tab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function renderChildren(props) {
  return _react2.default.Children.map(props.children, function (child, index) {
    // if child is not a tab we don't need to clone it
    // since we don't need to add custom props
    var isFirst = false;
    if (child.type !== _Tab2.default) {
      return child;
    }

    if (index === 0) {
      isFirst = true;
    }

    var clonedProps = {
      isMainStyle: props.isMainStyle,
      activeTabClassName: props.activeTabClassName,
      disabledTabClassName: props.disabledTabClassName,
      isFirst: isFirst
    };

    return _react2.default.cloneElement(child, clonedProps);
  });
}

var TabListStyle = {
  tabList: {
    margin: 0,
    padding: 0,
    listStyle: 'none',
    background: '#EEEEEE'
  },
  tabListMain: {
    borderTop: 0,
    borderBottom: '1px solid #D4DAD1',
    margin: 0,
    padding: 0,
    listStyle: 'none',
    background: '#fff'
  }
};

var TabList = exports.TabList = function (_Component) {
  _inherits(TabList, _Component);

  function TabList() {
    _classCallCheck(this, TabList);

    return _possibleConstructorReturn(this, (TabList.__proto__ || Object.getPrototypeOf(TabList)).apply(this, arguments));
  }

  _createClass(TabList, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          activeTabClassName = _props.activeTabClassName,
          disabledTabClassName = _props.disabledTabClassName,
          children = _props.children,
          isMainStyle = _props.isMainStyle,
          attributes = _objectWithoutProperties(_props, ['className', 'activeTabClassName', 'disabledTabClassName', 'children', 'isMainStyle']);

      var mergedStyle = TabListStyle.tabList;

      if (isMainStyle) {
        mergedStyle = TabListStyle.tabListMain;
      }
      return _react2.default.createElement(
        'ul',
        _extends({
          style: mergedStyle
        }, attributes, {
          className: (0, _classnames2.default)(
          // 'ReactTabs__TabList',
          className),
          role: 'tablist'
        }),
        renderChildren({ activeTabClassName: activeTabClassName, isMainStyle: isMainStyle, disabledTabClassName: disabledTabClassName, children: children })
      );
    }
  }]);

  return TabList;
}(_react.Component);

TabList.displayName = 'TabList';
TabList.propTypes = {
  className: _propTypes2.default.string,
  activeTabClassName: _propTypes2.default.string,
  disabledTabClassName: _propTypes2.default.string,
  isMainStyle: _propTypes2.default.bool,
  children: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array])
};
TabList.defaultProps = {
  className: '',
  activeTabClassName: '',
  disabledTabClassName: '',
  isMainStyle: false,
  children: null
};
exports.default = TabList;