'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabPanel = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabPanel = exports.TabPanel = function (_Component) {
  _inherits(TabPanel, _Component);

  function TabPanel() {
    _classCallCheck(this, TabPanel);

    return _possibleConstructorReturn(this, (TabPanel.__proto__ || Object.getPrototypeOf(TabPanel)).apply(this, arguments));
  }

  _createClass(TabPanel, [{
    key: 'getDefaultProps',
    value: function getDefaultProps() {
      return {
        selected: false,
        id: null,
        tabId: null
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          children = _props.children,
          selected = _props.selected,
          id = _props.id,
          tabId = _props.tabId,
          style = _props.style,
          attributes = _objectWithoutProperties(_props, ['className', 'children', 'selected', 'id', 'tabId', 'style']);

      return _react2.default.createElement(
        'div',
        _extends({}, attributes, {
          className: (0, _classnames2.default)(
          // 'ReactTabs__TabPanel',
          className, {
            'ReactTabs__TabPanel--selected': selected
          }),
          role: 'tabpanel',
          id: id,
          'aria-labelledby': tabId,
          style: _extends({ padding: '15px 0' }, style, { display: selected ? null : 'none' })
        }),
        this.context.forceRenderTabPanel || selected ? children : null
      );
    }
  }]);

  return TabPanel;
}(_react.Component);

TabPanel.displayName = 'TabPanel';
TabPanel.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object, _propTypes2.default.string]),
  className: _propTypes2.default.string,
  id: _propTypes2.default.string,
  selected: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  tabId: _propTypes2.default.string
};
TabPanel.defaultProps = {
  children: null,
  className: '',
  id: '',
  selected: false,
  style: {},
  tabId: ''
};
TabPanel.contextTypes = {
  forceRenderTabPanel: _propTypes2.default.bool
};
exports.default = TabPanel;