'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextEllipsisUI = exports.textEllipsisStylesCSSString = undefined;

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  /* truncate tail by default */\n  ', ';\n'], ['\n  ', ';\n  /* truncate tail by default */\n  ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var textEllipsisStylesCSSString = exports.textEllipsisStylesCSSString = '\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n  max-width: 100%;\n';

// eslint-disable-next-line no-unexpected-multiline
var TextEllipsisUI = exports.TextEllipsisUI = _styledComponents2.default.div(_templateObject, textEllipsisStylesCSSString, function (_ref) {
  var truncateHead = _ref.truncateHead,
      leftAligned = _ref.leftAligned;
  return truncateHead ? 'text-align: ' + (leftAligned ? 'left' : 'right') + '; direction: rtl;' : '';
});

var TextEllipsis = function TextEllipsis() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return props.truncateHead ? _react2.default.createElement(
    TextEllipsisUI,
    props,
    _react2.default.createElement(
      'bdi',
      null,
      props.children
    )
  ) : _react2.default.createElement(TextEllipsisUI, props);
};

exports.default = TextEllipsis;