'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTooltip = require('rc-tooltip');

var _rcTooltip2 = _interopRequireDefault(_rcTooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getTooltip = function getTooltip(fullText) {
  return _react2.default.createElement(
    _rcTooltip2.default,
    {
      overlay: _react2.default.createElement(
        'div',
        { style: { maxWidth: '620px' } },
        fullText
      )
    },
    _react2.default.createElement(
      'span',
      null,
      '\xA0',
      _react2.default.createElement(
        'small',
        { style: { textDecoration: 'underline' } },
        '(...)'
      )
    )
  );
};

var TruncatedText = function TruncatedText(_ref) {
  var _ref$text = _ref.text,
      text = _ref$text === undefined ? '' : _ref$text,
      children = _ref.children,
      _ref$max = _ref.max,
      max = _ref$max === undefined ? 150 : _ref$max,
      _ref$withViewMoreLink = _ref.withViewMoreLink,
      withViewMoreLink = _ref$withViewMoreLink === undefined ? false : _ref$withViewMoreLink,
      style = _ref.style;

  var tooltip = null;
  var truncatedText = children && children instanceof String ? children : text;

  if (text.length > max) {
    truncatedText = text.slice(0, max - 6);
    tooltip = withViewMoreLink ? getTooltip(text) : null;
  }

  return _react2.default.createElement(
    'div',
    { style: style },
    truncatedText,
    tooltip
  );
};

exports.default = TruncatedText;