'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDnd = require('react-dnd');

var _reactDndHtml5Backend = require('react-dnd-html5-backend');

var _reactDndHtml5Backend2 = _interopRequireDefault(_reactDndHtml5Backend);

var _styledComponents = require('styled-components');

var _global = require('../global');

var _utils = require('../utils');

var _index = require('../index');

var _ContextThemeProvider = require('./ContextThemeProvider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UXISCThemeProvider = function UXISCThemeProvider(props) {
  var children = props.children,
      customPalette = props.palette,
      defaultTheme = props.defaultTheme,
      theme = props.theme;


  var theTheme = defaultTheme;
  if (theme) {
    theTheme = (0, _utils.mergeTheme)(defaultTheme, theme);
  } else if (customPalette) {
    theTheme = (0, _utils.getThemeWithCustomPalette)(customPalette);
  }

  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: theTheme || theme },
    _react2.default.createElement(
      _ContextThemeProvider.ThemeProvider,
      null,
      _react2.default.createElement(
        _reactDnd.DndProvider,
        { backend: _reactDndHtml5Backend2.default },
        _react2.default.createElement(
          'div',
          { style: { height: '100%' } },
          _react2.default.createElement(_global.GlobalStyle, null),
          children
        )
      )
    )
  );
};

UXISCThemeProvider.propTypes = {
  defaultTheme: _propTypes2.default.object,
  theme: _propTypes2.default.object,
  palette: _propTypes2.default.object
};

UXISCThemeProvider.defaultProps = {
  defaultTheme: _index.theme || {},
  theme: undefined,
  palette: {}
};

UXISCThemeProvider.displayName = 'UXISCThemeProvider';

exports.default = UXISCThemeProvider;