'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.theme = exports.palette = undefined;

var _templateObject = _taggedTemplateLiteral(['\n      color: ', ';\n      font-weight: bold;\n    '], ['\n      color: ', ';\n      font-weight: bold;\n    ']),
    _templateObject2 = _taggedTemplateLiteral(['font-size: 1.85em; margin: .67em 0;'], ['font-size: 1.85em; margin: .67em 0;']),
    _templateObject3 = _taggedTemplateLiteral(['font-size: 1.70em; margin: .6em 0;'], ['font-size: 1.70em; margin: .6em 0;']),
    _templateObject4 = _taggedTemplateLiteral(['font-size: 1.38em; margin: .5em 0;'], ['font-size: 1.38em; margin: .5em 0;']),
    _templateObject5 = _taggedTemplateLiteral(['font-size: 1.2em; margin: .5em 0;'], ['font-size: 1.2em; margin: .5em 0;']),
    _templateObject6 = _taggedTemplateLiteral(['font-size: 1em; margin: .5em 0;'], ['font-size: 1em; margin: .5em 0;']),
    _templateObject7 = _taggedTemplateLiteral(['font-size: .86em; margin: .5em 0;'], ['font-size: .86em; margin: .5em 0;']);

var _styledComponents = require('styled-components');

var _palette = require('./palette');

var _colorManipulator = require('./colorManipulator');

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var fonts = {
  fontFamily: 'Open sans, sans-serif'
};

var palette = exports.palette = _palette.palette;

var marketingFontFamilly = '\'Fira Sans\', sans-serif';

var theme = exports.theme = { // eslint-disable-line no-shadow
  wrapper: {
    '.uxi_container': {
      width: '100%',
      margin: '0 auto'
    },
    mediaQueries: {
      '(min-width: 768px)': {
        '.uxi_container': {
          maxWidth: '750px',
          margin: '0 auto'
        }
      },
      '(min-width: 992px)': {
        '.uxi_container': {
          maxWidth: '970px',
          margin: '0 auto'
        }
      },
      '(min-width: 1200px)': {
        '.uxi_container': {
          maxWidth: '1170px',
          margin: '0 auto'
        }
      }
    },
    body: {
      height: '100%',
      margin: 0,
      padding: 0
    },
    html: {
      height: '100%',
      margin: 0,
      padding: 0,
      background: palette.white,
      fontFamily: '\'Source Sans Pro\', sans-serif',
      color: palette.darkGrey
    },
    ul: {
      margin: 0,
      padding: 0,
      listStyle: 'none'
    },
    a: {
      color: palette.accent.main,
      textDecoration: 'none'
    },
    'a:hover': {
      color: (0, _colorManipulator.lighten)(palette.accent.main, 0.1),
      textDecoration: 'none'
    },
    'h1, h2, h3, h4': {
      color: palette.neutral.dark
    },
    '.uxi-root': {
      height: '100%'
    },
    table: {
      margin: 0,
      padding: 0
    },
    td: {
      padding: '5px 10px'
    }
  },
  root: {
    fontSize: '14p'
  },
  border: {
    default: '1px solid #e9e9e9'
  },
  palette: palette,
  background: {
    light: palette.purewhite,
    dark: palette.primary.main
  },
  padding: {
    breathPadding: '1em',
    defaultPadding: '24px',
    title: '15px 0',
    heading: '10px 0'
  },
  dimensions: {
    mainHeaderHeight: '80px'
  },
  marketingText: {
    light: {
      title: {
        fontFamilly: marketingFontFamilly,
        fontSize: '30px',
        fontWeight: 'bold',
        color: (0, _colorManipulator.lighten)('#000000', 0.11)
      },
      heading: {
        fontSize: '18px',
        fontFamilly: marketingFontFamilly,
        fontWeight: 600,
        color: (0, _colorManipulator.lighten)('#000000', 0.11)
      },
      button: {
        fontSize: '14px',
        color: (0, _colorManipulator.lighten)('#000000', 0.21)
      },
      body: {
        fontSize: '16px',
        color: (0, _colorManipulator.lighten)('#000000', 0.21)
      }
    },
    dark: {
      title: {
        fontFamilly: marketingFontFamilly,
        fontSize: '30px',
        fontWeight: 'bold',
        color: (0, _colorManipulator.lighten)('#ffffff', 0.11)
      },
      heading: {
        fontSize: '18px',
        fontFamilly: marketingFontFamilly,
        fontWeight: 600,
        color: (0, _colorManipulator.lighten)('#ffffff', 0.11)
      },
      button: {
        fontSize: '14px',
        color: (0, _colorManipulator.lighten)('#ffffff', 0.21)
      },
      body: {
        fontSize: '16px',
        color: (0, _colorManipulator.lighten)('#ffffff', 0.21)
      }
    }
  },
  fontsAndColor: {
    default: Object.assign({
      color: '#37373a'
    }, fonts),
    defaultOnDarkBg: Object.assign({
      color: '#fff'
    }, fonts),
    light: {
      title: {
        fontSize: '24px',
        fontWeight: 'bold',
        color: (0, _colorManipulator.lighten)('#000000', 0.11)
      },
      heading: {
        fontSize: '16px',
        fontWeight: 600,
        color: (0, _colorManipulator.lighten)('#000000', 0.11)
      },
      button: {
        fontSize: '14px',
        color: (0, _colorManipulator.lighten)('#000000', 0.21)
      },
      body: {
        fontSize: '14px',
        color: (0, _colorManipulator.lighten)('#000000', 0.21)
      },
      caption: {
        fontSize: '12px',
        color: (0, _colorManipulator.lighten)('#000000', 0.45)
      },
      disable: {
        color: (0, _colorManipulator.lighten)('#000000', 0.40)
      },
      link: {
        fontSize: '12px',
        color: '#15a9a9'
      }
    },
    dark: {
      title: {
        fontSize: '24px',
        fontWeight: 'bold',
        color: (0, _colorManipulator.darken)('#ffffff', 0.11)
      },
      heading: {
        fontSize: '16px',
        fontWeight: 600,
        color: (0, _colorManipulator.darken)('#ffffff', 0.11)
      },
      button: {
        fontSize: '14px',
        color: '#ffffff'
      },
      body: {
        fontSize: '14px',
        color: (0, _colorManipulator.darken)('#ffffff', 0.21)
      },
      caption: {
        fontSize: '12px',
        color: (0, _colorManipulator.darken)('#ffffff', 0.45)
      },
      disable: {
        color: (0, _colorManipulator.darken)('#ffffff', 0.40)
      },
      link: {
        fontSize: '12px',
        color: '#15a9a9'
      }
    }
  },
  title: {
    color: palette.lightBlack
  },
  button: {
    backgroundColor: palette.neutral.lightestDark,
    color: palette.neutral.darker,
    borderColor: palette.neutral.lightDark
  },
  'button:hover': {
    backgroundColor: palette.neutral.lightDark,
    color: palette.neutral.darker,
    borderColor: palette.neutral.neutral
  },
  'button:primary': {
    color: palette.white,
    backgroundColor: palette.accent.main,
    borderColor: palette.accent.dark
  },
  'button:primary:hover': {
    color: palette.accent.main,
    backgroundColor: palette.white,
    borderColor: palette.accent.dark
  },

  'button:secondary': {
    color: palette.white,
    backgroundColor: palette.primary.main,
    borderColor: palette.primary.dark
  },
  'button:secondary:hover': {
    color: palette.primary.main,
    backgroundColor: palette.white,
    borderColor: palette.primary.dark
  },

  'button:danger': {
    color: palette.white,
    backgroundColor: palette.semantic.error,
    borderColor: palette.semantic.error
  },
  'button:danger:hover': {
    color: palette.semantic.error,
    backgroundColor: palette.white,
    borderColor: palette.semantic.error
  },

  'button:warning': {
    color: palette.white,
    backgroundColor: palette.semantic.warning,
    borderColor: palette.semantic.warning
  },
  'button:warning:hover': {
    color: palette.semantic.warning,
    backgroundColor: palette.white,
    borderColor: palette.semantic.warning
  },

  'button:success': {
    color: palette.white,
    backgroundColor: palette.semantic.success,
    borderColor: palette.semantic.success
  },
  'button:success:hover': {
    color: palette.semantic.success,
    backgroundColor: palette.white,
    borderColor: palette.semantic.success
  },
  link: {
    linkOnBgDark: {
      cursor: 'pointer',
      textDecoration: 'none',
      color: palette.white
    },
    linkOnBgDarktHover: {
      color: palette.accent.main
    },
    linkOnBgLight: {
      cursor: 'pointer',
      textDecoration: 'none',
      color: palette.neutral.dark
    },
    linkOnBgLightHover: {
      color: palette.accent.main
    }
  },
  shadow: {
    base: 'rgba(0, 0, 0, 0.12) 0px 1px 6px, rgba(0, 0, 0, 0.12) 0px 1px 4px '
  },
  radius: '3px',
  outline: 'none',
  // outlineShadow: '0 0 5px 3px rgba(35, 35, 35, .4), 0 0 2px 2px rgba(35, 35, 35, .24)',
  outlineShadow: '0 0 3px 1px rgba(35, 35, 35, 0.28)',
  outlineShadow2: '0 1px 20px 0px hsla(0, 0%, 0%, 0.29), 0 1px 5px 0px hsla(0, 0%, 0%, 0.18)',
  // focusHighlight: 'Highlight',
  // focusHighlightText: 'HighlightText',
  focusHighlight: (0, _colorManipulator.lighten)(palette.accent.main, 0.85),
  focusHighlightText: palette.accent.main,
  transition: {
    default: '450ms cubic-bezier(0.23, 1, 0.32, 1) ',
    defaultAll: 'all 450ms cubic-bezier(0.23, 1, 0.32, 1) ',
    duration: '450ms ',
    durationIn: '292ms ',
    durationOut: '196ms ',
    delay: '0ms ',
    easing: 'cubic-bezier(0.23, 1, 0.32, 1) '
  },
  // TODO do not use that, theme declaration must be done in json (serializable) =>
  sc: {
    // titleColor: 'red',
    // titleFontSize: '2em',
    // OR title: { color: '', 'font-size': }
    title: (0, _styledComponents.css)(_templateObject, palette.darkGrey),
    h1: (0, _styledComponents.css)(_templateObject2),
    h2: (0, _styledComponents.css)(_templateObject3),
    h3: (0, _styledComponents.css)(_templateObject4),
    h4: (0, _styledComponents.css)(_templateObject5),
    h5: (0, _styledComponents.css)(_templateObject6),
    h6: (0, _styledComponents.css)(_templateObject7)
  }
};