'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.palette = undefined;

var _colorManipulator = require('./colorManipulator');

var palette = exports.palette = {
  pureWhite: '#FFFFFF',
  white: '#F3F3F2',
  extraLightGrey: '#c2c2c2',
  lightGrey: '#d4d4d4',
  grey: '#9a9a9a',
  midDarkGrey: '#595959',
  darkGrey: '#222222',
  primary: {
    light: '#30556b',
    main: '#1b3c4f',
    dark: '#1c313f'
  },
  accent: {
    light: '#64cfba',
    main: '#26a29a',
    dark: '#00897a'
  },
  semantic: {
    default: '#cecece', // !important for fallback
    error: '#d13f48',
    danger: '#d13f48',
    // this nwarn color looks way too pale -df
    // warning: 'rgba(247, 187, 62, 0.5)',
    warning: '#ff9800',
    info: '#3e53c1',
    success: '#009688'
  },
  neutral: {
    darkest: (0, _colorManipulator.lighten)('#000000', 0.11),
    darker: (0, _colorManipulator.lighten)('#000000', 0.21),
    dark: (0, _colorManipulator.lighten)('#000000', 0.45),
    neutral: (0, _colorManipulator.lighten)('#000000', 0.60),
    lightDark: (0, _colorManipulator.lighten)('#000000', 0.85),
    lightestDark: (0, _colorManipulator.lighten)('#000000', 0.95)
  },
  charts: {
    color1: '#64cfba',
    color2: '#62acba',
    color3: '#5789b3',
    color4: '#476ca2',
    color5: '#335184',
    color6: '#1b3c4f'
  }
};

exports.default = palette;