'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeTheme = exports.getThemeWithCustomPalette = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.mergeCustomPalette = mergeCustomPalette;

var _palette = require('./palette');

var _ = require('./');

var _colorManipulator = require('./colorManipulator');

// eslint-disable-next-line no-shadow
function mergeCustomPalette(mainPalette, customPalette) {
  var secondary = mainPalette.primary.main;
  var primary = mainPalette.accent.main;

  if (!customPalette) {
    return mainPalette;
  }
  if (customPalette.primary) {
    primary = customPalette.primary;
  }
  if (customPalette.secondary) {
    secondary = customPalette.secondary;
  }
  var palette = _extends({}, mainPalette, {
    primary: {
      main: secondary,
      light: (0, _colorManipulator.lighten)(secondary),
      dark: (0, _colorManipulator.darken)(secondary)
    },
    accent: {
      main: primary,
      light: (0, _colorManipulator.lighten)(primary),
      dark: (0, _colorManipulator.darken)(primary)
    }
  });
  return palette;
}

// eslint-disable-next-line no-use-before-define
var getThemeWithCustomPalette = exports.getThemeWithCustomPalette = function getThemeWithCustomPalette() {
  var customPalette = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  // eslint-disable-line no-shadow
  var themeWithCustomPalette = _extends({}, _.theme, {
    palette: mergeCustomPalette(_palette.palette, customPalette)
  });

  return themeWithCustomPalette;
};

var mergeTheme = exports.mergeTheme = function mergeTheme(defaultTheme, partialTheme) {
  return _extends({}, defaultTheme, partialTheme, {
    palette: mergeCustomPalette(defaultTheme.palette, partialTheme.palette),
    transition: _extends({}, defaultTheme.transition, {
      default: partialTheme.transition.default,
      defaultAll: 'all ' + partialTheme.transition.default
    })
  });
};