'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _templateObject = _taggedTemplateLiteral(['\n  ', ';\n  justify-content: flex-start;\n  align-items: flex-start;\n  flex-flow: row wrap;\n  & > *:first-child {}\n  & > *:nth-child(2) {}\n'], ['\n  ', ';\n  justify-content: flex-start;\n  align-items: flex-start;\n  flex-flow: row wrap;\n  & > *:first-child {}\n  & > *:nth-child(2) {}\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  box-sizing: border-box;\n  display:flex;\n  border: 1px solid #ccc;\n  padding: 16px;\n  position:relative;\n  flex-flow: row wrap;\n  & + & {\n    border-top: none;\n  }\n'], ['\n  box-sizing: border-box;\n  display:flex;\n  border: 1px solid #ccc;\n  padding: 16px;\n  position:relative;\n  flex-flow: row wrap;\n  & + & {\n    border-top: none;\n  }\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  padding-right:15px;\n'], ['\n  padding-right:15px;\n']),
    _templateObject4 = _taggedTemplateLiteral(['\n  width: 42px;\n  height: 42px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  ', ';\n'], ['\n  width: 42px;\n  height: 42px;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  ', ';\n']),
    _templateObject5 = _taggedTemplateLiteral(['\n  flex:1;\n  overflow: hidden;\n  margin-right: 16px;\n'], ['\n  flex:1;\n  overflow: hidden;\n  margin-right: 16px;\n']),
    _templateObject6 = _taggedTemplateLiteral(['\n  max-width: 280px;\n'], ['\n  max-width: 280px;\n']),
    _templateObject7 = _taggedTemplateLiteral(['\n  font-size: 16px;\n  padding-bottom: 5px;\n'], ['\n  font-size: 16px;\n  padding-bottom: 5px;\n']),
    _templateObject8 = _taggedTemplateLiteral([''], ['']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Img = require('../Img');

var _Img2 = _interopRequireDefault(_Img);

var _Layout = require('../Layout');

var _Icons = require('../Icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ExtendedFlex = _styledComponents2.default.div(_templateObject, _Layout.flexCSSString);

var TileDetailWrapper = _styledComponents2.default.div(_templateObject2);

var TileImageWrapper = _styledComponents2.default.div(_templateObject3);
var TileImageInnerWrapper = _styledComponents2.default.div(_templateObject4, function (_ref) {
  var roundImage = _ref.roundImage;
  return roundImage ? 'overflow: hidden; border-radius: 21px;' : '';
});

var TileContentWrapper = _styledComponents2.default.div(_templateObject5);

var TileExtra = _styledComponents2.default.div(_templateObject6);

var TileContentWrapperTitle = _styledComponents2.default.div(_templateObject7);

var TileDetail = function TileDetail(_ref2) {
  var title = _ref2.title,
      imageUrl = _ref2.imageUrl,
      imgTooltipOverlay = _ref2.imgTooltipOverlay,
      Tooltip = _ref2.Tooltip,
      icon = _ref2.icon,
      extra = _ref2.extra,
      children = _ref2.children,
      style = _ref2.style,
      roundImage = _ref2.roundImage;

  var imageContent = void 0;

  if (imageUrl) {
    imageContent = _react2.default.createElement(_Img2.default, { style: { width: '42px', height: '42px' }, alt: title, src: imageUrl });
  } else if (icon) {
    imageContent = _react2.default.cloneElement(icon, { size: '32px' });
  } else {
    imageContent = _react2.default.createElement(_Icons.Circle, { size: '42px' });
  }

  var extraContent = extra && _react2.default.createElement(
    TileExtra,
    { className: 'uxi-titleDetail-extra' },
    extra
  ) || null;

  var ImgTooltipWrapper = Tooltip && imgTooltipOverlay ? Tooltip : _styledComponents2.default.div(_templateObject8);

  return _react2.default.createElement(
    TileDetailWrapper,
    { className: 'uxi-tile-detail', style: style },
    _react2.default.createElement(
      _Layout.ContentWithExtra,
      {
        extra: extraContent,
        extraPosition: 'after',
        extraMinWidth: extraContent ? '280px' : 0
        // TODO add breakpoint for this to be larger on wider srceen
        // cannot hard code min-width more than 320 EVER! -df
        // use propsMapperMediaQuery
        , contentMinWidth: '280px'
      },
      _react2.default.createElement(
        ExtendedFlex,
        null,
        _react2.default.createElement(
          ImgTooltipWrapper,
          {
            overlay: imgTooltipOverlay,
            trigger: ['hover'],
            placement: 'top',
            destroyTooltipOnHide: true
          },
          _react2.default.createElement(
            TileImageWrapper,
            null,
            _react2.default.createElement(
              TileImageInnerWrapper,
              { roundImage: roundImage },
              imageContent
            )
          )
        ),
        _react2.default.createElement(
          TileContentWrapper,
          null,
          _react2.default.createElement(
            TileContentWrapperTitle,
            null,
            title
          ),
          _react2.default.createElement(
            'div',
            null,
            children
          )
        )
      )
    )
  );

  /*
    return (
      <TileDetailWrapper className="uxi-tile-detail" style={style}>
        <TileImageWrapper>
          <TileImageInnerWrapper>
             {imageContent}
           </TileImageInnerWrapper>
        </TileImageWrapper>
        <TileContentWrapper>
          <TileContentWrapperTitle>
             {title}
           </TileContentWrapperTitle>
          <div>
             {children}
           </div>
        </TileContentWrapper>
        {
          extra &&
          (
            <TileExtra className="uxi-titleDetail-extra">
              {extra}
            </TileExtra>
          )
        }
      </TileDetailWrapper>
    );
    */
};

exports.default = TileDetail;