'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _throttle = require('lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }
// import debounce from 'lodash/debounce';


function useOnDocumentMouseMove(refs, handler) {
  (0, _react.useEffect)(function () {
    var listener = function listener(event) {
      // TODO fi this, ideally we should not listen on documents
      // but on the 'input' component or dialog or whatever...
      // unless we decide to never do multiple modeal at once ??
      // Do nothing if clicking ref's element or descendent elements
      // if (!ref.current || ref.current.contains(event.target, event.currentTarget)) {
      //   return;
      // }
      console.log('useOnDocumentMouseMove listener running...');

      handler(event);
    };

    // const debounceListener = debounce(
    var debounceListener = (0, _throttle2.default)(listener, 14, { maxWait: 64, leading: true, trailing: false });

    document.addEventListener('mousemove', debounceListener);

    return function () {
      console.log('useOnDocumentMouseMove cleanup');
      debounceListener.flush();
      document.removeEventListener('mousemove', debounceListener);
    };
  },
  // Add ref and handler to effect dependencies
  // It's worth noting that because passed in handler is a new ...
  // ... function on every render that will cause this effect ...
  // ... callback/cleanup to run every render. It's not a big deal ...
  // ... but to optimize you can wrap handler in useCallback before ...
  // ... passing it into this hook.
  [].concat(_toConsumableArray(refs), [handler]));
}

exports.default = useOnDocumentMouseMove;