'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

function useOnDocumentMouseUp(ref, handler) {
  (0, _react.useEffect)(function () {
    var listener = function listener(event) {
      // TODO fi this, ideally we should not listen on
      // documents but on the 'input' component or dialog or whatever...
      // unless we decide to never do multiple modeal at once ??
      // Do nothing if clicking ref's element or descendent elements
      // if (!ref.current || ref.current.contains(event.target, event.currentTarget)) {
      //   return;
      // }

      handler(event);
    };

    document.addEventListener('mouseup', listener);

    return function () {
      document.removeEventListener('mouseup', listener);
    };
  },
  // Add ref and handler to effect dependencies
  // It's worth noting that because passed in handler is a new ...
  // ... function on every render that will cause this effect ...
  // ... callback/cleanup to run every render. It's not a big deal ...
  // ... but to optimize you can wrap handler in useCallback before ...
  // ... passing it into this hook.
  [ref, handler]);
}

exports.default = useOnDocumentMouseUp;