'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _throttle = require('lodash/throttle');

var _throttle2 = _interopRequireDefault(_throttle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var useResizeObserver = function useResizeObserver(deps, callback) {
  var _deps = _slicedToArray(deps, 1),
      reactRef = _deps[0];

  var state = null;
  (0, _react.useEffect)(function () {
    var handler = function handler(entries) {
      var contentRect = entries[0].contentRect;

      if (!(0, _isEqual2.default)(state, contentRect)) {
        // console.log('useResizeObserver handler running...');
        state = contentRect;
        callback(contentRect);
      }
    };

    var debounceHandler = (0, _throttle2.default)(handler, 16, { maxWait: 16, leading: true, trailing: false });

    var resizeObserver = new _resizeObserverPolyfill2.default(debounceHandler);

    resizeObserver.observe(reactRef.current);

    return function () {
      // console.log('useResizeObserver cleanup');
      resizeObserver.disconnect();
    };
  }, [callback].concat(_toConsumableArray(deps)));
};

exports.default = useResizeObserver;