'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropDown = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  pointer-events: none;\n  z-index: 9;\n  min-width: 100px;\n  position: absolute;\n  border-color: transparent;\n  margin-top: 1px;\n  border-radius: 3px;\n  opacity: 0;\n  display: flex;\n  flex-direction: column;\n  ', ';\n  /*transition: ', ';*/\n'], ['\n  pointer-events: none;\n  z-index: 9;\n  min-width: 100px;\n  position: absolute;\n  border-color: transparent;\n  margin-top: 1px;\n  border-radius: 3px;\n  opacity: 0;\n  display: flex;\n  flex-direction: column;\n  ', ';\n  /*transition: ', ';*/\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  clip: rect(-8px 38px 11px -8px);\n  position: absolute;\n  width: 20px;\n  height: 20px;\n  min-height: 29px;\n  background: transparent;\n  top: -11px;\n  ', ';\n\n  &:after {\n    ', ';\n    display: block;\n    width: 20px;\n    height: 20px;\n    position: absolute;\n    box-sizing: border-box;\n    background: white;\n    transform: rotate(-45deg);\n    transform-origin: center center;\n    border-style: solid;\n    border-color: rgb(206, 206, 206);\n    border-width: 1px;\n  }\n'], ['\n  clip: rect(-8px 38px 11px -8px);\n  position: absolute;\n  width: 20px;\n  height: 20px;\n  min-height: 29px;\n  background: transparent;\n  top: -11px;\n  ', ';\n\n  &:after {\n    ', ';\n    display: block;\n    width: 20px;\n    height: 20px;\n    position: absolute;\n    box-sizing: border-box;\n    background: white;\n    transform: rotate(-45deg);\n    transform-origin: center center;\n    border-style: solid;\n    border-color: rgb(206, 206, 206);\n    border-width: 1px;\n  }\n']),
    _templateObject3 = _taggedTemplateLiteral(['\n  position: relative;\n  display: inline-block;\n  height: 100%;\n  ', ';\n'], ['\n  position: relative;\n  display: inline-block;\n  height: 100%;\n  ', ';\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Button = require('../Button');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ItemsWrapper = _styledComponents2.default.div(_templateObject, function (_ref) {
  var isFullWidth = _ref.isFullWidth;
  return isFullWidth ? 'width: 100%' : '';
}, function (_ref2) {
  var transition = _ref2.theme.transition;
  return transition.defaultAll;
});

var PopOverArrow = _styledComponents2.default.div(_templateObject2, function (_ref3) {
  var anchor = _ref3.anchor;
  return anchor === 'right' ? 'right: 20px;' : 'left: 20px;';
}, function (_ref4) {
  var isPopOver = _ref4.isPopOver;
  return isPopOver ? 'content: ""' : '';
});

var WrapperUI = _styledComponents2.default.div(_templateObject3, function (_ref5) {
  var isFullWidth = _ref5.isFullWidth;
  return isFullWidth ? 'width: 100%' : '';
});

var getPosition = function getPosition(cRectMain, cRectItems, anchor, isPopOver) {
  var ItemsLeft = cRectMain.left;
  var ItemsTop = cRectMain.bottom;
  var top = isPopOver ? ItemsTop + 20 : ItemsTop;

  var left = anchor === 'left' ? ItemsLeft + 'px' : ItemsLeft - (cRectItems.width - cRectMain.width) + 'px';

  return {
    left: left,
    top: top + 'px'
  };
};

var getStyleForIsOpen = function getStyleForIsOpen(isOpen, itemsHeight) {
  return {
    maxHeight: itemsHeight + 'px',
    opacity: isOpen ? 1 : 0,
    borderColor: isOpen ? '#cecece' : 'transparent',
    pointerEvents: isOpen ? 'all' : 'none'
  };
};

/**
 * DropDown
 *
 * default to right aligning the droped down part
 */
var styles = {
  triggerWrapper: {
    cursor: 'pointer'
  },
  triggerInnerWrapper: {
    height: '100%',
    display: 'flex',
    alignItems: 'stretch'
  }
};

var DropDown = exports.DropDown = function (_PureComponent) {
  _inherits(DropDown, _PureComponent);

  function DropDown(props) {
    _classCallCheck(this, DropDown);

    var _this = _possibleConstructorReturn(this, (DropDown.__proto__ || Object.getPrototypeOf(DropDown)).call(this, props));

    _this.isOpenControlled = _this.props.isOpen !== undefined;

    _this.state = {
      isOpen: _this.isOpenControlled ? _this.props.isOpen : false,
      windowWidth: window.innerWidth,
      windowHeight: window.innerHeight,
      position: null,
      dynamicStyle: null
    };

    _this.handleToggleVisibility = _this.handleToggleVisibility.bind(_this);
    _this.closeDropdown = _this.closeDropdown.bind(_this);
    _this.attachListeners = _this.attachListeners.bind(_this);
    _this.detachListeners = _this.detachListeners.bind(_this);
    _this.mainRef = _react2.default.createRef();
    _this.itemsRef = _react2.default.createRef();
    _this.mainPanelRef = _react2.default.createRef();
    return _this;
  }

  _createClass(DropDown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.htmlNodeRef = this.getDomElementToListenTo();

      var isOpen = this.getOpenState();

      if (isOpen) {
        this.setState({
          dynamicStyle: this.getFullStyle()
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(_ref6, _ref7) {
      var prevOpen = _ref6.isOpen;
      var prevOpenState = _ref7.isOpen;

      var isOpen = this.getOpenState();
      var wasOpen = this.isOpenControlled ? prevOpen : prevOpenState;

      if (isOpen !== wasOpen) {
        this.setState({
          dynamicStyle: this.getFullStyle()
        });

        if (isOpen && this.itemsRef.current && this.itemsRef.currentfirstChild && this.itemsRef.currentfirstChild.firstChild) {
          this.itemsRef.current.firstChild.firstChild.focus();
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.detachListeners();
    }
  }, {
    key: 'getDomElementToListenTo',
    value: function getDomElementToListenTo() {
      var mainScrollingElementSelector = this.props.mainScrollingElementSelector;

      var elToListen = document;

      if (mainScrollingElementSelector) {
        var htmlNodeRef = document.querySelector(mainScrollingElementSelector);
        if (htmlNodeRef) {
          elToListen = htmlNodeRef;
        }
      }

      return elToListen;
    }
  }, {
    key: 'getOpenState',
    value: function getOpenState() {
      return this.isOpenControlled ? this.props.isOpen : this.state.isOpen;
    }
  }, {
    key: 'getFullStyle',
    value: function getFullStyle() {
      var mainRef = this.mainRef,
          itemsRef = this.itemsRef;
      var _props = this.props,
          anchor = _props.anchor,
          isFullWidth = _props.isFullWidth,
          isPopOver = _props.isPopOver;


      var isOpen = this.getOpenState();

      if (!mainRef || !itemsRef || !itemsRef.current || !mainRef.current || !itemsRef.current.firstChild) {
        return {};
      }

      var itemsHeight = 0;

      if (isOpen) {
        itemsHeight = this.calculateItemsHeight();
      }

      var cRectMain = mainRef.current.getBoundingClientRect();
      var cRectItems = itemsRef.current.getBoundingClientRect();

      var width = cRectMain.width;

      var positioning = getPosition(cRectMain, cRectItems, anchor, isPopOver);

      var styleChangingWithIsOpen = getStyleForIsOpen(isOpen, itemsHeight);

      return _extends({
        width: isFullWidth ? width + 'px' : 'auto',
        position: 'fixed'
      }, styleChangingWithIsOpen, positioning);
    }
  }, {
    key: 'calculateItemsHeight',
    value: function calculateItemsHeight() {
      var itemsRef = this.itemsRef;


      return itemsRef.current.firstChild.getBoundingClientRect().height;
    }
  }, {
    key: 'attachListeners',
    value: function attachListeners() {
      window.addEventListener('resize', this.closeDropdown);
      document.addEventListener('scroll', this.closeDropdown, true);
    }
  }, {
    key: 'detachListeners',
    value: function detachListeners() {
      window.removeEventListener('resize', this.closeDropdown);
      document.removeEventListener('scroll', this.closeDropdown, true);
    }
  }, {
    key: 'closeDropdown',
    value: function closeDropdown() {
      var onIsOpenChange = this.props.onIsOpenChange;


      if (this.isOpenControlled) {
        if (onIsOpenChange) {
          onIsOpenChange(false);
        }
      } else {
        this.setState({
          isOpen: false
        });
      }

      this.detachListeners();
    }
  }, {
    key: 'handleClickOutside',
    value: function handleClickOutside() {
      var _props2 = this.props,
          onClickOutside = _props2.onClickOutside,
          onIsOpenChange = _props2.onIsOpenChange;

      var isOpen = this.getOpenState();
      if (!isOpen) {
        return;
      }

      if (this.isOpenControlled && onClickOutside) {
        onClickOutside();
      }

      if (!this.isOpenControlled) {
        this.setState({
          isOpen: false
        });

        if (onIsOpenChange) {
          onIsOpenChange(false);
        }
      }

      this.detachListeners();
    }
  }, {
    key: 'closeVisibilty',
    value: function closeVisibilty() {
      var onIsOpenChange = this.props.onIsOpenChange;


      if (onIsOpenChange) {
        onIsOpenChange(false);
      }

      this.setState({
        isOpen: false
      });

      this.detachListeners();
    }
  }, {
    key: 'handleToggleVisibility',
    value: function handleToggleVisibility() {
      var onIsOpenChange = this.props.onIsOpenChange;

      var isOpen = this.getOpenState();

      var nextOpenState = !isOpen;
      this.setState({
        isOpen: nextOpenState
      });

      if (onIsOpenChange) {
        onIsOpenChange(nextOpenState);
      }

      if (nextOpenState) {
        this.attachListeners();
      } else {
        this.detachListeners();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props3 = this.props,
          isFullWidth = _props3.isFullWidth,
          anchor = _props3.anchor,
          inertMain = _props3.inertMain,
          style = _props3.style,
          itemsStyle = _props3.itemsStyle,
          triggerWrapperStyle = _props3.triggerWrapperStyle,
          isPopOver = _props3.isPopOver,
          isOpenProp = _props3.isOpen,
          children = _props3.children,
          main = _props3.main;
      var _state = this.state,
          isOpenState = _state.isOpen,
          shouldFocusTrigerrer = _state.shouldFocusTrigerrer,
          dynamicStyle = _state.dynamicStyle;


      var isOpen = isOpenProp || isOpenState;
      var cleanedItemsStyle = _extends({}, itemsStyle, isOpen && itemsStyle && 'maxHeight' in itemsStyle ? { maxHeight: itemsStyle.maxHeight } : {});

      var tabIndexButtonattr = shouldFocusTrigerrer ? { tabIndex: inertMain ? '-1' : '0' } : {};

      return _react2.default.createElement(
        WrapperUI,
        { style: style, isFullWidth: isFullWidth },
        _react2.default.createElement(
          _Button.UnstyledButton,
          _extends({
            inert: inertMain,
            'data-drop-down-main': true,
            role: inertMain === false ? undefined : 'menu',
            isFullWidth: isFullWidth,
            style: _extends({}, styles.triggerWrapper, triggerWrapperStyle),
            onClick: function onClick() {
              _this2.handleToggleVisibility();
            },
            onKeyUp: function onKeyUp(e) {
              if (e.key === 'Enter' || e.key === 'Escape') {
                _this2.closeVisibilty();
                return;
              }

              if (e.key === 'ArrowDown') {
                if (_this2.itemsRef && _this2.itemsRef.current && _this2.itemsRef.current.firstChild && _this2.itemsRef.current.firstChild.firstChild && _this2.itemsRef.current.firstChild.firstChild.focus) {
                  _this2.itemsRef.current.firstChild.firstChild.focus();
                }
                return;
              }

              var open = _this2.getOpenState();
              if (!open) {
                _this2.handleToggleVisibility();
              }
            }
          }, tabIndexButtonattr),
          _react2.default.createElement(
            'div',
            { ref: this.mainRef, style: styles.triggerInnerWrapper },
            main
          )
        ),
        _react2.default.createElement(
          ItemsWrapper,
          {
            'data-drop-down-items': true,
            isFullWidth: isFullWidth,
            isPopOver: isPopOver,
            style: _extends({}, dynamicStyle, cleanedItemsStyle),
            innerRef: this.itemsRef,
            onClick: this.handleToggleVisibility,
            onKeyUp: function onKeyUp(e) {
              if (e.key === 'Enter' || e.key === 'Escape') {
                _this2.closeVisibilty();
                if (_this2.mainRef && _this2.mainRef.current && _this2.mainRef.current.firstChild && _this2.mainRef.current.firstChild.focus) {
                  _this2.mainRef.current.firstChild.focus();
                }
              }
            }
          },
          isPopOver && _react2.default.createElement(PopOverArrow, { isPopOver: isPopOver, anchor: anchor }),
          children
        )
      );
    }
  }]);

  return DropDown;
}(_react.PureComponent);

DropDown.propTypes = {
  main: _propTypes2.default.node,
  inertMain: _propTypes2.default.bool
};
DropDown.defaultProps = {
  main: null,
  inertMain: false,
  anchor: 'left'
};
exports.default = (0, _reactClickOutside2.default)(DropDown);