'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BackdropStyle = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BackdropStyle = exports.BackdropStyle = {
  root: {
    zIndex: 12,
    width: '100%',
    height: '100%',
    position: 'fixed',
    top: 0,
    left: 0,
    // Remove grey highlight
    // we should keep those outline and have a better solution that remove -df
    // those are super usefull when keyboard navigating and are -df
    // seriously not that bad visually if well done I thinkg -df
    WebkitTapHightLightColor: 'rgba(0,0,0,0)',
    backgroundColor: 'rgba(0,0,0, 0.25)',
    // transition: 'translate(0px, 0px)',
    willChange: 'opacity',
    opacity: '0.25'
  },
  invisible: {
    opacity: 0
  }
};

var Backdrop = function Backdrop(props) {
  var invisible = props.invisible,
      onClick = props.onClick;


  var mergedStyle = invisible ? Object.assign({}, BackdropStyle.root, BackdropStyle.invisible) : BackdropStyle.root;

  return _react2.default.createElement('div', { style: mergedStyle, onClick: onClick, 'aria-hidden': 'true' });
};

Backdrop.dispalyName = 'Backdrop';

Backdrop.propTypes = {
  invisible: _propTypes2.default.bool
};

Backdrop.defaultProps = {
  invisible: false
};

exports.default = Backdrop;