'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Fade = require('./Fade');

var _Fade2 = _interopRequireDefault(_Fade);

var _Backdrop = require('./Backdrop');

var _Backdrop2 = _interopRequireDefault(_Backdrop);

var _Portal = require('./Portal');

var _Portal2 = _interopRequireDefault(_Portal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import keycode from 'keycode';


var styles = exports.styles = {
  root: {},
  hidden: {
    visibility: 'hidden'
  }
};

var Modal = function (_Component) {
  _inherits(Modal, _Component);

  function Modal() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Modal);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Modal.__proto__ || Object.getPrototypeOf(Modal)).call.apply(_ref, [this].concat(args))), _this), _this.handleDocumentKeyUp = function (event) {
      if (event.key !== 'Escape') {
        return;
      }

      var _this$props = _this.props,
          onEscapeKeyUp = _this$props.onEscapeKeyUp,
          onClose = _this$props.onClose,
          ignoreEscapeKeyUp = _this$props.ignoreEscapeKeyUp;


      if (onEscapeKeyUp) {
        onEscapeKeyUp(event);
      }

      if (onClose && !ignoreEscapeKeyUp) {
        onClose(event);
      }
    }, _this.attachGlobalEventHandlers = function () {
      window.addEventListener('keyup', _this.handleDocumentKeyUp);
    }, _this.detachGlobalEventHandlers = function () {
      window.addEventListener('keyup', _this.handleDocumentKeyUp);
    }, _this.handleBackdropClick = function (event) {
      if (event.target !== event.currentTarget) {
        return;
      }

      var _this$props2 = _this.props,
          onBackdropClick = _this$props2.onBackdropClick,
          onClose = _this$props2.onClose,
          ignoreBackdropClick = _this$props2.ignoreBackdropClick;


      if (onBackdropClick) {
        onBackdropClick(event);
      }

      if (onClose && !ignoreBackdropClick) {
        onClose(event);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Modal, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var show = this.props.show;


      if (show) {
        this.attachGlobalEventHandlers();
      } else {
        this.detachGlobalEventHandlers();
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(_ref2) {
      var show = _ref2.show;

      if (show !== this.props.show) {
        if (show) {
          this.attachGlobalEventHandlers();
        } else {
          this.detachGlobalEventHandlers();
        }
      }
    }
  }, {
    key: 'renderBackdrop',
    value: function renderBackdrop() {
      var _props = this.props,
          BackdropComponent = _props.BackdropComponent,
          BackdropInvisible = _props.BackdropInvisible,
          BackdropTransitionDuration = _props.BackdropTransitionDuration,
          show = _props.show;

      return _react2.default.createElement(
        _Fade2.default,
        { appear: true, 'in': show, timeout: BackdropTransitionDuration },
        _react2.default.createElement(BackdropComponent, {
          invisible: BackdropInvisible,
          onClick: this.handleBackdropClick
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          children = _props2.children,
          disableBackdrop = _props2.disableBackdrop,
          show = _props2.show;


      if (!show) {
        return null;
      }

      return _react2.default.createElement(
        _Portal2.default,
        { open: true },
        _react2.default.createElement(
          'div',
          {
            style: styles.root,
            ref: function ref(node) {
              _this2.modal = node;
            }
          },
          _react2.default.createElement(
            'div',
            { className: 'modalContent' },
            children
          ),
          !disableBackdrop && show && this.renderBackdrop()
        )
      );
    }
  }]);

  return Modal;
}(_react.Component);

Modal.propTypes = {
  BackdropComponent: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
  BackdropInvisible: _propTypes2.default.bool,
  BackdropTransitionDuration: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.shape({ enter: _propTypes2.default.number, exit: _propTypes2.default.number })]),
  disableBackdrop: _propTypes2.default.bool,
  ignoreBackdropClick: _propTypes2.default.bool,
  ignoreEscapeKeyUp: _propTypes2.default.bool,
  onBackdropClick: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onEscapeKeyUp: _propTypes2.default.func,
  show: _propTypes2.default.bool.isRequired
};

Modal.defaultProps = {
  show: false,
  BackdropComponent: _Backdrop2.default,
  BackdropInvisible: false,
  BackdropTransitionDuration: 300,
  disableBackdrop: false,
  ignoreBackdropClick: false,
  ignoreEscapeKeyUp: false,
  onBackdropClick: function onBackdropClick() {},
  onClose: function onClose() {},
  onEscapeKeyUp: function onEscapeKeyUp() {}
};

exports.default = Modal;