'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WithBoundingRect = function (_Component) {
  _inherits(WithBoundingRect, _Component);

  function WithBoundingRect(props) {
    _classCallCheck(this, WithBoundingRect);

    var _this = _possibleConstructorReturn(this, (WithBoundingRect.__proto__ || Object.getPrototypeOf(WithBoundingRect)).call(this, props));

    _this.ref = null;

    _this.state = {
      scrollOffset: 0,
      rect: {
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
        height: 0,
        width: 0
      }
    };

    _this.update = _this.update.bind(_this);
    _this.storeRef = _this.storeRef.bind(_this);
    _this.findScrollingContextRef = _this.findScrollingContextRef.bind(_this);
    return _this;
  }

  _createClass(WithBoundingRect, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.update();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.scrollingContextRef = null;

      window.cancelAnimationFrame(this.rafRef);
    }
  }, {
    key: 'findScrollingContextRef',
    value: function findScrollingContextRef() {
      if (!this.scrollingContextRef) {
        this.scrollingContextRef = this.props.mainScrollingElementSelector ? document.querySelector(this.props.mainScrollingElementSelector) : window;
      }
    }
  }, {
    key: 'update',
    value: function update() {
      this.findScrollingContextRef();
      if (this.ref && this.scrollingContextRef) {
        this.setState({
          rect: this.ref.getBoundingClientRect(),
          scrollOffset: this.scrollingContextRef.scrollTop
        });

        this.rafRef = requestAnimationFrame(this.update);
      }
    }
  }, {
    key: 'storeRef',
    value: function storeRef(node) {
      this.ref = node;
      this.update();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { ref: this.storeRef },
        _react2.default.cloneElement(this.props.children, _extends({
          rect: this.state.rect,
          scrollOffset: this.state.scrollOffset
        }, this.props || {}))
      );
    }
  }]);

  return WithBoundingRect;
}(_react.Component);

exports.default = WithBoundingRect;